namespace dnnl {
namespace impl {
namespace gpu {
namespace intel {
namespace ocl {
const char *binary_common_header = R"==(/*******************************************************************************)==""\n"
R"==(* Copyright 2022-2024 Intel Corporation)==""\n"
R"==(*)==""\n"
R"==(* Licensed under the Apache License, Version 2.0 (the "License");)==""\n"
R"==(* you may not use this file except in compliance with the License.)==""\n"
R"==(* You may obtain a copy of the License at)==""\n"
R"==(*)==""\n"
R"==(* http:)==""\n"
R"==(*)==""\n"
R"==(* Unless required by applicable law or agreed to in writing, software)==""\n"
R"==(* distributed under the License is distributed on an "AS IS" BASIS,)==""\n"
R"==(* WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.)==""\n"
R"==(* See the License for the specific language governing permissions and)==""\n"
R"==(* limitations under the License.)==""\n"
R"==(*******************************************************************************/)==""\n"
R"==(#ifndef GPU_INTEL_OCL_BINARY_COMMON_H)==""\n"
R"==(#define GPU_INTEL_OCL_BINARY_COMMON_H)==""\n"
R"==(#include "gpu/intel/ocl/dispatch.h")==""\n"
R"==(#include "gpu/intel/ocl/ocl_post_ops.h")==""\n"
R"==(#include "gpu/intel/ocl/ocl_types.h")==""\n"
R"==(#include "gpu/intel/ocl/ocl_utils.h")==""\n"
R"==(#undef DST_OFF)==""\n"
R"==(#define DST_OFF(x0, x1, x2, x3, x4, x5) OFF_MD(DST, x0, x1, x2, x3, x4, x5))==""\n"
R"==(#define SRC0_OFF(x0, x1, x2, x3, x4, x5) OFF_MD(SRC0, x0, x1, x2, x3, x4, x5))==""\n"
R"==(#define SRC1_OFF(x0, x1, x2, x3, x4, x5) OFF_MD(SRC1, x0, x1, x2, x3, x4, x5))==""\n"
R"==(#if SRC1_DT_BF16)==""\n"
R"==(#define SRC1_TO_FLOAT cvt_bf16_to_f32)==""\n"
R"==(#else)==""\n"
R"==(#define SRC1_TO_FLOAT CONVERT_FLOAT_T)==""\n"
R"==(#endif)==""\n"
R"==(#if SRC0_DT_BF16)==""\n"
R"==(#define SRC0_TO_FLOAT cvt_bf16_to_f32)==""\n"
R"==(#else)==""\n"
R"==(#define SRC0_TO_FLOAT CONVERT_FLOAT_T)==""\n"
R"==(#endif)==""\n"
R"==(#if SRC0_DT_BF8)==""\n"
R"==(#define SRC0_BLOCK_READ(src) \)==""\n"
R"==(as_char(intel_sub_group_block_read_uc((const __global uchar *)(src))))==""\n"
R"==(#define SRC0_BLOCK_READ2(src) \)==""\n"
R"==(as_char2(intel_sub_group_block_read_uc2((const __global uchar *)(src))))==""\n"
R"==(#define SRC0_BLOCK_READ4(src) \)==""\n"
R"==(as_char4(intel_sub_group_block_read_uc4((const __global uchar *)(src))))==""\n"
R"==(#define SRC0_BLOCK_READ8(src) \)==""\n"
R"==(as_char8(intel_sub_group_block_read_uc8((const __global uchar *)(src))))==""\n"
R"==(#endif )==""\n"
R"==(#if SRC1_DT_BF8)==""\n"
R"==(#define SRC1_BLOCK_READ(src) \)==""\n"
R"==(as_char(intel_sub_group_block_read_uc((const __global uchar *)(src))))==""\n"
R"==(#define SRC1_BLOCK_READ2(src) \)==""\n"
R"==(as_char2(intel_sub_group_block_read_uc2((const __global uchar *)(src))))==""\n"
R"==(#define SRC1_BLOCK_READ4(src) \)==""\n"
R"==(as_char4(intel_sub_group_block_read_uc4((const __global uchar *)(src))))==""\n"
R"==(#define SRC1_BLOCK_READ8(src) \)==""\n"
R"==(as_char8(intel_sub_group_block_read_uc8((const __global uchar *)(src))))==""\n"
R"==(#endif )==""\n"
R"==(#if SRC0_DT_HF8)==""\n"
R"==(#define SRC0_BLOCK_READ(src) \)==""\n"
R"==(as_char(intel_sub_group_block_read_uc((const __global uchar *)(src))))==""\n"
R"==(#define SRC0_BLOCK_READ2(src) \)==""\n"
R"==(as_char2(intel_sub_group_block_read_uc2((const __global uchar *)(src))))==""\n"
R"==(#define SRC0_BLOCK_READ4(src) \)==""\n"
R"==(as_char4(intel_sub_group_block_read_uc4((const __global uchar *)(src))))==""\n"
R"==(#define SRC0_BLOCK_READ8(src) \)==""\n"
R"==(as_char8(intel_sub_group_block_read_uc8((const __global uchar *)(src))))==""\n"
R"==(#endif )==""\n"
R"==(#if SRC1_DT_HF8)==""\n"
R"==(#define SRC1_BLOCK_READ(src) \)==""\n"
R"==(as_char(intel_sub_group_block_read_uc((const __global uchar *)(src))))==""\n"
R"==(#define SRC1_BLOCK_READ2(src) \)==""\n"
R"==(as_char2(intel_sub_group_block_read_uc2((const __global uchar *)(src))))==""\n"
R"==(#define SRC1_BLOCK_READ4(src) \)==""\n"
R"==(as_char4(intel_sub_group_block_read_uc4((const __global uchar *)(src))))==""\n"
R"==(#define SRC1_BLOCK_READ8(src) \)==""\n"
R"==(as_char8(intel_sub_group_block_read_uc8((const __global uchar *)(src))))==""\n"
R"==(#endif )==""\n"
R"==(#if SRC0_DT_S8)==""\n"
R"==(#define SRC0_BLOCK_READ(src) \)==""\n"
R"==(as_char(intel_sub_group_block_read_uc((const __global uchar *)(src))))==""\n"
R"==(#define SRC0_BLOCK_READ2(src) \)==""\n"
R"==(as_char2(intel_sub_group_block_read_uc2((const __global uchar *)(src))))==""\n"
R"==(#define SRC0_BLOCK_READ4(src) \)==""\n"
R"==(as_char4(intel_sub_group_block_read_uc4((const __global uchar *)(src))))==""\n"
R"==(#define SRC0_BLOCK_READ8(src) \)==""\n"
R"==(as_char8(intel_sub_group_block_read_uc8((const __global uchar *)(src))))==""\n"
R"==(#endif )==""\n"
R"==(#if SRC1_DT_S8)==""\n"
R"==(#define SRC1_BLOCK_READ(src) \)==""\n"
R"==(as_char(intel_sub_group_block_read_uc((const __global uchar *)(src))))==""\n"
R"==(#define SRC1_BLOCK_READ2(src) \)==""\n"
R"==(as_char2(intel_sub_group_block_read_uc2((const __global uchar *)(src))))==""\n"
R"==(#define SRC1_BLOCK_READ4(src) \)==""\n"
R"==(as_char4(intel_sub_group_block_read_uc4((const __global uchar *)(src))))==""\n"
R"==(#define SRC1_BLOCK_READ8(src) \)==""\n"
R"==(as_char8(intel_sub_group_block_read_uc8((const __global uchar *)(src))))==""\n"
R"==(#endif )==""\n"
R"==(#if SRC0_DT_U8)==""\n"
R"==(#define SRC0_BLOCK_READ(src) \)==""\n"
R"==(as_uchar(intel_sub_group_block_read_uc((const __global uchar *)(src))))==""\n"
R"==(#define SRC0_BLOCK_READ2(src) \)==""\n"
R"==(as_uchar2(intel_sub_group_block_read_uc2((const __global uchar *)(src))))==""\n"
R"==(#define SRC0_BLOCK_READ4(src) \)==""\n"
R"==(as_uchar4(intel_sub_group_block_read_uc4((const __global uchar *)(src))))==""\n"
R"==(#define SRC0_BLOCK_READ8(src) \)==""\n"
R"==(as_uchar8(intel_sub_group_block_read_uc8((const __global uchar *)(src))))==""\n"
R"==(#endif )==""\n"
R"==(#if SRC1_DT_U8)==""\n"
R"==(#define SRC1_BLOCK_READ(src) \)==""\n"
R"==(as_uchar(intel_sub_group_block_read_uc((const __global uchar *)(src))))==""\n"
R"==(#define SRC1_BLOCK_READ2(src) \)==""\n"
R"==(as_uchar2(intel_sub_group_block_read_uc2((const __global uchar *)(src))))==""\n"
R"==(#define SRC1_BLOCK_READ4(src) \)==""\n"
R"==(as_uchar4(intel_sub_group_block_read_uc4((const __global uchar *)(src))))==""\n"
R"==(#define SRC1_BLOCK_READ8(src) \)==""\n"
R"==(as_uchar8(intel_sub_group_block_read_uc8((const __global uchar *)(src))))==""\n"
R"==(#endif )==""\n"
R"==(#if SRC0_DT_F16)==""\n"
R"==(#define SRC0_BLOCK_READ(src) \)==""\n"
R"==(as_half(intel_sub_group_block_read_us((const __global ushort *)(src))))==""\n"
R"==(#define SRC0_BLOCK_READ2(src) \)==""\n"
R"==(as_half2(intel_sub_group_block_read_us2((const __global ushort *)(src))))==""\n"
R"==(#define SRC0_BLOCK_READ4(src) \)==""\n"
R"==(as_half4(intel_sub_group_block_read_us4((const __global ushort *)(src))))==""\n"
R"==(#define SRC0_BLOCK_READ8(src) \)==""\n"
R"==(as_half8(intel_sub_group_block_read_us8((const __global ushort *)(src))))==""\n"
R"==(#endif )==""\n"
R"==(#if SRC1_DT_F16)==""\n"
R"==(#define SRC1_BLOCK_READ(src) \)==""\n"
R"==(as_half(intel_sub_group_block_read_us((const __global ushort *)(src))))==""\n"
R"==(#define SRC1_BLOCK_READ2(src) \)==""\n"
R"==(as_half2(intel_sub_group_block_read_us2((const __global ushort *)(src))))==""\n"
R"==(#define SRC1_BLOCK_READ4(src) \)==""\n"
R"==(as_half4(intel_sub_group_block_read_us4((const __global ushort *)(src))))==""\n"
R"==(#define SRC1_BLOCK_READ8(src) \)==""\n"
R"==(as_half8(intel_sub_group_block_read_us8((const __global ushort *)(src))))==""\n"
R"==(#endif )==""\n"
R"==(#if SRC0_DT_S32)==""\n"
R"==(#define SRC0_BLOCK_READ(src) \)==""\n"
R"==(as_int(intel_sub_group_block_read((const __global uint *)(src))))==""\n"
R"==(#define SRC0_BLOCK_READ2(src) \)==""\n"
R"==(as_int2(intel_sub_group_block_read2((const __global uint *)(src))))==""\n"
R"==(#define SRC0_BLOCK_READ4(src) \)==""\n"
R"==(as_int4(intel_sub_group_block_read4((const __global uint *)(src))))==""\n"
R"==(#define SRC0_BLOCK_READ8(src) \)==""\n"
R"==(as_int8(intel_sub_group_block_read8((const __global uint *)(src))))==""\n"
R"==(#endif )==""\n"
R"==(#if SRC1_DT_S32)==""\n"
R"==(#define SRC1_BLOCK_READ(src) \)==""\n"
R"==(as_int(intel_sub_group_block_read((const __global uint *)(src))))==""\n"
R"==(#define SRC1_BLOCK_READ2(src) \)==""\n"
R"==(as_int2(intel_sub_group_block_read2((const __global uint *)(src))))==""\n"
R"==(#define SRC1_BLOCK_READ4(src) \)==""\n"
R"==(as_int4(intel_sub_group_block_read4((const __global uint *)(src))))==""\n"
R"==(#define SRC1_BLOCK_READ8(src) \)==""\n"
R"==(as_int8(intel_sub_group_block_read8((const __global uint *)(src))))==""\n"
R"==(#endif )==""\n"
R"==(#if SRC0_DT_F32)==""\n"
R"==(#define SRC0_BLOCK_READ(src) \)==""\n"
R"==(as_float(intel_sub_group_block_read((const __global uint *)(src))))==""\n"
R"==(#define SRC0_BLOCK_READ2(src) \)==""\n"
R"==(as_float2(intel_sub_group_block_read2((const __global uint *)(src))))==""\n"
R"==(#define SRC0_BLOCK_READ4(src) \)==""\n"
R"==(as_float4(intel_sub_group_block_read4((const __global uint *)(src))))==""\n"
R"==(#define SRC0_BLOCK_READ8(src) \)==""\n"
R"==(as_float8(intel_sub_group_block_read8((const __global uint *)(src))))==""\n"
R"==(#endif )==""\n"
R"==(#if SRC1_DT_F32)==""\n"
R"==(#define SRC1_BLOCK_READ(src) \)==""\n"
R"==(as_float(intel_sub_group_block_read((const __global uint *)(src))))==""\n"
R"==(#define SRC1_BLOCK_READ2(src) \)==""\n"
R"==(as_float2(intel_sub_group_block_read2((const __global uint *)(src))))==""\n"
R"==(#define SRC1_BLOCK_READ4(src) \)==""\n"
R"==(as_float4(intel_sub_group_block_read4((const __global uint *)(src))))==""\n"
R"==(#define SRC1_BLOCK_READ8(src) \)==""\n"
R"==(as_float8(intel_sub_group_block_read8((const __global uint *)(src))))==""\n"
R"==(#endif )==""\n"
R"==(#if SRC0_DT_BF16)==""\n"
R"==(#define SRC0_BLOCK_READ(src) \)==""\n"
R"==(as_ushort(intel_sub_group_block_read_us((const __global ushort *)(src))))==""\n"
R"==(#define SRC0_BLOCK_READ2(src) \)==""\n"
R"==(as_ushort2(intel_sub_group_block_read_us2((const __global ushort *)(src))))==""\n"
R"==(#define SRC0_BLOCK_READ4(src) \)==""\n"
R"==(as_ushort4(intel_sub_group_block_read_us4((const __global ushort *)(src))))==""\n"
R"==(#define SRC0_BLOCK_READ8(src) \)==""\n"
R"==(as_ushort8(intel_sub_group_block_read_us8((const __global ushort *)(src))))==""\n"
R"==(#endif )==""\n"
R"==(#if SRC1_DT_BF16)==""\n"
R"==(#define SRC1_BLOCK_READ(src) \)==""\n"
R"==(as_ushort(intel_sub_group_block_read_us((const __global ushort *)(src))))==""\n"
R"==(#define SRC1_BLOCK_READ2(src) \)==""\n"
R"==(as_ushort2(intel_sub_group_block_read_us2((const __global ushort *)(src))))==""\n"
R"==(#define SRC1_BLOCK_READ4(src) \)==""\n"
R"==(as_ushort4(intel_sub_group_block_read_us4((const __global ushort *)(src))))==""\n"
R"==(#define SRC1_BLOCK_READ8(src) \)==""\n"
R"==(as_ushort8(intel_sub_group_block_read_us8((const __global ushort *)(src))))==""\n"
R"==(#endif )==""\n"
R"==(#if DST_DT_BF8 || DST_DT_HF8)==""\n"
R"==(#define DST_BLOCK_READ(src) \)==""\n"
R"==(as_char(intel_sub_group_block_read_uc((const __global uchar *)(src))))==""\n"
R"==(#define DST_BLOCK_READ2(src) \)==""\n"
R"==(as_char2(intel_sub_group_block_read_uc2((const __global uchar *)(src))))==""\n"
R"==(#define DST_BLOCK_READ4(src) \)==""\n"
R"==(as_char4(intel_sub_group_block_read_uc4((const __global uchar *)(src))))==""\n"
R"==(#define DST_BLOCK_READ8(src) \)==""\n"
R"==(as_char8(intel_sub_group_block_read_uc8((const __global uchar *)(src))))==""\n"
R"==(#define DST_BLOCK_WRITE(dst, val) \)==""\n"
R"==(intel_sub_group_block_write_uc((__global uchar *)(dst), as_uchar(val)))==""\n"
R"==(#define DST_BLOCK_WRITE2(dst, val) \)==""\n"
R"==(intel_sub_group_block_write_uc2((__global uchar *)(dst), as_uchar2(val)))==""\n"
R"==(#define DST_BLOCK_WRITE4(dst, val) \)==""\n"
R"==(intel_sub_group_block_write_uc4((__global uchar *)(dst), as_uchar4(val)))==""\n"
R"==(#define DST_BLOCK_WRITE8(dst, val) \)==""\n"
R"==(intel_sub_group_block_write_uc8((__global uchar *)(dst), as_uchar8(val)))==""\n"
R"==(#endif )==""\n"
R"==(#if DST_DT_S8)==""\n"
R"==(#define DST_BLOCK_READ(src) \)==""\n"
R"==(as_char(intel_sub_group_block_read_uc((const __global uchar *)(src))))==""\n"
R"==(#define DST_BLOCK_READ2(src) \)==""\n"
R"==(as_char2(intel_sub_group_block_read_uc2((const __global uchar *)(src))))==""\n"
R"==(#define DST_BLOCK_READ4(src) \)==""\n"
R"==(as_char4(intel_sub_group_block_read_uc4((const __global uchar *)(src))))==""\n"
R"==(#define DST_BLOCK_READ8(src) \)==""\n"
R"==(as_char8(intel_sub_group_block_read_uc8((const __global uchar *)(src))))==""\n"
R"==(#define DST_BLOCK_WRITE(dst, val) \)==""\n"
R"==(intel_sub_group_block_write_uc((__global uchar *)(dst), as_uchar(val)))==""\n"
R"==(#define DST_BLOCK_WRITE2(dst, val) \)==""\n"
R"==(intel_sub_group_block_write_uc2((__global uchar *)(dst), as_uchar2(val)))==""\n"
R"==(#define DST_BLOCK_WRITE4(dst, val) \)==""\n"
R"==(intel_sub_group_block_write_uc4((__global uchar *)(dst), as_uchar4(val)))==""\n"
R"==(#define DST_BLOCK_WRITE8(dst, val) \)==""\n"
R"==(intel_sub_group_block_write_uc8((__global uchar *)(dst), as_uchar8(val)))==""\n"
R"==(#endif )==""\n"
R"==(#if DST_DT_U8)==""\n"
R"==(#define DST_BLOCK_READ(src) \)==""\n"
R"==(as_uchar(intel_sub_group_block_read_uc((const __global uchar *)(src))))==""\n"
R"==(#define DST_BLOCK_READ2(src) \)==""\n"
R"==(as_uchar2(intel_sub_group_block_read_uc2((const __global uchar *)(src))))==""\n"
R"==(#define DST_BLOCK_READ4(src) \)==""\n"
R"==(as_uchar4(intel_sub_group_block_read_uc4((const __global uchar *)(src))))==""\n"
R"==(#define DST_BLOCK_READ8(src) \)==""\n"
R"==(as_uchar8(intel_sub_group_block_read_uc8((const __global uchar *)(src))))==""\n"
R"==(#define DST_BLOCK_WRITE(dst, val) \)==""\n"
R"==(intel_sub_group_block_write_uc((__global uchar *)(dst), as_uchar(val)))==""\n"
R"==(#define DST_BLOCK_WRITE2(dst, val) \)==""\n"
R"==(intel_sub_group_block_write_uc2((__global uchar *)(dst), as_uchar2(val)))==""\n"
R"==(#define DST_BLOCK_WRITE4(dst, val) \)==""\n"
R"==(intel_sub_group_block_write_uc4((__global uchar *)(dst), as_uchar4(val)))==""\n"
R"==(#define DST_BLOCK_WRITE8(dst, val) \)==""\n"
R"==(intel_sub_group_block_write_uc8((__global uchar *)(dst), as_uchar8(val)))==""\n"
R"==(#endif )==""\n"
R"==(#if DST_DT_F16)==""\n"
R"==(#define DST_BLOCK_READ(src) \)==""\n"
R"==(as_half(intel_sub_group_block_read_us((const __global ushort *)(src))))==""\n"
R"==(#define DST_BLOCK_READ2(src) \)==""\n"
R"==(as_half2(intel_sub_group_block_read_us2((const __global ushort *)(src))))==""\n"
R"==(#define DST_BLOCK_READ4(src) \)==""\n"
R"==(as_half4(intel_sub_group_block_read_us4((const __global ushort *)(src))))==""\n"
R"==(#define DST_BLOCK_READ8(src) \)==""\n"
R"==(as_half8(intel_sub_group_block_read_us8((const __global ushort *)(src))))==""\n"
R"==(#define DST_BLOCK_WRITE(dst, val) \)==""\n"
R"==(intel_sub_group_block_write_us((__global ushort *)(dst), as_ushort(val)))==""\n"
R"==(#define DST_BLOCK_WRITE2(dst, val) \)==""\n"
R"==(intel_sub_group_block_write_us2((__global ushort *)(dst), as_ushort2(val)))==""\n"
R"==(#define DST_BLOCK_WRITE4(dst, val) \)==""\n"
R"==(intel_sub_group_block_write_us4((__global ushort *)(dst), as_ushort4(val)))==""\n"
R"==(#define DST_BLOCK_WRITE8(dst, val) \)==""\n"
R"==(intel_sub_group_block_write_us8((__global ushort *)(dst), as_ushort8(val)))==""\n"
R"==(#endif )==""\n"
R"==(#if DST_DT_S32)==""\n"
R"==(#define DST_BLOCK_READ(src) \)==""\n"
R"==(as_int(intel_sub_group_block_read((const __global uint *)(src))))==""\n"
R"==(#define DST_BLOCK_READ2(src) \)==""\n"
R"==(as_int2(intel_sub_group_block_read2((const __global uint *)(src))))==""\n"
R"==(#define DST_BLOCK_READ4(src) \)==""\n"
R"==(as_int4(intel_sub_group_block_read4((const __global uint *)(src))))==""\n"
R"==(#define DST_BLOCK_READ8(src) \)==""\n"
R"==(as_int8(intel_sub_group_block_read8((const __global uint *)(src))))==""\n"
R"==(#define DST_BLOCK_WRITE(dst, val) \)==""\n"
R"==(intel_sub_group_block_write((__global uint *)(dst), as_uint(val)))==""\n"
R"==(#define DST_BLOCK_WRITE2(dst, val) \)==""\n"
R"==(intel_sub_group_block_write2((__global uint *)(dst), as_uint2(val)))==""\n"
R"==(#define DST_BLOCK_WRITE4(dst, val) \)==""\n"
R"==(intel_sub_group_block_write4((__global uint *)(dst), as_uint4(val)))==""\n"
R"==(#define DST_BLOCK_WRITE8(dst, val) \)==""\n"
R"==(intel_sub_group_block_write8((__global uint *)(dst), as_uint8(val)))==""\n"
R"==(#endif )==""\n"
R"==(#if DST_DT_F32)==""\n"
R"==(#define DST_BLOCK_READ(src) \)==""\n"
R"==(as_float(intel_sub_group_block_read((const __global uint *)(src))))==""\n"
R"==(#define DST_BLOCK_READ2(src) \)==""\n"
R"==(as_float2(intel_sub_group_block_read2((const __global uint *)(src))))==""\n"
R"==(#define DST_BLOCK_READ4(src) \)==""\n"
R"==(as_float4(intel_sub_group_block_read4((const __global uint *)(src))))==""\n"
R"==(#define DST_BLOCK_READ8(src) \)==""\n"
R"==(as_float8(intel_sub_group_block_read8((const __global uint *)(src))))==""\n"
R"==(#define DST_BLOCK_WRITE(dst, val) \)==""\n"
R"==(intel_sub_group_block_write((__global uint *)(dst), as_uint(val)))==""\n"
R"==(#define DST_BLOCK_WRITE2(dst, val) \)==""\n"
R"==(intel_sub_group_block_write2((__global uint *)(dst), as_uint2(val)))==""\n"
R"==(#define DST_BLOCK_WRITE4(dst, val) \)==""\n"
R"==(intel_sub_group_block_write4((__global uint *)(dst), as_uint4(val)))==""\n"
R"==(#define DST_BLOCK_WRITE8(dst, val) \)==""\n"
R"==(intel_sub_group_block_write8((__global uint *)(dst), as_uint8(val)))==""\n"
R"==(#endif )==""\n"
R"==(#if DST_DT_BF16)==""\n"
R"==(#define DST_BLOCK_READ(src) \)==""\n"
R"==(as_ushort(intel_sub_group_block_read_us((const __global ushort *)(src))))==""\n"
R"==(#define DST_BLOCK_READ2(src) \)==""\n"
R"==(as_ushort2(intel_sub_group_block_read_us2((const __global ushort *)(src))))==""\n"
R"==(#define DST_BLOCK_READ4(src) \)==""\n"
R"==(as_ushort4(intel_sub_group_block_read_us4((const __global ushort *)(src))))==""\n"
R"==(#define DST_BLOCK_READ8(src) \)==""\n"
R"==(as_ushort8(intel_sub_group_block_read_us8((const __global ushort *)(src))))==""\n"
R"==(#define DST_BLOCK_WRITE(dst, val) \)==""\n"
R"==(intel_sub_group_block_write_us((__global ushort *)(dst), as_ushort(val)))==""\n"
R"==(#define DST_BLOCK_WRITE2(dst, val) \)==""\n"
R"==(intel_sub_group_block_write_us2((__global ushort *)(dst), as_ushort2(val)))==""\n"
R"==(#define DST_BLOCK_WRITE4(dst, val) \)==""\n"
R"==(intel_sub_group_block_write_us4((__global ushort *)(dst), as_ushort4(val)))==""\n"
R"==(#define DST_BLOCK_WRITE8(dst, val) \)==""\n"
R"==(intel_sub_group_block_write_us8((__global ushort *)(dst), as_ushort8(val)))==""\n"
R"==(#endif )==""\n"
R"==(#if NVECT == 1 || IS_PLAIN_LAYOUT)==""\n"
R"==(#define ELEM_DATA_T float)==""\n"
R"==(#elif NVECT == 2)==""\n"
R"==(#define ELEM_DATA_T float2)==""\n"
R"==(#elif NVECT == 4)==""\n"
R"==(#define ELEM_DATA_T float4)==""\n"
R"==(#elif NVECT == 8)==""\n"
R"==(#define ELEM_DATA_T float8)==""\n"
R"==(#endif)==""\n"
R"==(#define DEF_binary_op(dt, special_dt) \)==""\n"
R"==(dt __attribute__((overloadable)) binary_op(int alg, dt src0, dt src1) { \)==""\n"
R"==(switch (alg) { \)==""\n"
R"==(case (BINARY_ADD): return src0 + src1; \)==""\n"
R"==(case (BINARY_MUL): return src0 * src1; \)==""\n"
R"==(case (BINARY_MAX): return max(src0, src1); \)==""\n"
R"==(case (BINARY_MIN): return min(src0, src1); \)==""\n"
R"==(case (BINARY_DIV): return src0 / src1; \)==""\n"
R"==(case (BINARY_SUB): return src0 - src1; \)==""\n"
R"==(case (BINARY_GE): \)==""\n"
R"==(return (src0 >= src1) ? SPECIAL(special_dt, one) \)==""\n"
R"==(: SPECIAL(special_dt, zero); \)==""\n"
R"==(case (BINARY_GT): \)==""\n"
R"==(return (src0 > src1) ? SPECIAL(special_dt, one) \)==""\n"
R"==(: SPECIAL(special_dt, zero); \)==""\n"
R"==(case (BINARY_LE): \)==""\n"
R"==(return (src0 <= src1) ? SPECIAL(special_dt, one) \)==""\n"
R"==(: SPECIAL(special_dt, zero); \)==""\n"
R"==(case (BINARY_LT): \)==""\n"
R"==(return (src0 < src1) ? SPECIAL(special_dt, one) \)==""\n"
R"==(: SPECIAL(special_dt, zero); \)==""\n"
R"==(case (BINARY_EQ): \)==""\n"
R"==(return (src0 == src1) ? SPECIAL(special_dt, one) \)==""\n"
R"==(: SPECIAL(special_dt, zero); \)==""\n"
R"==(case (BINARY_NE): \)==""\n"
R"==(return (src0 != src1) ? SPECIAL(special_dt, one) \)==""\n"
R"==(: SPECIAL(special_dt, zero); \)==""\n"
R"==(} \)==""\n"
R"==(DEBUG_PRINT("Invalid binary op: %d\n", alg); \)==""\n"
R"==(return SPECIAL(special_dt, max); \)==""\n"
R"==(})==""\n"
R"==(DEF_binary_op(float, float);)==""\n"
R"==(DEF_binary_op(float2, float);)==""\n"
R"==(DEF_binary_op(float4, float);)==""\n"
R"==(DEF_binary_op(float8, float);)==""\n"
R"==(#undef DEF_binary_op)==""\n"
R"==(#define READ_DATA(size, name, source_ptr, dest_ptr, scale) \)==""\n"
R"==({ \)==""\n"
R"==(unsigned offset = 0; \)==""\n"
R"==(unroll_for(unsigned j8 = 0; j8 < size / 8; ++j8) { \)==""\n"
R"==(*((float8 *)(dest_ptr + offset)) = scale \)==""\n"
R"==(* CONVERT_FLOAT8_T(CONCAT2(name, _BLOCK_READ8)( \)==""\n"
R"==((source_ptr + offset * SUB_GROUP_SIZE))); \)==""\n"
R"==(offset += 8; \)==""\n"
R"==(} \)==""\n"
R"==(if ((size % 8) / 4) { \)==""\n"
R"==(*((float4 *)(dest_ptr + offset)) = scale \)==""\n"
R"==(* CONVERT_FLOAT4_T(CONCAT2(name, _BLOCK_READ4)( \)==""\n"
R"==((source_ptr + offset * SUB_GROUP_SIZE))); \)==""\n"
R"==(offset += 4; \)==""\n"
R"==(} \)==""\n"
R"==(if ((size % 4) / 2) { \)==""\n"
R"==(*((float2 *)(dest_ptr + offset)) = scale \)==""\n"
R"==(* CONVERT_FLOAT2_T(CONCAT2(name, _BLOCK_READ2)( \)==""\n"
R"==((source_ptr + offset * SUB_GROUP_SIZE))); \)==""\n"
R"==(offset += 2; \)==""\n"
R"==(} \)==""\n"
R"==(if ((size % 2)) { \)==""\n"
R"==(*((float *)(dest_ptr + offset)) = scale \)==""\n"
R"==(* CONVERT_FLOAT_T(CONCAT2(name, _BLOCK_READ)( \)==""\n"
R"==((source_ptr + offset * SUB_GROUP_SIZE))); \)==""\n"
R"==(} \)==""\n"
R"==(})==""\n"
R"==(#define WRITE_DATA(size, name, source_ptr, dest_ptr) \)==""\n"
R"==({ \)==""\n"
R"==(unsigned offset = 0; \)==""\n"
R"==(unroll_for(unsigned j8 = 0; j8 < size / 8; ++j8) { \)==""\n"
R"==(CONCAT2(name, _BLOCK_WRITE8) \)==""\n"
R"==(((dest_ptr + offset * SUB_GROUP_SIZE), \)==""\n"
R"==(TO_DST8(*((float8 *)(source_ptr + offset)))); \)==""\n"
R"==(offset += 8; \)==""\n"
R"==(} \)==""\n"
R"==(if ((size % 8) / 4) { \)==""\n"
R"==(CONCAT2(name, _BLOCK_WRITE4) \)==""\n"
R"==(((dest_ptr + offset * SUB_GROUP_SIZE), \)==""\n"
R"==(TO_DST4(*((float4 *)(source_ptr + offset)))); \)==""\n"
R"==(offset += 4; \)==""\n"
R"==(} \)==""\n"
R"==(if ((size % 4) / 2) { \)==""\n"
R"==(CONCAT2(name, _BLOCK_WRITE2) \)==""\n"
R"==(((dest_ptr + offset * SUB_GROUP_SIZE), \)==""\n"
R"==(TO_DST2(*((float2 *)(source_ptr + offset)))); \)==""\n"
R"==(offset += 2; \)==""\n"
R"==(} \)==""\n"
R"==(if ((size % 2)) { \)==""\n"
R"==(CONCAT2(name, _BLOCK_WRITE) \)==""\n"
R"==(((dest_ptr + offset * SUB_GROUP_SIZE), \)==""\n"
R"==(TO_DST(*((float *)(source_ptr + offset)))); \)==""\n"
R"==(} \)==""\n"
R"==(})==""\n"
R"==(#endif)==""\n"
R"==()==";
}
}
}
}
}