namespace dnnl {
namespace impl {
namespace gpu {
namespace intel {
namespace ocl {
const char *gemm_with_post_ops_kernel = R"==(/*******************************************************************************)==""\n"
R"==(* Copyright 2021-2024 Intel Corporation)==""\n"
R"==(*)==""\n"
R"==(* Licensed under the Apache License, Version 2.0 (the "License");)==""\n"
R"==(* you may not use this file except in compliance with the License.)==""\n"
R"==(* You may obtain a copy of the License at)==""\n"
R"==(*)==""\n"
R"==(* http:)==""\n"
R"==(*)==""\n"
R"==(* Unless required by applicable law or agreed to in writing, software)==""\n"
R"==(* distributed under the License is distributed on an "AS IS" BASIS,)==""\n"
R"==(* WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.)==""\n"
R"==(* See the License for the specific language governing permissions and)==""\n"
R"==(* limitations under the License.)==""\n"
R"==(*******************************************************************************/)==""\n"
R"==(#include "gpu/intel/ocl/dispatch.h")==""\n"
R"==(#include "gpu/intel/ocl/ocl_math_utils.h")==""\n"
R"==(#include "gpu/intel/ocl/ocl_post_ops.h")==""\n"
R"==(#include "gpu/intel/ocl/ocl_types.h")==""\n"
R"==(#if defined(DST_DT_BF16))==""\n"
R"==(#define DST_TO_ACC(x) cvt_bf16_to_f32(x))==""\n"
R"==(#elif defined(DST_DT_BF8))==""\n"
R"==(#define DST_TO_ACC(x) convert_float(cvt_f8_e5m2_to_hf(x)))==""\n"
R"==(#elif defined(DST_DT_HF8))==""\n"
R"==(#define DST_TO_ACC(x) convert_float(cvt_f8_e4m3_to_hf(x)))==""\n"
R"==(#else)==""\n"
R"==(#define DST_TO_ACC(x) (x))==""\n"
R"==(#endif)==""\n"
R"==(#if defined(BIA_DT_BF16))==""\n"
R"==(#define BIA_TO_ACC(x) cvt_bf16_to_f32(x))==""\n"
R"==(#elif defined(BIA_DT_BF8))==""\n"
R"==(#define BIA_TO_ACC(x) convert_float(cvt_f8_e5m2_to_hf(x)))==""\n"
R"==(#elif defined(BIA_DT_HF8))==""\n"
R"==(#define BIA_TO_ACC(x) convert_float(cvt_f8_e4m3_to_hf(x)))==""\n"
R"==(#else)==""\n"
R"==(#define BIA_TO_ACC(x) (x))==""\n"
R"==(#endif)==""\n"
R"==(#if defined(SRC_DT_BF16))==""\n"
R"==(#define SRC_TO_ACC(x) cvt_bf16_to_f32(x))==""\n"
R"==(#elif defined(SRC_DT_BF8))==""\n"
R"==(#define SRC_TO_ACC(x) convert_float(cvt_f8_e5m2_to_hf(x)))==""\n"
R"==(#elif defined(SRC_DT_HF8))==""\n"
R"==(#define SRC_TO_ACC(x) convert_float(cvt_f8_e4m3_to_hf(x)))==""\n"
R"==(#else)==""\n"
R"==(#define SRC_TO_ACC(x) (x))==""\n"
R"==(#endif)==""\n"
R"==(#ifndef BIA_D2)==""\n"
R"==(#define BIA_D2 1)==""\n"
R"==(#endif)==""\n"
R"==(#ifndef BIA_D3)==""\n"
R"==(#define BIA_D3 1)==""\n"
R"==(#endif)==""\n"
R"==(#if BIA_NDIMS == 4)==""\n"
R"==(#define BIA_OFF(x0, x1, d, h, w) \)==""\n"
R"==((((x0 % BIA_D0) % BIA_B0) * BIA_SB0 + ((x0 % BIA_D0) / BIA_B0) * BIA_S0 \)==""\n"
R"==(+ ((x1 % BIA_D1) % BIA_B1) * BIA_SB1 \)==""\n"
R"==(+ ((x1 % BIA_D1) / BIA_B1) * BIA_S1 \)==""\n"
R"==(+ ((h % BIA_D2) % BIA_B2) * BIA_SB2 \)==""\n"
R"==(+ ((h % BIA_D2) / BIA_B2) * BIA_S2 \)==""\n"
R"==(+ ((w % BIA_D3) % BIA_B3) * BIA_SB3 \)==""\n"
R"==(+ ((w % BIA_D3) / BIA_B3) * BIA_S3))==""\n"
R"==(#elif BIA_NDIMS == 3)==""\n"
R"==(#define BIA_OFF(x0, x1, d, h, w) \)==""\n"
R"==((((x0 % BIA_D0) % BIA_B0) * BIA_SB0 + ((x0 % BIA_D0) / BIA_B0) * BIA_S0 \)==""\n"
R"==(+ ((x1 % BIA_D1) % BIA_B1) * BIA_SB1 \)==""\n"
R"==(+ ((x1 % BIA_D1) / BIA_B1) * BIA_S1 \)==""\n"
R"==(+ ((w % BIA_D2) % BIA_B2) * BIA_SB2 \)==""\n"
R"==(+ ((w % BIA_D2) / BIA_B2) * BIA_S2))==""\n"
R"==(#elif BIA_NDIMS == 2)==""\n"
R"==(#define BIA_OFF(x0, x1, d, h, w) \)==""\n"
R"==((((x0 % BIA_D0) % BIA_B0) * BIA_SB0 + ((x0 % BIA_D0) / BIA_B0) * BIA_S0 \)==""\n"
R"==(+ ((x1 % BIA_D1) % BIA_B1) * BIA_SB1 \)==""\n"
R"==(+ ((x1 % BIA_D1) / BIA_B1) * BIA_S1))==""\n"
R"==(#elif BIA_NDIMS == 1)==""\n"
R"==(#define BIA_OFF(x1, x0, d, h, w) (x0))==""\n"
R"==(#endif)==""\n"
R"==(__kernel void gemm_post_ops(__global SRC_DATA_T *src, __global BIA_DATA_T *bias,)==""\n"
R"==(__global DST_DATA_T *dst POST_OP_ARGS, __global SPAD_DATA_T *scratchpad,)==""\n"
R"==(global float *a_scales, global WEI_SCALES_DATA_T *b_scales,)==""\n"
R"==(global DST_SCALES_DATA_T *c_scales, int scale_stride,)==""\n"
R"==(global int *dst_zp) {)==""\n"
R"==(const uint d0 = GWS_GET_D0();)==""\n"
R"==(const uint d1 = GWS_GET_D1();)==""\n"
R"==(const uint d2 = GWS_GET_D2();)==""\n"
R"==(const uint d3 = GWS_GET_D3();)==""\n"
R"==(#if NDIMS == 4)==""\n"
R"==(size_t data_idx = DST_OFF(d0, d1, 0, d2, d3);)==""\n"
R"==(#elif NDIMS == 3)==""\n"
R"==(size_t data_idx = DST_OFF(d0, d1, 0, 0, d2);)==""\n"
R"==(#else)==""\n"
R"==(size_t data_idx = DST_OFF(d0, d1, 0, 0, 0);)==""\n"
R"==(#endif)==""\n"
R"==(#if USE_TEMP_DST == 1)==""\n"
R"==(ACC_DATA_T acc = SRC_TO_ACC(scratchpad[data_idx]);)==""\n"
R"==(#else)==""\n"
R"==(ACC_DATA_T acc = SRC_TO_ACC(src[data_idx]);)==""\n"
R"==(#endif)==""\n"
R"==(float accumulator = acc;)==""\n"
R"==(if ((d0 == D0_WO_PADDING && d1 == D1_WO_PADDING && d2 == D2_WO_PADDING)==""\n"
R"==(&& d3 == D3_WO_PADDING))==""\n"
R"==(|| (d0 < D0_WO_PADDING && d1 < D1_WO_PADDING && d2 < D2_WO_PADDING)==""\n"
R"==(&& d3 < D3_WO_PADDING)) {)==""\n"
R"==(#if A_SCALES || B_SCALES)==""\n"
R"==(#define A_SCALE (A_SCALES ? a_scales[0] : 1))==""\n"
R"==(#if NDIMS == 2)==""\n"
R"==(const float b_scale)==""\n"
R"==(= B_SCALES ? WEI_SCALES_TO_REF(b_scales[scale_stride * d1]) : 1;)==""\n"
R"==(#elif NDIMS == 3)==""\n"
R"==(const float b_scale)==""\n"
R"==(= B_SCALES ? WEI_SCALES_TO_REF(b_scales[scale_stride * d2]) : 1;)==""\n"
R"==(#elif NDIMS == 4)==""\n"
R"==(const float b_scale)==""\n"
R"==(= B_SCALES ? WEI_SCALES_TO_REF(b_scales[scale_stride * d3]) : 1;)==""\n"
R"==(#endif)==""\n"
R"==(acc *= A_SCALE * b_scale;)==""\n"
R"==(#endif)==""\n"
R"==(#if WITH_BIAS == 1)==""\n"
R"==(#if NDIMS == 4)==""\n"
R"==(size_t bia_idx = BIA_OFF(d0, d1, 0, d2, d3);)==""\n"
R"==(#elif NDIMS == 3)==""\n"
R"==(size_t bia_idx = BIA_OFF(d0, d1, 0, 0, d2);)==""\n"
R"==(#else)==""\n"
R"==(size_t bia_idx = BIA_OFF(d0, d1, 0, 0, 0);)==""\n"
R"==(#endif)==""\n"
R"==(acc += BIA_TO_ACC(bias[bia_idx]);)==""\n"
R"==(#endif)==""\n"
R"==(float sum_src = 0.0f;)==""\n"
R"==(#if WITH_SUM)==""\n"
R"==(sum_src = DST_TO_ACC(dst[data_idx]);)==""\n"
R"==(#endif)==""\n"
R"==(accumulator = acc;)==""\n"
R"==(#if NDIMS == 2)==""\n"
R"==(APPLY_POST_OPS_SERIAL(accumulator, float, sum_src, float, d0, 1, d1, 1,)==""\n"
R"==(0, 1, 0, 1, 0, 1, 0, 1);)==""\n"
R"==(#elif NDIMS == 3)==""\n"
R"==(APPLY_POST_OPS_SERIAL(accumulator, float, sum_src, float, d0, 1, d1, 1,)==""\n"
R"==(d2, 1, 0, 1, 0, 1, 0, 1);)==""\n"
R"==(#elif NDIMS == 4)==""\n"
R"==(APPLY_POST_OPS_SERIAL(accumulator, float, sum_src, float, d0, 1, d1, 1,)==""\n"
R"==(d2, 1, d3, 1, 0, 1, 0, 1);)==""\n"
R"==(#endif)==""\n"
R"==(#if C_SCALES)==""\n"
R"==(accumulator /= DST_SCALES_TO_REF(c_scales[0]);)==""\n"
R"==(#endif)==""\n"
R"==(#if DST_ZERO_POINT)==""\n"
R"==(accumulator += dst_zp[0];)==""\n"
R"==(#endif)==""\n"
R"==(})==""\n"
R"==(dst[data_idx] = TO_DST(accumulator);)==""\n"
R"==(})==""\n"
R"==()==";
}
}
}
}
}