namespace dnnl {
namespace impl {
namespace gpu {
namespace intel {
namespace ocl {
const char *gen9_bnorm_nhwc_fwd_kernel = R"==(/*******************************************************************************)==""\n"
R"==(* Copyright 2020-2024 Intel Corporation)==""\n"
R"==(*)==""\n"
R"==(* Licensed under the Apache License, Version 2.0 (the "License");)==""\n"
R"==(* you may not use this file except in compliance with the License.)==""\n"
R"==(* You may obtain a copy of the License at)==""\n"
R"==(*)==""\n"
R"==(* http:)==""\n"
R"==(*)==""\n"
R"==(* Unless required by applicable law or agreed to in writing, software)==""\n"
R"==(* distributed under the License is distributed on an "AS IS" BASIS,)==""\n"
R"==(* WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.)==""\n"
R"==(* See the License for the specific language governing permissions and)==""\n"
R"==(* limitations under the License.)==""\n"
R"==(*******************************************************************************/)==""\n"
R"==(#include "gpu/intel/ocl/bnorm/gen9_bnorm.h")==""\n"
R"==(#if USE_STATS_ONE_PASS)==""\n"
R"==(NAMED_KERNEL_ATTR(CALC))==""\n"
R"==(__kernel void gen9_calc_mean_var_nhwc(__global DATA_T *src,)==""\n"
R"==(__global ACCUM_DATA_T *reduce_temp,)==""\n"
R"==(volatile __global atomic_float *mean,)==""\n"
R"==(volatile __global atomic_float *variance) {)==""\n"
R"==(const int mb = GWS_GET_STAT_MB();)==""\n"
R"==(const int c = GWS_GET_STAT_IC();)==""\n"
R"==(const int sp_block_idx = GWS_GET_STAT_SP();)==""\n"
R"==(const int ic_block_offset = (c / SG_SIZE) * IC_BLOCK;)==""\n"
R"==(const int group_c_offset)==""\n"
R"==(= REDUCE_STAT_NBLOCKS * ic_block_offset + sp_block_idx * SG_SIZE;)==""\n"
R"==(const int ver_offs = REDUCE_STAT_NBLOCKS * IC;)==""\n"
R"==(const int src_off = ic_block_offset + sp_block_idx * STAT_SP_BLOCK * IC;)==""\n"
R"==(src += src_off;)==""\n"
R"==(SUM_DATA_T sum[IC_BLOCK_SGROUPS] = {0.0f};)==""\n"
R"==(SUM_DATA_T sum_sq[IC_BLOCK_SGROUPS] = {0.0f};)==""\n"
R"==(#if HAS_STAT_SP_BLOCK_TAIL)==""\n"
R"==(for (int sp = 0; sp < min(STAT_SP_BLOCK, SP - sp_block_idx * STAT_SP_BLOCK);)==""\n"
R"==(++sp) {)==""\n"
R"==(#else)==""\n"
R"==(for (int sp = 0; sp < STAT_SP_BLOCK; ++sp) {)==""\n"
R"==(#endif)==""\n"
R"==(for (int sg = 0; sg < IC_BLOCK_SGROUPS / VECT_SIZE; ++sg) {)==""\n"
R"==(VECT_FLOAT_T s_vect)==""\n"
R"==(= LOAD_VECT_DATA(&src[sg * SG_SIZE * VECT_SIZE]);)==""\n"
R"==(for (int vect = 0; vect < VECT_SIZE; ++vect) {)==""\n"
R"==(const int sum_idx = sg * VECT_SIZE + vect;)==""\n"
R"==(#if VECT_SIZE > 1)==""\n"
R"==(sum[sum_idx] = summation(s_vect[vect], sum[sum_idx]);)==""\n"
R"==(sum_sq[sum_idx] = summation()==""\n"
R"==(s_vect[vect] * s_vect[vect], sum_sq[sum_idx]);)==""\n"
R"==(#else)==""\n"
R"==(sum[sum_idx] = summation(s_vect, sum[sum_idx]);)==""\n"
R"==(sum_sq[sum_idx] = summation(s_vect * s_vect, sum_sq[sum_idx]);)==""\n"
R"==(#endif)==""\n"
R"==(})==""\n"
R"==(})==""\n"
R"==(#if HAS_IC_VECT_TAIL)==""\n"
R"==(for (int sg = 0; sg < IC_TAIL_SGROUPS; ++sg) {)==""\n"
R"==(const int sg_idx = IC_VECT_SGROUPS + sg;)==""\n"
R"==(float s_tail)==""\n"
R"==(= LOAD_DATA_1x16(&src[(IC_VECT_SGROUPS + sg) * SG_SIZE]);)==""\n"
R"==(sum[sg_idx] = summation(s_tail, sum[sg_idx]);)==""\n"
R"==(sum_sq[sg_idx] = summation(s_tail * s_tail, sum_sq[sg_idx]);)==""\n"
R"==(})==""\n"
R"==(#endif)==""\n"
R"==(src += IC;)==""\n"
R"==(})==""\n"
R"==(#if FUSED_ATOMICS_REDUCTION)==""\n"
R"==(__local SUM_DATA_T local_sum[2 * CALC_SLM_SIZE];)==""\n"
R"==(__local SUM_DATA_T *local_sum_sq = local_sum + CALC_SLM_SIZE;)==""\n"
R"==(gen9_mean_var_calc_fused_reduction(mean, variance, ic_block_offset, sum,)==""\n"
R"==(sum_sq, local_sum, local_sum_sq);)==""\n"
R"==(#else)==""\n"
R"==(for (int sg = 0; sg < IC_BLOCK_SGROUPS; ++sg) {)==""\n"
R"==(const int reduce_off)==""\n"
R"==(= group_c_offset + sg * SG_SIZE * REDUCE_STAT_NBLOCKS;)==""\n"
R"==(STORE_FLOAT_1x16(&reduce_temp[reduce_off], sum[sg].s0);)==""\n"
R"==(STORE_FLOAT_1x16(&reduce_temp[ver_offs + reduce_off], sum_sq[sg].s0);)==""\n"
R"==(})==""\n"
R"==(#endif)==""\n"
R"==(})==""\n"
R"==(#else )==""\n"
R"==(NAMED_KERNEL_ATTR(CALC))==""\n"
R"==(__kernel void gen9_calc_mean_nhwc(__global DATA_T *src,)==""\n"
R"==(__global float *reduce_temp, volatile __global atomic_float *mean) {)==""\n"
R"==(const int mb = GWS_GET_STAT_MB();)==""\n"
R"==(const int c = GWS_GET_STAT_IC();)==""\n"
R"==(const int sp_block_idx = GWS_GET_STAT_SP();)==""\n"
R"==(const int ic_block_offset = (c / SG_SIZE) * IC_BLOCK;)==""\n"
R"==(const int group_c_offset)==""\n"
R"==(= REDUCE_STAT_NBLOCKS * ic_block_offset + sp_block_idx * SG_SIZE;)==""\n"
R"==(const int src_off = ic_block_offset + sp_block_idx * STAT_SP_BLOCK * IC;)==""\n"
R"==(src += src_off;)==""\n"
R"==(float v_mean[IC_BLOCK_SGROUPS] = {0.0f};)==""\n"
R"==(#if HAS_STAT_SP_BLOCK_TAIL)==""\n"
R"==(for (int sp = 0; sp < min(STAT_SP_BLOCK, SP - sp_block_idx * STAT_SP_BLOCK);)==""\n"
R"==(++sp) {)==""\n"
R"==(#else)==""\n"
R"==(for (int sp = 0; sp < STAT_SP_BLOCK; ++sp) {)==""\n"
R"==(#endif)==""\n"
R"==(for (int sg = 0; sg < IC_BLOCK_SGROUPS / VECT_SIZE; ++sg) {)==""\n"
R"==(VECT_FLOAT_T s_vect)==""\n"
R"==(= LOAD_VECT_DATA(&src[sg * SG_SIZE * VECT_SIZE]);)==""\n"
R"==(for (int vect = 0; vect < VECT_SIZE; ++vect) {)==""\n"
R"==(v_mean[sg * VECT_SIZE + vect])==""\n"
R"==(#if VECT_SIZE > 1)==""\n"
R"==(+= s_vect[vect];)==""\n"
R"==(#else)==""\n"
R"==(+= s_vect;)==""\n"
R"==(#endif)==""\n"
R"==(})==""\n"
R"==(})==""\n"
R"==(#if HAS_IC_VECT_TAIL)==""\n"
R"==(for (int sg = 0; sg < IC_TAIL_SGROUPS; ++sg) {)==""\n"
R"==(float s_tail)==""\n"
R"==(= LOAD_DATA_1x16(&src[(IC_VECT_SGROUPS + sg) * SG_SIZE]);)==""\n"
R"==(v_mean[IC_VECT_SGROUPS + sg] += s_tail;)==""\n"
R"==(})==""\n"
R"==(#endif )==""\n"
R"==(src += IC;)==""\n"
R"==(})==""\n"
R"==(#if FUSED_ATOMICS_REDUCTION)==""\n"
R"==(__local float local_sum[CALC_SLM_SIZE];)==""\n"
R"==(gen9_calc_fused_reduction(mean, ic_block_offset, v_mean, local_sum);)==""\n"
R"==(#else)==""\n"
R"==(for (int sg = 0; sg < IC_BLOCK_SGROUPS; ++sg) {)==""\n"
R"==(const int reduce_off)==""\n"
R"==(= group_c_offset + sg * SG_SIZE * REDUCE_STAT_NBLOCKS;)==""\n"
R"==(STORE_FLOAT_1x16(&reduce_temp[reduce_off], v_mean[sg]);)==""\n"
R"==(})==""\n"
R"==(#endif)==""\n"
R"==(})==""\n"
R"==(NAMED_KERNEL_ATTR(CALC))==""\n"
R"==(__kernel void gen9_calc_variance_nhwc(__global DATA_T *src,)==""\n"
R"==(__global float *mean, __global float *reduce_temp,)==""\n"
R"==(volatile __global atomic_float *variance) {)==""\n"
R"==(const int mb = GWS_GET_STAT_MB();)==""\n"
R"==(const int c = GWS_GET_STAT_IC();)==""\n"
R"==(const int sp_block_idx = GWS_GET_STAT_SP();)==""\n"
R"==(const int ic_block_offset = (c / SG_SIZE) * IC_BLOCK;)==""\n"
R"==(const int group_c_offset)==""\n"
R"==(= REDUCE_STAT_NBLOCKS * ic_block_offset + sp_block_idx * SG_SIZE;)==""\n"
R"==(reduce_temp += REDUCE_STAT_NBLOCKS * PADDED_IC;)==""\n"
R"==(mean += ic_block_offset;)==""\n"
R"==(const int src_off = ic_block_offset + sp_block_idx * STAT_SP_BLOCK * IC;)==""\n"
R"==(src += src_off;)==""\n"
R"==(float v_mean[IC_BLOCK_SGROUPS];)==""\n"
R"==(for (int sg = 0; sg < IC_BLOCK_SGROUPS; ++sg) {)==""\n"
R"==(v_mean[sg] = as_float(intel_sub_group_block_read()==""\n"
R"==((const __global uint *)(&mean[(sg * SG_SIZE)])));)==""\n"
R"==(})==""\n"
R"==(float v_var[IC_BLOCK_SGROUPS] = {0.0f};)==""\n"
R"==(float v0[IC_BLOCK_SGROUPS] = {0.0f};)==""\n"
R"==(#if HAS_STAT_SP_BLOCK_TAIL)==""\n"
R"==(for (int sp = 0; sp < min(STAT_SP_BLOCK, SP - sp_block_idx * STAT_SP_BLOCK);)==""\n"
R"==(++sp) {)==""\n"
R"==(#else)==""\n"
R"==(for (int sp = 0; sp < STAT_SP_BLOCK; ++sp) {)==""\n"
R"==(#endif)==""\n"
R"==(for (int sg = 0; sg < IC_BLOCK_SGROUPS / VECT_SIZE; ++sg) {)==""\n"
R"==(VECT_FLOAT_T s_vect)==""\n"
R"==(= LOAD_VECT_DATA(&src[sg * SG_SIZE * VECT_SIZE]);)==""\n"
R"==(for (int vect = 0; vect < VECT_SIZE; ++vect) {)==""\n"
R"==(int sg_idx = sg * VECT_SIZE + vect;)==""\n"
R"==(#if VECT_SIZE > 1)==""\n"
R"==(v0[sg_idx] = s_vect[vect] - v_mean[sg_idx];)==""\n"
R"==(#else)==""\n"
R"==(v0[sg_idx] = s_vect - v_mean[sg_idx];)==""\n"
R"==(#endif)==""\n"
R"==(v_var[sg_idx] = fma(v0[sg_idx], v0[sg_idx], v_var[sg_idx]);)==""\n"
R"==(})==""\n"
R"==(})==""\n"
R"==(#if HAS_IC_VECT_TAIL)==""\n"
R"==(for (int sg = 0; sg < IC_TAIL_SGROUPS; ++sg) {)==""\n"
R"==(const int sg_idx = IC_VECT_SGROUPS + sg;)==""\n"
R"==(float s_tail)==""\n"
R"==(= LOAD_DATA_1x16(&src[(IC_VECT_SGROUPS + sg) * SG_SIZE]);)==""\n"
R"==(v0[sg_idx] = s_tail - v_mean[sg_idx];)==""\n"
R"==(v_var[sg_idx] = fma(v0[sg_idx], v0[sg_idx], v_var[sg_idx]);)==""\n"
R"==(})==""\n"
R"==(#endif )==""\n"
R"==(src += IC;)==""\n"
R"==(})==""\n"
R"==(#if FUSED_ATOMICS_REDUCTION)==""\n"
R"==(__local float local_sum[CALC_SLM_SIZE];)==""\n"
R"==(gen9_calc_fused_reduction(variance, ic_block_offset, v_var, local_sum);)==""\n"
R"==(#else)==""\n"
R"==(for (int sg = 0; sg < IC_BLOCK_SGROUPS; ++sg) {)==""\n"
R"==(const int reduce_off)==""\n"
R"==(= group_c_offset + sg * SG_SIZE * REDUCE_STAT_NBLOCKS;)==""\n"
R"==(STORE_FLOAT_1x16(&reduce_temp[reduce_off], v_var[sg]);)==""\n"
R"==(})==""\n"
R"==(#endif)==""\n"
R"==(})==""\n"
R"==(#endif )==""\n"
R"==(KERNEL_ATTR)==""\n"
R"==(__kernel void gen9_bnorm_fwd_nhwc(__global DATA_T *src, __global float *mean,)==""\n"
R"==(__global float *variance, __global DATA_T *dst,)==""\n"
R"==(__global float *scaleshift, __global float *shift, __global char *ws,)==""\n"
R"==(float eps, __global DATA_T *src_add, float relu_alpha) {)==""\n"
R"==(const int n = GWS_GET_MB();)==""\n"
R"==(const int c = GWS_GET_IC();)==""\n"
R"==(const int sp = GWS_GET_SP() * UPDATE_SP_BLOCK;)==""\n"
R"==(const int ic_block_offset = (c / SG_SIZE) * IC_BLOCK;)==""\n"
R"==(mean += ic_block_offset;)==""\n"
R"==(variance += ic_block_offset;)==""\n"
R"==(shift += ic_block_offset;)==""\n"
R"==(scaleshift += ic_block_offset;)==""\n"
R"==(const uint d_off = sp * IC + ic_block_offset;)==""\n"
R"==(src += d_off;)==""\n"
R"==(#if FUSE_BN_ADD_RELU)==""\n"
R"==(src_add += d_off;)==""\n"
R"==(#endif)==""\n"
R"==(dst += d_off;)==""\n"
R"==(#if FUSE_BN_RELU && IS_TRAINING)==""\n"
R"==(ws += d_off;)==""\n"
R"==(#endif)==""\n"
R"==(VECT_FLOAT_T sm[IC_BLOCK_SGROUPS / VECT_SIZE],)==""\n"
R"==(sv[IC_BLOCK_SGROUPS / VECT_SIZE],)==""\n"
R"==(v_mean[IC_BLOCK_SGROUPS / VECT_SIZE],)==""\n"
R"==(v_variance[IC_BLOCK_SGROUPS / VECT_SIZE],)==""\n"
R"==(sqrt_variance[IC_BLOCK_SGROUPS / VECT_SIZE];)==""\n"
R"==(for (int sg = 0; sg < IC_BLOCK_SGROUPS / VECT_SIZE; ++sg) {)==""\n"
R"==(const int sg_idx = sg * SG_SIZE * VECT_SIZE;)==""\n"
R"==(#if USE_SCALE == 1)==""\n"
R"==(sm[sg] = LOAD_VECT_FLOAT(&scaleshift[sg_idx]);)==""\n"
R"==(#else)==""\n"
R"==(sm[sg] = (VECT_FLOAT_T)1.0f;)==""\n"
R"==(#endif)==""\n"
R"==(#if USE_SHIFT == 1)==""\n"
R"==(sv[sg] = LOAD_VECT_FLOAT(&shift[sg_idx]);)==""\n"
R"==(#else)==""\n"
R"==(sv[sg] = (VECT_FLOAT_T)0.0f;)==""\n"
R"==(#endif)==""\n"
R"==(v_mean[sg] = LOAD_VECT_FLOAT(&mean[sg_idx]);)==""\n"
R"==(v_variance[sg] = LOAD_VECT_FLOAT(&variance[sg_idx]);)==""\n"
R"==(sqrt_variance[sg] = sm[sg] / sqrt(v_variance[sg] + (VECT_FLOAT_T)eps);)==""\n"
R"==(})==""\n"
R"==(#if HAS_IC_VECT_TAIL)==""\n"
R"==(float sm_tail[IC_TAIL_SGROUPS], sv_tail[IC_TAIL_SGROUPS],)==""\n"
R"==(v_mean_tail[IC_TAIL_SGROUPS], v_variance_tail[IC_TAIL_SGROUPS],)==""\n"
R"==(sqrt_variance_tail[IC_TAIL_SGROUPS];)==""\n"
R"==(for (int sg = 0; sg < IC_TAIL_SGROUPS; ++sg) {)==""\n"
R"==(const int sg_idx = (IC_VECT_SGROUPS + sg) * SG_SIZE;)==""\n"
R"==(#if USE_SCALE == 1)==""\n"
R"==(sm_tail[sg] = LOAD_FLOAT_1x16(&scaleshift[sg_idx]);)==""\n"
R"==(#else)==""\n"
R"==(sm_tail[sg] = 1.0f;)==""\n"
R"==(#endif)==""\n"
R"==(#if USE_SHIFT == 1)==""\n"
R"==(sv_tail[sg] = LOAD_FLOAT_1x16(&shift[sg_idx]);)==""\n"
R"==(#else)==""\n"
R"==(sv_tail[sg] = 0.0f;)==""\n"
R"==(#endif)==""\n"
R"==(v_mean_tail[sg] = LOAD_FLOAT_1x16(&mean[sg_idx]);)==""\n"
R"==(v_variance_tail[sg] = LOAD_FLOAT_1x16(&variance[sg_idx]);)==""\n"
R"==(sqrt_variance_tail[sg] = sm_tail[sg] / sqrt(v_variance_tail[sg] + eps);)==""\n"
R"==(})==""\n"
R"==(#endif)==""\n"
R"==(#if HAS_UPDATE_SP_BLOCK_TAIL)==""\n"
R"==(for (int sp_idx = 0; sp_idx < min(UPDATE_SP_BLOCK, SP - sp);)==""\n"
R"==(sp_idx += UPDATE_SP_UNROLL) {)==""\n"
R"==(#else)==""\n"
R"==(for (int sp_idx = 0; sp_idx < UPDATE_SP_BLOCK; sp_idx += UPDATE_SP_UNROLL) {)==""\n"
R"==(#endif)==""\n"
R"==(for (int sg = 0; sg < IC_BLOCK_SGROUPS / VECT_SIZE; ++sg) {)==""\n"
R"==(const int sg_idx = sg * SG_SIZE * VECT_SIZE;)==""\n"
R"==(VECT_FLOAT_T s_vect[UPDATE_SP_UNROLL];)==""\n"
R"==(unroll_for(int i = 0; i < UPDATE_SP_UNROLL; i++) {)==""\n"
R"==(s_vect[i] = LOAD_VECT_DATA(&src[sg_idx + IC * i]);)==""\n"
R"==(})==""\n"
R"==(VECT_FLOAT_T d_vect[UPDATE_SP_UNROLL];)==""\n"
R"==(unroll_for(int i = 0; i < UPDATE_SP_UNROLL; i++) {)==""\n"
R"==(d_vect[i] = fma()==""\n"
R"==(s_vect[i] - v_mean[sg], sqrt_variance[sg], sv[sg]);)==""\n"
R"==(})==""\n"
R"==(#if FUSE_BN_RELU)==""\n"
R"==(#if FUSE_BN_ADD_RELU)==""\n"
R"==(VECT_FLOAT_T s_add_vect[UPDATE_SP_UNROLL];)==""\n"
R"==(unroll_for(int i = 0; i < UPDATE_SP_UNROLL; i++) {)==""\n"
R"==(s_add_vect[i] = LOAD_VECT_DATA(&src_add[sg_idx + IC * i]);)==""\n"
R"==(d_vect[i] += s_add_vect[i];)==""\n"
R"==(})==""\n"
R"==(#endif)==""\n"
R"==(VECT_INT_T ws_vect[UPDATE_SP_UNROLL];)==""\n"
R"==(unroll_for(int i = 0; i < UPDATE_SP_UNROLL; i++) {)==""\n"
R"==(ws_vect[i] = ISGREATER(d_vect[i], (VECT_FLOAT_T)0.0f);)==""\n"
R"==(d_vect[i] = select((VECT_FLOAT_T)0.0f, d_vect[i], ws_vect[i]);)==""\n"
R"==(})==""\n"
R"==(#if IS_TRAINING)==""\n"
R"==(unroll_for(int i = 0; i < UPDATE_SP_UNROLL; i++) {)==""\n"
R"==(STORE_VECT_CHAR(&ws[sg_idx + IC * i], ws_vect[i]);)==""\n"
R"==(})==""\n"
R"==(#endif )==""\n"
R"==(#endif )==""\n"
R"==(#if WITH_RELU && WITH_LEAKY_RELU)==""\n"
R"==(VECT_INT_T l_vect[UPDATE_SP_UNROLL];)==""\n"
R"==(#endif )==""\n"
R"==(unroll_for(int i = 0; i < UPDATE_SP_UNROLL; i++) {)==""\n"
R"==(#if WITH_RELU)==""\n"
R"==(#if WITH_LEAKY_RELU)==""\n"
R"==(l_vect[i] = isless(d_vect[i], 0.0f);)==""\n"
R"==(d_vect[i])==""\n"
R"==(= select(d_vect[i], d_vect[i] * relu_alpha, l_vect[i]);)==""\n"
R"==(#else)==""\n"
R"==(d_vect[i] = max(d_vect[i], (VECT_FLOAT_T)0.0f);)==""\n"
R"==(#endif )==""\n"
R"==(#endif )==""\n"
R"==(STORE_VECT_DATA(&dst[sg_idx + IC * i], d_vect[i]);)==""\n"
R"==(})==""\n"
R"==(})==""\n"
R"==(#if HAS_IC_VECT_TAIL)==""\n"
R"==(for (int sg = 0; sg < IC_TAIL_SGROUPS; ++sg) {)==""\n"
R"==(const int sg_idx = (IC_VECT_SGROUPS + sg) * SG_SIZE;)==""\n"
R"==(float s_tail[UPDATE_SP_UNROLL], d_tail[UPDATE_SP_UNROLL];)==""\n"
R"==(unroll_for(int i = 0; i < UPDATE_SP_UNROLL; i++) {)==""\n"
R"==(s_tail[i] = LOAD_DATA_1x16(&src[sg_idx + IC * i]);)==""\n"
R"==(d_tail[i] = fma(s_tail[i] - v_mean_tail[sg],)==""\n"
R"==(sqrt_variance_tail[sg], sv_tail[sg]);)==""\n"
R"==(})==""\n"
R"==(#if FUSE_BN_RELU)==""\n"
R"==(#if FUSE_BN_ADD_RELU)==""\n"
R"==(float s_add_tail[UPDATE_SP_UNROLL];)==""\n"
R"==(unroll_for(int i = 0; i < UPDATE_SP_UNROLL; i++) {)==""\n"
R"==(s_add_tail[i] = LOAD_DATA_1x16(&src_add[sg_idx + IC * i]);)==""\n"
R"==(d_tail[i] += s_add_tail[i];)==""\n"
R"==(})==""\n"
R"==(#endif)==""\n"
R"==(int ws_tail[UPDATE_SP_UNROLL];)==""\n"
R"==(unroll_for(int i = 0; i < UPDATE_SP_UNROLL; i++) {)==""\n"
R"==(ws_tail[i] = d_tail[i] > 0.0f ? -1 : 0;)==""\n"
R"==(d_tail[i] = select(0.0f, d_tail[i], ws_tail[i]);)==""\n"
R"==(})==""\n"
R"==(#if IS_TRAINING)==""\n"
R"==(unroll_for(int i = 0; i < UPDATE_SP_UNROLL; i++) {)==""\n"
R"==(STORE_CHAR_1x16(&ws[sg_idx + IC * i], convert_char(ws_tail[i]));)==""\n"
R"==(})==""\n"
R"==(#endif )==""\n"
R"==(#endif )==""\n"
R"==(#if WITH_RELU && WITH_LEAKY_RELU)==""\n"
R"==(int l_tail[UPDATE_SP_UNROLL];)==""\n"
R"==(#endif )==""\n"
R"==(unroll_for(int i = 0; i < UPDATE_SP_UNROLL; i++) {)==""\n"
R"==(#if WITH_RELU)==""\n"
R"==(#if WITH_LEAKY_RELU)==""\n"
R"==(l_tail[i] = isless(d_tail[i], 0.0f);)==""\n"
R"==(d_tail[i])==""\n"
R"==(= select(d_tail[i], d_tail[i] * relu_alpha, l_tail[i]);)==""\n"
R"==(#else)==""\n"
R"==(d_tail[i] = max(d_tail[i], 0.0f);)==""\n"
R"==(#endif )==""\n"
R"==(#endif )==""\n"
R"==(STORE_DATA_1x16(&dst[sg_idx + IC * i], d_tail[i]);)==""\n"
R"==(})==""\n"
R"==(})==""\n"
R"==(#endif)==""\n"
R"==(src += IC * UPDATE_SP_UNROLL;)==""\n"
R"==(#if FUSE_BN_ADD_RELU)==""\n"
R"==(src_add += IC * UPDATE_SP_UNROLL;)==""\n"
R"==(#endif)==""\n"
R"==(dst += IC * UPDATE_SP_UNROLL;)==""\n"
R"==(#if FUSE_BN_RELU && IS_TRAINING)==""\n"
R"==(ws += IC * UPDATE_SP_UNROLL;)==""\n"
R"==(#endif)==""\n"
R"==(})==""\n"
R"==(})==""\n"
R"==()==";
}
}
}
}
}