namespace dnnl {
namespace impl {
namespace gpu {
namespace intel {
namespace ocl {
const char *gen9_global_pooling_kernel = R"==(/*******************************************************************************)==""\n"
R"==(* Copyright 2021-2024 Intel Corporation)==""\n"
R"==(*)==""\n"
R"==(* Licensed under the Apache License, Version 2.0 (the "License");)==""\n"
R"==(* you may not use this file except in compliance with the License.)==""\n"
R"==(* You may obtain a copy of the License at)==""\n"
R"==(*)==""\n"
R"==(* http:)==""\n"
R"==(*)==""\n"
R"==(* Unless required by applicable law or agreed to in writing, software)==""\n"
R"==(* distributed under the License is distributed on an "AS IS" BASIS,)==""\n"
R"==(* WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.)==""\n"
R"==(* See the License for the specific language governing permissions and)==""\n"
R"==(* limitations under the License.)==""\n"
R"==(*******************************************************************************/)==""\n"
R"==(#include "gpu/intel/ocl/dispatch.h")==""\n"
R"==(#include "gpu/intel/ocl/ocl_types.h")==""\n"
R"==(#define ALG_AVG (ALG_AVG_NP || ALG_AVG_P))==""\n"
R"==(#if IS_FWD)==""\n"
R"==(KERNEL_ATTR)==""\n"
R"==(__kernel void gen9_global_pooling_fwd()==""\n"
R"==(__global DATA_T *src, __global int *ws, __global DST_DATA_T *dst) {)==""\n"
R"==(const int mb = get_global_id(0) / C;)==""\n"
R"==(const int oc = get_global_id(0) % C;)==""\n"
R"==(const uint dst_off = DST_OFF(mb, oc, 0, 0, 0);)==""\n"
R"==(#if ALG_MAX)==""\n"
R"==(#if DT_BF16)==""\n"
R"==(DEF_ACC_DATA_T dst_val = DATA_TO_REF(src[0]);)==""\n"
R"==(#else)==""\n"
R"==(float dst_val = src[0];)==""\n"
R"==(#endif)==""\n"
R"==(#if IS_TRAINING)==""\n"
R"==(int max_idx = -1;)==""\n"
R"==(#endif)==""\n"
R"==(#else)==""\n"
R"==(#if DT_BF16)==""\n"
R"==(DEF_ACC_DATA_T dst_val = DATA_TO_REF(0.f);)==""\n"
R"==(#else)==""\n"
R"==(float dst_val = 0.f;)==""\n"
R"==(#endif)==""\n"
R"==(#endif)==""\n"
R"==(for (int id = 0; id < ID; id++) {)==""\n"
R"==(for (int ih = 0; ih < IH; ih++) {)==""\n"
R"==(for (int iw = 0; iw < IW; iw++) {)==""\n"
R"==(uint src_off = SRC_OFF(mb, oc, id, ih, iw);)==""\n"
R"==(#if DT_BF16)==""\n"
R"==(DEF_ACC_DATA_T val = DATA_TO_REF(src[src_off]);)==""\n"
R"==(#else)==""\n"
R"==(float val = DATA_TO_REF(src[src_off]);)==""\n"
R"==(#endif)==""\n"
R"==(#if ALG_MAX)==""\n"
R"==(if (val > dst_val) {)==""\n"
R"==(dst_val = val;)==""\n"
R"==(#if IS_TRAINING)==""\n"
R"==(max_idx = id * IH * IW + ih * IW + iw;)==""\n"
R"==(#endif)==""\n"
R"==(})==""\n"
R"==(#else)==""\n"
R"==(dst_val += val;)==""\n"
R"==(#endif)==""\n"
R"==(})==""\n"
R"==(})==""\n"
R"==(})==""\n"
R"==(#if ALG_MAX)==""\n"
R"==(dst[dst_off] = TO_DST(dst_val);)==""\n"
R"==(#if IS_TRAINING)==""\n"
R"==(ws[dst_off] = max_idx;)==""\n"
R"==(#endif)==""\n"
R"==(#else)==""\n"
R"==(dst[dst_off] = TO_DST(dst_val / ID / IH / IW);)==""\n"
R"==(#endif)==""\n"
R"==(})==""\n"
R"==(#endif )==""\n"
R"==(#if IS_BWD)==""\n"
R"==(#if DT_BF16 || DT_F16)==""\n"
R"==(#define DST_BLOCK_WRITE(dst, val) \)==""\n"
R"==(BLOCK_WRITE((__global ushort *)(dst), as_ushort(val)))==""\n"
R"==(#endif )==""\n"
R"==(#if DT_F32)==""\n"
R"==(#define DST_BLOCK_WRITE(dst, val) \)==""\n"
R"==(BLOCK_WRITE((__global uint *)(dst), as_uint(val)))==""\n"
R"==(#endif )==""\n"
R"==(KERNEL_ATTR)==""\n"
R"==(__kernel void gen9_global_pooling_bwd(__global DATA_T *diff_src,)==""\n"
R"==(__global int *ws, __global DATA_T *diff_dst) {)==""\n"
R"==(const int mb = GWS_GET_MB();)==""\n"
R"==(#if IS_VECTORIZED)==""\n"
R"==(const int c = GWS_GET_C() + get_sub_group_local_id();)==""\n"
R"==(#else)==""\n"
R"==(const int c = GWS_GET_C();)==""\n"
R"==(#endif)==""\n"
R"==(const int spatial = GWS_GET_SPATIAL();)==""\n"
R"==(const bool is_in_padded_area = NEED_ZERO_PADDING && (mb >= MB || c >= C);)==""\n"
R"==(const int dst_off = DST_OFF(mb, c, 0, 0, 0);)==""\n"
R"==(#if ALG_AVG)==""\n"
R"==(const DATA_T dst_val = diff_dst[dst_off];)==""\n"
R"==(#endif )==""\n"
R"==(int ws_val = ws[dst_off];)==""\n"
R"==(for (int sp_idx = spatial;)==""\n"
R"==(sp_idx < min(spatial + SPATIAL_CHUNK, SPATIAL_DIM); sp_idx++) {)==""\n"
R"==(const int iw = sp_idx % IW;)==""\n"
R"==(const int ih = ((sp_idx - iw) % (IH * IW)) / IW;)==""\n"
R"==(const int id = (sp_idx - iw - ih * IW) / (IH * IW);)==""\n"
R"==(DATA_T val_to_write;)==""\n"
R"==(if (is_in_padded_area))==""\n"
R"==(val_to_write = DATA_ZERO;)==""\n"
R"==(else {)==""\n"
R"==(#if ALG_MAX)==""\n"
R"==(const int current_input_idx = id * IH * IW + ih * IW + iw;)==""\n"
R"==(if (current_input_idx == ws_val) {)==""\n"
R"==(val_to_write = diff_dst[dst_off];)==""\n"
R"==(} else {)==""\n"
R"==(val_to_write = DATA_ZERO;)==""\n"
R"==(})==""\n"
R"==(#else )==""\n"
R"==(float dst_val_f = DATA_TO_REF(dst_val) / SPATIAL_DIM;)==""\n"
R"==(val_to_write = CONVERT_DATA_T(dst_val_f);)==""\n"
R"==(#endif )==""\n"
R"==(})==""\n"
R"==(const int src_off = SRC_OFF(mb, GWS_GET_C(), id, ih, iw);)==""\n"
R"==(#if IS_VECTORIZED)==""\n"
R"==(DST_BLOCK_WRITE(&diff_src[src_off], val_to_write);)==""\n"
R"==(#else)==""\n"
R"==(diff_src[src_off] = val_to_write;)==""\n"
R"==(#endif)==""\n"
R"==(})==""\n"
R"==(})==""\n"
R"==(#endif )==""\n"
R"==()==";
}
}
}
}
}