namespace dnnl {
namespace impl {
namespace gpu {
namespace intel {
namespace ocl {
const char *gen9_wino_conv_fwd_data_fused_kernel = R"==(/*******************************************************************************)==""\n"
R"==(* Copyright 2020-2024 Intel Corporation)==""\n"
R"==(*)==""\n"
R"==(* Licensed under the Apache License, Version 2.0 (the "License");)==""\n"
R"==(* you may not use this file except in compliance with the License.)==""\n"
R"==(* You may obtain a copy of the License at)==""\n"
R"==(*)==""\n"
R"==(* http:)==""\n"
R"==(*)==""\n"
R"==(* Unless required by applicable law or agreed to in writing, software)==""\n"
R"==(* distributed under the License is distributed on an "AS IS" BASIS,)==""\n"
R"==(* WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.)==""\n"
R"==(* See the License for the specific language governing permissions and)==""\n"
R"==(* limitations under the License.)==""\n"
R"==(*******************************************************************************/)==""\n"
R"==(#include "gpu/intel/ocl/ocl_post_ops.h")==""\n"
R"==(#include "gpu/intel/ocl/ocl_types.h")==""\n"
R"==(#include "gpu/intel/ocl/offsets.h")==""\n"
R"==(#define IW_BLOCK (OW_BLOCK + KW - 1))==""\n"
R"==(#define IW_INTERNAL_BLOCK 16)==""\n"
R"==(#if IW_BLOCK > IW_INTERNAL_BLOCK)==""\n"
R"==(#error "Invalid IW_BLOCK value")==""\n"
R"==(#endif)==""\n"
R"==(#define LWY 8)==""\n"
R"==(#define LWX (WINO_IC_BLOCK / 2))==""\n"
R"==(#define COMP_UNITS ((OC_BLOCK * WINO_D)))==""\n"
R"==(#define COMP_OC_STRIDE LWX)==""\n"
R"==(#define COMP_OC_COUNT (OC_BLOCK / COMP_OC_STRIDE))==""\n"
R"==(#define WINO_D (WINO_M + WINO_R - 1))==""\n"
R"==(#define TO_TYPE(value) ((DATA_T)value))==""\n"
R"==(#define UTRANS_BLOCK VECT_DT_N)==""\n"
R"==(#define UTRANS_DATA_T VECT_DATA_T)==""\n"
R"==(#define AS_UTRANS_DATA_T AS_VECT_DATA_T)==""\n"
R"==(#define UTRANS_BLOCK_READ(ptr) \)==""\n"
R"==(AS_UTRANS_DATA_T(VECT_BLOCK_READ((const __global BLOCK_DATA_T *)ptr)))==""\n"
R"==(#define UTRANS_BLOCK_WRITE(data, ptr) \)==""\n"
R"==(VECT_BLOCK_WRITE((__global BLOCK_DATA_T *)ptr, AS_VECT_BLOCK_DATA_T(data)))==""\n"
R"==(#define VTRANS_BLOCK 4 )==""\n"
R"==(#define VTRANS_DATA_T CONCAT2(DATA_T, VTRANS_BLOCK))==""\n"
R"==(#define COMP_BLOCK VECT_DT_N)==""\n"
R"==(#define COMP_DATA_T VECT_DATA_T)==""\n"
R"==(#define AS_COMP_DATA_T AS_VECT_DATA_T)==""\n"
R"==(#define COMP_READ(ptr) CONCAT2(vload, COMP_BLOCK)(0, ptr))==""\n"
R"==(#define COMP_WRITE(data, ptr) CONCAT2(vstore, COMP_BLOCK)(data, 0, ptr))==""\n"
R"==(#define COMP_BLOCK_READ(ptr) \)==""\n"
R"==(AS_COMP_DATA_T(VECT_BLOCK_READ((const __global BLOCK_DATA_T *)ptr)))==""\n"
R"==(#define COMP_UNROLL (IC_BLOCK / COMP_BLOCK))==""\n"
R"==(#define OUT_TYPE_BLOCK 2 )==""\n"
R"==(#define OUT_BLOCK_DATA_T CONCAT2(DATA_T, OUT_TYPE_BLOCK))==""\n"
R"==(#define OUT_BLOCK_READ(ptr) CONCAT2(vload, OUT_TYPE_BLOCK)(0, ptr))==""\n"
R"==(#define OUT_BLOCK_WRITE(data, ptr) \)==""\n"
R"==(do { \)==""\n"
R"==(OUT_BLOCK_DATA_T result = data; \)==""\n"
R"==(unroll_for(int _i = 0; _i < OUT_TYPE_BLOCK; _i++) { \)==""\n"
R"==((ptr)[_i] = result[_i]; \)==""\n"
R"==(} \)==""\n"
R"==(} while (0))==""\n"
R"==(static inline int U_off(int o, int i, int z, int w) {)==""\n"
R"==(const int ic_internal_block = 16;)==""\n"
R"==(const int oc_internal_block = LWX;)==""\n"
R"==(int icb = i / ic_internal_block;)==""\n"
R"==(int ic = i % ic_internal_block;)==""\n"
R"==(int ocb = o / oc_internal_block;)==""\n"
R"==(int oc = o % oc_internal_block;)==""\n"
R"==(int off = ocb * (WINO_IC / ic_internal_block) * KW * ic_internal_block)==""\n"
R"==(* WINO_D * oc_internal_block;)==""\n"
R"==(off += icb * KW * ic_internal_block * WINO_D * oc_internal_block;)==""\n"
R"==(off += w * ic_internal_block * WINO_D * oc_internal_block;)==""\n"
R"==(off += z * ic_internal_block * oc_internal_block;)==""\n"
R"==(off += ic * oc_internal_block;)==""\n"
R"==(off += oc;)==""\n"
R"==(return off;)==""\n"
R"==(})==""\n"
R"==(static inline int V_off(int i, int z, int w, int block_size) {)==""\n"
R"==(const int ic_internal_block = 16;)==""\n"
R"==(int icb = i / ic_internal_block;)==""\n"
R"==(int ic = i % ic_internal_block;)==""\n"
R"==(int off = icb * WINO_D * IW_INTERNAL_BLOCK * ic_internal_block;)==""\n"
R"==(off += z * IW_INTERNAL_BLOCK * ic_internal_block;)==""\n"
R"==(off += w * ic_internal_block;)==""\n"
R"==(off += ic;)==""\n"
R"==(return off / block_size;)==""\n"
R"==(})==""\n"
R"==(static inline int M_off(int o, int z, int w, int block_size) {)==""\n"
R"==(const int ow_internal_block = OUT_TYPE_BLOCK;)==""\n"
R"==(int owb = w / ow_internal_block;)==""\n"
R"==(int ow = w % ow_internal_block;)==""\n"
R"==(int off = z * OW_BLOCK / ow_internal_block * OC_BLOCK * ow_internal_block;)==""\n"
R"==(off += owb * OC_BLOCK * ow_internal_block;)==""\n"
R"==(off += o * ow_internal_block;)==""\n"
R"==(off += ow;)==""\n"
R"==(return off / block_size;)==""\n"
R"==(})==""\n"
R"==(#define VTRANS_LY_STRIDE 2)==""\n"
R"==(#define VTRANS_LX_CYCLE (LWX / VTRANS_LY_STRIDE))==""\n"
R"==(static inline int get_Vtrans_ic0(int lx, int ly) {)==""\n"
R"==(return VTRANS_BLOCK * (lx % VTRANS_LX_CYCLE);)==""\n"
R"==(})==""\n"
R"==(static inline int get_Vtrans_ih0(int lx, int ly) {)==""\n"
R"==(return 0;)==""\n"
R"==(})==""\n"
R"==(static inline int get_Vtrans_iw0(int lx, int ly) {)==""\n"
R"==(return LWY * (lx / VTRANS_LX_CYCLE) + ly;)==""\n"
R"==(})==""\n"
R"==(#define VCOMP_LX_CYCLE (LWX / 8) )==""\n"
R"==(static inline int get_Vcomp_ic0(int lx, int ly) {)==""\n"
R"==(return 8 * (lx % VCOMP_LX_CYCLE);)==""\n"
R"==(})==""\n"
R"==(static inline int get_Vcomp_ih0(int lx, int ly) {)==""\n"
R"==(return ly;)==""\n"
R"==(})==""\n"
R"==(static inline int get_Vcomp_iw0(int lx, int ly) {)==""\n"
R"==(return lx / VCOMP_LX_CYCLE;)==""\n"
R"==(})==""\n"
R"==(static inline int get_Ucomp_ic0(int lx, int ly) {)==""\n"
R"==(return 0;)==""\n"
R"==(})==""\n"
R"==(static inline int get_Ucomp_oc0(int lx, int ly) {)==""\n"
R"==(return lx;)==""\n"
R"==(})==""\n"
R"==(static inline int get_Ucomp_kh0(int lx, int ly) {)==""\n"
R"==(return get_Vcomp_ih0(lx, ly);)==""\n"
R"==(})==""\n"
R"==(static inline int get_Ucomp_kw0(int lx, int ly) {)==""\n"
R"==(return 0;)==""\n"
R"==(})==""\n"
R"==(static inline int get_Mcomp_oc0(int lx, int ly) {)==""\n"
R"==(return get_Ucomp_oc0(lx, ly);)==""\n"
R"==(})==""\n"
R"==(static inline int get_Mcomp_oh0(int lx, int ly) {)==""\n"
R"==(return get_Vcomp_ih0(lx, ly);)==""\n"
R"==(})==""\n"
R"==(static inline int get_Mcomp_ow0(int lx, int ly) {)==""\n"
R"==(return 0;)==""\n"
R"==(})==""\n"
R"==(static inline int get_out_oh0(int lx, int ly) {)==""\n"
R"==(return 0;)==""\n"
R"==(})==""\n"
R"==(#define OUT_LY_CYCLE (16 / OUT_TYPE_BLOCK) )==""\n"
R"==(static inline int get_out_ow0(int lx, int ly) {)==""\n"
R"==(return OUT_TYPE_BLOCK * (ly % OUT_LY_CYCLE);)==""\n"
R"==(})==""\n"
R"==(static inline int get_out_oc0(int lx, int ly) {)==""\n"
R"==(return lx + LWX * (ly / OUT_LY_CYCLE);)==""\n"
R"==(})==""\n"
R"==(#if WINO_M == 6)==""\n"
R"==(static inline void wino_U_transform()==""\n"
R"==(UTRANS_DATA_T U[WINO_D], UTRANS_DATA_T wei[WINO_R]) {)==""\n"
R"==(U[0] = wei[0];)==""\n"
R"==(U[1] = TO_TYPE(-2.0 / 9) * (wei[0] + wei[1] + wei[2]);)==""\n"
R"==(U[2] = TO_TYPE(2.0 / 9) * (-wei[0] + wei[1] - wei[2]);)==""\n"
R"==(U[3] = TO_TYPE(1.0 / 90) * wei[0] + TO_TYPE(2.0 / 90) * wei[1])==""\n"
R"==(+ TO_TYPE(4.0 / 90) * wei[2];)==""\n"
R"==(U[4] = TO_TYPE(1.0 / 90) * wei[0] - TO_TYPE(2.0 / 90) * wei[1])==""\n"
R"==(+ TO_TYPE(4.0 / 90) * wei[2];)==""\n"
R"==(U[5] = TO_TYPE(64.0 / 90) * wei[0] + TO_TYPE(32.0 / 90) * wei[1])==""\n"
R"==(+ TO_TYPE(16.0 / 90) * wei[2];)==""\n"
R"==(U[6] = TO_TYPE(64.0 / 90) * wei[0] - TO_TYPE(32.0 / 90) * wei[1])==""\n"
R"==(+ TO_TYPE(16.0 / 90) * wei[2];)==""\n"
R"==(U[7] = wei[2];)==""\n"
R"==(})==""\n"
R"==(static inline void wino_V_transform()==""\n"
R"==(__local VTRANS_DATA_T *V, const VTRANS_DATA_T src[WINO_D]) {)==""\n"
R"==(V[V_off(0, 0, 0, VTRANS_BLOCK)])==""\n"
R"==(= src[0] - TO_TYPE(5.25) * src[2] + TO_TYPE(5.25) * src[4] - src[6];)==""\n"
R"==(VTRANS_DATA_T x0 = src[1] - TO_TYPE(4.25) * src[3] + src[5];)==""\n"
R"==(VTRANS_DATA_T x1 = src[2] - TO_TYPE(4.25) * src[4] + src[6];)==""\n"
R"==(V[V_off(0, 1, 0, VTRANS_BLOCK)] = x1 + x0;)==""\n"
R"==(V[V_off(0, 2, 0, VTRANS_BLOCK)] = x1 - x0;)==""\n"
R"==(VTRANS_DATA_T x2 = TO_TYPE(-5) * src[3] + src[1];)==""\n"
R"==(VTRANS_DATA_T x3 = TO_TYPE(4) * src[5] + x2;)==""\n"
R"==(VTRANS_DATA_T x4 = TO_TYPE(0.25) * src[2] + src[6];)==""\n"
R"==(VTRANS_DATA_T x5 = TO_TYPE(-1.25) * src[4] + x4;)==""\n"
R"==(V[V_off(0, 3, 0, VTRANS_BLOCK)] = TO_TYPE(0.5) * x3 + x5;)==""\n"
R"==(V[V_off(0, 4, 0, VTRANS_BLOCK)] = TO_TYPE(-0.5) * x3 + x5;)==""\n"
R"==(VTRANS_DATA_T x6 = TO_TYPE(4) * src[1] + src[5];)==""\n"
R"==(VTRANS_DATA_T x7 = TO_TYPE(-5) * src[3] + x6;)==""\n"
R"==(VTRANS_DATA_T x8 = TO_TYPE(4) * src[2] + src[6];)==""\n"
R"==(VTRANS_DATA_T x9 = TO_TYPE(-5) * src[4] + x8;)==""\n"
R"==(V[V_off(0, 5, 0, VTRANS_BLOCK)] = TO_TYPE(+0.5) * x7 + x9;)==""\n"
R"==(V[V_off(0, 6, 0, VTRANS_BLOCK)] = TO_TYPE(-0.5) * x7 + x9;)==""\n"
R"==(V[V_off(0, 7, 0, VTRANS_BLOCK)] = -src[1] + TO_TYPE(5.25) * src[3])==""\n"
R"==(- TO_TYPE(5.25) * src[5] + src[7];)==""\n"
R"==(})==""\n"
R"==(static inline void wino_m_transform()==""\n"
R"==(OUT_BLOCK_DATA_T C[WINO_M], OUT_BLOCK_DATA_T M[WINO_D]) {)==""\n"
R"==(OUT_BLOCK_DATA_T x0 = M[1] + M[2];)==""\n"
R"==(OUT_BLOCK_DATA_T x1 = M[1] - M[2];)==""\n"
R"==(OUT_BLOCK_DATA_T x2 = M[3] + M[4];)==""\n"
R"==(OUT_BLOCK_DATA_T x3 = M[3] - M[4];)==""\n"
R"==(OUT_BLOCK_DATA_T x4 = M[5] + M[6];)==""\n"
R"==(OUT_BLOCK_DATA_T x5 = M[5] - M[6];)==""\n"
R"==(C[0] = M[0] + x0 + x2 + x4;)==""\n"
R"==(C[1] = x1 + TO_TYPE(2) * x3 + TO_TYPE(0.5f) * x5;)==""\n"
R"==(C[2] = x0 + TO_TYPE(4.f) * x2 + TO_TYPE(0.25f) * x4;)==""\n"
R"==(C[3] = x1 + TO_TYPE(8.f) * x3 + TO_TYPE(0.125f) * x5;)==""\n"
R"==(C[4] = x0 + TO_TYPE(16.f) * x2 + TO_TYPE(0.0625f) * x4;)==""\n"
R"==(C[5] = x1 + TO_TYPE(32.f) * x3 + TO_TYPE(0.03125f) * x5 + M[7];)==""\n"
R"==(})==""\n"
R"==(#elif WINO_M == 4)==""\n"
R"==(static inline void wino_U_transform()==""\n"
R"==(UTRANS_DATA_T U[WINO_D], UTRANS_DATA_T wei[WINO_R]) {)==""\n"
R"==(U[0] = wei[0] / 4;)==""\n"
R"==(U[1] = (wei[0] + wei[1] + wei[2]) / (-6);)==""\n"
R"==(U[2] = (wei[0] - wei[1] + wei[2]) / (-6);)==""\n"
R"==(U[3] = (wei[0] + 2 * wei[1] + 4 * wei[2]) / 24;)==""\n"
R"==(U[4] = (wei[0] - 2 * wei[1] + 4 * wei[2]) / 24;)==""\n"
R"==(U[5] = wei[2];)==""\n"
R"==(})==""\n"
R"==(static inline void wino_V_transform()==""\n"
R"==(__local VTRANS_DATA_T *V, const VTRANS_DATA_T src[WINO_D]) {)==""\n"
R"==(V[V_off(0, 0, 0, VTRANS_BLOCK)] = 4 * src[0] - 5 * src[2] + src[4];)==""\n"
R"==(V[V_off(0, 1, 0, VTRANS_BLOCK)] = -4 * (src[1] + src[2]) + src[3] + src[4];)==""\n"
R"==(V[V_off(0, 2, 0, VTRANS_BLOCK)] = 4 * (src[1] - src[2]) - src[3] + src[4];)==""\n"
R"==(V[V_off(0, 3, 0, VTRANS_BLOCK)])==""\n"
R"==(= -2 * src[1] - src[2] + 2 * src[3] + src[4];)==""\n"
R"==(V[V_off(0, 4, 0, VTRANS_BLOCK)] = 2 * src[1] - src[2] - 2 * src[3] + src[4];)==""\n"
R"==(V[V_off(0, 5, 0, VTRANS_BLOCK)] = 4 * src[1] - 5 * src[3] + src[5];)==""\n"
R"==(})==""\n"
R"==(static inline void wino_m_transform()==""\n"
R"==(OUT_BLOCK_DATA_T C[WINO_M], OUT_BLOCK_DATA_T M[WINO_D]) {)==""\n"
R"==(OUT_BLOCK_DATA_T x0 = M[1] + M[2];)==""\n"
R"==(OUT_BLOCK_DATA_T x1 = M[1] - M[2];)==""\n"
R"==(OUT_BLOCK_DATA_T x2 = M[3] + M[4];)==""\n"
R"==(OUT_BLOCK_DATA_T x3 = M[3] - M[4];)==""\n"
R"==(C[0] = M[0] + x0 + x2;)==""\n"
R"==(C[1] = x1 + 2 * x3;)==""\n"
R"==(C[2] = x0 + 4 * x2;)==""\n"
R"==(C[3] = x1 + 8 * x3 + M[5];)==""\n"
R"==(})==""\n"
R"==(#elif WINO_M == 2)==""\n"
R"==(static inline void wino_U_transform()==""\n"
R"==(UTRANS_DATA_T U[WINO_D], UTRANS_DATA_T wei[WINO_R]) {)==""\n"
R"==(U[0] = wei[0];)==""\n"
R"==(U[1] = (wei[0] + wei[1] + wei[2]) / 2;)==""\n"
R"==(U[2] = (wei[0] - wei[1] + wei[2]) / 2;)==""\n"
R"==(U[3] = wei[2];)==""\n"
R"==(})==""\n"
R"==(static inline void wino_V_transform()==""\n"
R"==(__local VTRANS_DATA_T *V, const VTRANS_DATA_T src[WINO_D]) {)==""\n"
R"==(V[V_off(0, 0, 0, VTRANS_BLOCK)] = src[0] - src[2];)==""\n"
R"==(V[V_off(0, 1, 0, VTRANS_BLOCK)] = src[1] + src[2];)==""\n"
R"==(V[V_off(0, 2, 0, VTRANS_BLOCK)] = -src[1] + src[2];)==""\n"
R"==(V[V_off(0, 3, 0, VTRANS_BLOCK)] = src[1] - src[3];)==""\n"
R"==(})==""\n"
R"==(static inline void wino_m_transform()==""\n"
R"==(OUT_BLOCK_DATA_T C[WINO_M], OUT_BLOCK_DATA_T M[WINO_D]) {)==""\n"
R"==(C[0] = M[0] + M[1] + M[2];)==""\n"
R"==(C[1] = M[1] - M[2] - M[3];)==""\n"
R"==(})==""\n"
R"==(#else)==""\n"
R"==(#error "Unsupported Winograd Tile Size")==""\n"
R"==(#endif)==""\n"
R"==(__attribute__((reqd_work_group_size(LWX, 1, 1))))==""\n"
R"==(__attribute__((intel_reqd_sub_group_size(LWX))) __kernel void)==""\n"
R"==(gen9_wino_wei_transform(__global DATA_T *U, const __global DATA_T *weights) {)==""\n"
R"==(const uint weights_tile_width = 1;)==""\n"
R"==(const uint weights_tile_height = WINO_M;)==""\n"
R"==(const uint in_kw = get_global_id(1) * weights_tile_width;)==""\n"
R"==(const uint in_kh = get_global_id(2) * weights_tile_height;)==""\n"
R"==(const uint U_tile_width = 1;)==""\n"
R"==(const uint U_tile_height = WINO_D;)==""\n"
R"==(const uint out_kw = get_global_id(1) * U_tile_width;)==""\n"
R"==(const uint out_kh = get_global_id(2) * U_tile_height;)==""\n"
R"==(const uint oc0 = (get_group_id(0) % (WINO_OC / LWX)) * LWX;)==""\n"
R"==(const uint oc = oc0 + get_local_id(0);)==""\n"
R"==(const uint ic = (get_group_id(0) / (WINO_OC / LWX)) * UTRANS_BLOCK;)==""\n"
R"==(uint in_idx = wei_off(0, oc, ic, 0, in_kh, in_kw);)==""\n"
R"==(bool is_valid = ic < IC && oc0 < OC;)==""\n"
R"==(UTRANS_DATA_T g[WINO_R];)==""\n"
R"==(for (int i = 0; i < WINO_R; i++) {)==""\n"
R"==(for (int j = 0; j < UTRANS_BLOCK; j++) {)==""\n"
R"==(uint idx = in_idx + wei_off(0, 0, j, 0, 0, 0);)==""\n"
R"==(g[i][j] = is_valid ? weights[idx] : 0;)==""\n"
R"==(})==""\n"
R"==(in_idx += wei_off(0, 0, 0, 0, 1, 0);)==""\n"
R"==(})==""\n"
R"==(UTRANS_DATA_T out_tile[WINO_D];)==""\n"
R"==(wino_U_transform(out_tile, g);)==""\n"
R"==(uint out_idx = U_off(oc0, ic, out_kh, out_kw);)==""\n"
R"==(unroll_for(int i = 0; i < WINO_D; i++) {)==""\n"
R"==(UTRANS_BLOCK_WRITE(out_tile[i], &U[out_idx]);)==""\n"
R"==(out_idx += U_off(0, 0, 1, 0);)==""\n"
R"==(})==""\n"
R"==(})==""\n"
R"==(#define DOTi(_result, _A, _B) \)==""\n"
R"==({ _result = mad(_A, _B, _result); })==""\n"
R"==(__attribute__((reqd_work_group_size(LWX, LWY, 1))))==""\n"
R"==(__attribute__((intel_reqd_sub_group_size(LWX))) __kernel void)==""\n"
R"==(gen9_wino_conv_fwd(__global DATA_T *dst, const __global DATA_T *src,)==""\n"
R"==(const __global DATA_T *U_param,)==""\n"
R"==(const __global DATA_T *bias POST_OP_ARGS) {)==""\n"
R"==(const uint slm_size)==""\n"
R"==(= (WINO_IC_BLOCK * WINO_D * IW_INTERNAL_BLOCK) / VTRANS_BLOCK;)==""\n"
R"==(__local VTRANS_DATA_T V[slm_size]; )==""\n"
R"==(const DATA_T scl = TO_TYPE(16);)==""\n"
R"==(const DATA_T sc = TO_TYPE(1) / scl;)==""\n"
R"==(const VTRANS_DATA_T scl_vec = (VTRANS_DATA_T)(sc, sc, sc, sc);)==""\n"
R"==(const int ow0 = get_group_id(0) * OW_BLOCK;)==""\n"
R"==(const int oh0 = get_group_id(1) * OH_BLOCK;)==""\n"
R"==(const int gid2 = get_group_id(2);)==""\n"
R"==(const int oc0 = (gid2 % (OC / OC_BLOCK)) * OC_BLOCK;)==""\n"
R"==(const int mb = gid2 / (OC / OC_BLOCK);)==""\n"
R"==(const int lx = get_local_id(0);)==""\n"
R"==(const int ly = get_local_id(1);)==""\n"
R"==(const int M_ow_size = OW_BLOCK;)==""\n"
R"==(DATA_T M[COMP_OC_COUNT][M_ow_size];)==""\n"
R"==(for (int i = 0; i < COMP_OC_COUNT; i++) {)==""\n"
R"==(for (int j = 0; j < M_ow_size; j++) {)==""\n"
R"==(M[i][j] = 0;)==""\n"
R"==(})==""\n"
R"==(})==""\n"
R"==(const int Vtrans_ic = get_Vtrans_ic0(lx, ly);)==""\n"
R"==(const int Vtrans_ih = get_Vtrans_ih0(lx, ly);)==""\n"
R"==(const int Vtrans_iw = get_Vtrans_iw0(lx, ly);)==""\n"
R"==(const int src_ic = Vtrans_ic;)==""\n"
R"==(const int src_ih = oh0 - PH + Vtrans_ih;)==""\n"
R"==(const int src_iw = ow0 - PW + Vtrans_iw;)==""\n"
R"==(const __global DATA_T *src_load)==""\n"
R"==(= src + src_off(mb, src_ic, 0, src_ih, src_iw);)==""\n"
R"==(const int V_write_idx)==""\n"
R"==(= V_off(Vtrans_ic, Vtrans_ih, Vtrans_iw, VTRANS_BLOCK);)==""\n"
R"==(__local VTRANS_DATA_T *V_write = &V[V_write_idx];)==""\n"
R"==(const int U_oc = oc0 + get_Ucomp_oc0(lx, ly);)==""\n"
R"==(const int U_ic = get_Ucomp_ic0(lx, ly);)==""\n"
R"==(const int U_kh = get_Ucomp_kh0(lx, ly);)==""\n"
R"==(const int U_kw = get_Ucomp_kw0(lx, ly);)==""\n"
R"==(const __global DATA_T *U = U_param + U_off(U_oc, U_ic, U_kh, U_kw);)==""\n"
R"==(const int Vcomp_ic = get_Vcomp_ic0(lx, ly);)==""\n"
R"==(const int Vcomp_ih = get_Vcomp_ih0(lx, ly);)==""\n"
R"==(const int Vcomp_iw = get_Vcomp_iw0(lx, ly);)==""\n"
R"==(const int V_read_idx = V_off(Vcomp_ic, Vcomp_ih, Vcomp_iw, VTRANS_BLOCK);)==""\n"
R"==(__local const COMP_DATA_T *V_read)==""\n"
R"==(= (__local const COMP_DATA_T *)&V[V_read_idx];)==""\n"
R"==(__attribute__((opencl_unroll_hint(1))) for (uint c = 0; c < IC;)==""\n"
R"==(c += WINO_IC_BLOCK) {)==""\n"
R"==(if (IW_BLOCK == 16 || Vtrans_iw < IW_BLOCK) {)==""\n"
R"==(bool x_in = 0 <= src_iw && src_iw < IW && src_ic + c < IC;)==""\n"
R"==(VTRANS_DATA_T src[WINO_D];)==""\n"
R"==(for (int index = 0; index < WINO_D; index++) {)==""\n"
R"==(bool y_in = 0 <= (src_ih + index) && (src_ih + index) < IH)==""\n"
R"==(&& x_in;)==""\n"
R"==(src[index] = y_in ? *((const __global VTRANS_DATA_T *)(src_load)==""\n"
R"==(+ src_off(0, 0, 0, index, 0))))==""\n"
R"==(: 0;)==""\n"
R"==(src[index] = src[index] * scl_vec;)==""\n"
R"==(})==""\n"
R"==(wino_V_transform(V_write, src);)==""\n"
R"==(})==""\n"
R"==(src_load += src_off(0, WINO_IC_BLOCK, 0, 0, 0);)==""\n"
R"==(barrier(CLK_LOCAL_MEM_FENCE);)==""\n"
R"==(__local const COMP_DATA_T *V_read_outer = V_read;)==""\n"
R"==(const int outer_c_blocking = COMP_UNROLL * COMP_BLOCK;)==""\n"
R"==(const int V_local_count = outer_c_blocking * IW_INTERNAL_BLOCK / LWX;)==""\n"
R"==(__attribute__((opencl_unroll_hint()==""\n"
R"==(1))) for (uint c_outer = 0; c_outer < WINO_IC_BLOCK)==""\n"
R"==(&& (WINO_D == 8 || ly < WINO_D);)==""\n"
R"==(c_outer += outer_c_blocking) {)==""\n"
R"==(DATA_T V_block[V_local_count];)==""\n"
R"==(const int c_block = IC_BLOCK / VCOMP_LX_CYCLE;)==""\n"
R"==(const int w_count = V_local_count / c_block;)==""\n"
R"==(const int w_stride = IW_INTERNAL_BLOCK / w_count;)==""\n"
R"==(unroll_for(int w_load = 0; w_load < w_count; w_load++) {)==""\n"
R"==(unroll_for(int c_load = 0; c_load < c_block;)==""\n"
R"==(c_load += COMP_BLOCK) {)==""\n"
R"==(COMP_WRITE(V_read_outer[V_off(c_load, 0, w_load * w_stride,)==""\n"
R"==(COMP_BLOCK)],)==""\n"
R"==(&V_block[w_load * c_block + c_load]);)==""\n"
R"==(})==""\n"
R"==(})==""\n"
R"==(V_read_outer += V_off(outer_c_blocking, 0, 0, COMP_BLOCK);)==""\n"
R"==(#define V_BLOCK(_ic, _iw) \)==""\n"
R"==(sub_group_broadcast( \)==""\n"
R"==(V_block[(_ic) % c_block + c_block * ((_iw) / w_stride)], \)==""\n"
R"==((IC_BLOCK / c_block) * ((_iw) % w_stride) + ((_ic) / c_block)))==""\n"
R"==(unroll_for(int c_inner = 0; c_inner < outer_c_blocking;)==""\n"
R"==(c_inner += COMP_BLOCK) {)==""\n"
R"==(unroll_for(int kw_in = 0; kw_in < KW; kw_in++) {)==""\n"
R"==(unroll_for(int c_out = 0; c_out < COMP_OC_COUNT; c_out++) {)==""\n"
R"==(const COMP_DATA_T f0 = COMP_BLOCK_READ()==""\n"
R"==(&U[U_off(c_out * COMP_OC_STRIDE, 0, 0, kw_in)]);)==""\n"
R"==(unroll_for(int c_in = 0; c_in < COMP_BLOCK; c_in++) {)==""\n"
R"==(unroll_for(int ow_in = 0; ow_in < OW_BLOCK;)==""\n"
R"==(ow_in++) {)==""\n"
R"==(DOTi(M[c_out][ow_in], f0[c_in],)==""\n"
R"==(V_BLOCK(c_in + c_inner, kw_in + ow_in));)==""\n"
R"==(})==""\n"
R"==(})==""\n"
R"==(})==""\n"
R"==(})==""\n"
R"==(U += U_off(0, COMP_BLOCK, 0, 0);)==""\n"
R"==(})==""\n"
R"==(U += U_off(0, COMP_UNROLL * COMP_BLOCK, 0, 0))==""\n"
R"==(- COMP_UNROLL * U_off(0, COMP_BLOCK, 0, 0);)==""\n"
R"==(})==""\n"
R"==(barrier(CLK_LOCAL_MEM_FENCE);)==""\n"
R"==(})==""\n"
R"==({)==""\n"
R"==(const int M_oc = get_Mcomp_oc0(lx, ly);)==""\n"
R"==(const int M_oh = get_Mcomp_oh0(lx, ly);)==""\n"
R"==(const int M_ow = get_Mcomp_ow0(lx, ly);)==""\n"
R"==(__local DATA_T *M_write = (__local DATA_T *)&V[M_off(0, M_oh, 0, 4)];)==""\n"
R"==(M_write += M_off(M_oc, 0, 0, 1);)==""\n"
R"==(for (int i = 0; i < COMP_OC_COUNT; i++) {)==""\n"
R"==(for (int j = 0; j < M_ow_size; j++) {)==""\n"
R"==(M_write[M_off(i * COMP_OC_STRIDE, 0, M_ow + j, 1)] = M[i][j];)==""\n"
R"==(})==""\n"
R"==(})==""\n"
R"==(barrier(CLK_LOCAL_MEM_FENCE);)==""\n"
R"==(})==""\n"
R"==(if (get_out_ow0(lx, ly) < OW_BLOCK) {)==""\n"
R"==(const int M_oc = get_out_oc0(lx, ly);)==""\n"
R"==(const int M_oh = get_out_oh0(lx, ly);)==""\n"
R"==(const int M_ow = get_out_ow0(lx, ly);)==""\n"
R"==(__local const OUT_BLOCK_DATA_T *M_read)==""\n"
R"==(= (__local OUT_BLOCK_DATA_T *)&V[M_off(0, 0, M_ow, 4)];)==""\n"
R"==(M_read += M_off(M_oc, 0, 0, OUT_TYPE_BLOCK);)==""\n"
R"==(OUT_BLOCK_DATA_T M[COMP_OC_COUNT][WINO_D];)==""\n"
R"==(for (int i = 0; i < COMP_OC_COUNT; i++) {)==""\n"
R"==(for (int j = 0; j < WINO_D; j++) {)==""\n"
R"==(M[i][j] = M_read[M_off()==""\n"
R"==(i * COMP_OC_STRIDE, M_oh + j, 0, OUT_TYPE_BLOCK)];)==""\n"
R"==(})==""\n"
R"==(})==""\n"
R"==(OUT_BLOCK_DATA_T C[COMP_OC_COUNT][WINO_M];)==""\n"
R"==(unroll_for(int i = 0; i < COMP_OC_COUNT; i++) {)==""\n"
R"==(wino_m_transform(C[i], M[i]);)==""\n"
R"==(unroll_for(int j = 0; j < WINO_M; j++) { C[i][j] = C[i][j] * scl; })==""\n"
R"==(})==""\n"
R"==(const int oc = oc0 + M_oc;)==""\n"
R"==(const int ow = ow0 + M_ow;)==""\n"
R"==(const int oh = oh0 + M_oh;)==""\n"
R"==(int dst_idx = dst_off(mb, oc, 0, oh, ow);)==""\n"
R"==(if (WITH_BIAS || WITH_POST_OP) {)==""\n"
R"==(const int c_size = COMP_OC_COUNT * WINO_M * OUT_TYPE_BLOCK;)==""\n"
R"==(if (WITH_BIAS) {)==""\n"
R"==(for_(int oc_block = 0; oc_block < COMP_OC_COUNT; oc_block++))==""\n"
R"==(for_(int oh_block = 0; oh_block < WINO_M; oh_block++))==""\n"
R"==(for (int ow_block = 0; ow_block < OUT_TYPE_BLOCK; ow_block++) {)==""\n"
R"==(const int oc_tmp = oc + COMP_OC_STRIDE * oc_block;)==""\n"
R"==(C[oc_block][oh_block][ow_block])==""\n"
R"==(+= (OC_WO_PADDING % OC_BLOCK == 0)==""\n"
R"==(|| oc_tmp < OC_WO_PADDING))==""\n"
R"==(? bias[oc_tmp])==""\n"
R"==(: DATA_ZERO;)==""\n"
R"==(})==""\n"
R"==(})==""\n"
R"==(DATA_T S[COMP_OC_COUNT][WINO_M][OUT_TYPE_BLOCK];)==""\n"
R"==(if (WITH_SUM) {)==""\n"
R"==(for_(int oc_block = 0; oc_block < COMP_OC_COUNT; oc_block++))==""\n"
R"==(for (int oh_block = 0; oh_block < WINO_M; oh_block++) {)==""\n"
R"==(bool valid_oh = OH % OH_BLOCK == 0 || oh + oh_block < OH;)==""\n"
R"==(for (int ow_block = 0; ow_block < OUT_TYPE_BLOCK;)==""\n"
R"==(ow_block++) {)==""\n"
R"==(bool valid_ow)==""\n"
R"==(= OW % OW_BLOCK == 0 || ow + ow_block < OW;)==""\n"
R"==(S[oc_block][oh_block][ow_block] = valid_oh && valid_ow)==""\n"
R"==(? dst[dst_idx)==""\n"
R"==(+ dst_off(0, oc_block * COMP_OC_STRIDE,)==""\n"
R"==(0, oh_block, ow_block)])==""\n"
R"==(: 0;)==""\n"
R"==(})==""\n"
R"==(})==""\n"
R"==(})==""\n"
R"==(APPLY_POST_OPS_SERIAL(C, DATA_T, S, DATA_T, mb, 1, oc,)==""\n"
R"==(COMP_OC_COUNT, oh, WINO_M, ow, OUT_TYPE_BLOCK, 0, 1, 0, 1);)==""\n"
R"==(})==""\n"
R"==(unroll_for(int oc_off = 0; oc_off < COMP_OC_COUNT; oc_off++) {)==""\n"
R"==(unroll_for(int h_off = 0; h_off < WINO_M; h_off++) {)==""\n"
R"==(if (h_off == 0 || OH % OH_BLOCK == 0 || oh + h_off < OH) {)==""\n"
R"==(unroll_for(int w_off = 0; w_off < OUT_TYPE_BLOCK; w_off++) {)==""\n"
R"==(if (OW % OW_BLOCK == 0 || ow + w_off < OW))==""\n"
R"==(dst[dst_idx)==""\n"
R"==(+ dst_off(0, oc_off * COMP_OC_STRIDE, 0,)==""\n"
R"==(h_off, w_off)])==""\n"
R"==(= (OC_WO_PADDING % OC_BLOCK == 0)==""\n"
R"==(|| oc + oc_off < OC_WO_PADDING))==""\n"
R"==(? C[oc_off][h_off][w_off])==""\n"
R"==(: DATA_ZERO;)==""\n"
R"==(})==""\n"
R"==(})==""\n"
R"==(})==""\n"
R"==(})==""\n"
R"==(})==""\n"
R"==(})==""\n"
R"==()==";
}
}
}
}
}