namespace dnnl {
namespace impl {
namespace gpu {
namespace intel {
namespace ocl {
const char *metrics_discovery_api_header = R"==(/*****************************************************************************\)==""\n"
R"==(Copyright © 2019, Intel Corporation)==""\n"
R"==(Permission is hereby granted, free of charge, to any person obtaining a)==""\n"
R"==(copy of this software and associated documentation files (the "Software"),)==""\n"
R"==(to deal in the Software without restriction, including without limitation)==""\n"
R"==(the rights to use, copy, modify, merge, publish, distribute, sublicense,)==""\n"
R"==(and/or sell copies of the Software, and to permit persons to whom the)==""\n"
R"==(Software is furnished to do so, subject to the following conditions:)==""\n"
R"==(The above copyright notice and this permission notice shall be included)==""\n"
R"==(in all copies or substantial portions of the Software.)==""\n"
R"==(THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND, EXPRESS OR)==""\n"
R"==(IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF MERCHANTABILITY,)==""\n"
R"==(FITNESS FOR A PARTICULAR PURPOSE AND NONINFRINGEMENT. IN NO EVENT SHALL)==""\n"
R"==(THE AUTHORS OR COPYRIGHT HOLDERS BE LIABLE FOR ANY CLAIM, DAMAGES OR OTHER)==""\n"
R"==(LIABILITY, WHETHER IN AN ACTION OF CONTRACT, TORT OR OTHERWISE, ARISING)==""\n"
R"==(FROM, OUT OF OR IN CONNECTION WITH THE SOFTWARE OR THE USE OR OTHER DEALINGS)==""\n"
R"==(IN THE SOFTWARE.)==""\n"
R"==(File Name: metrics_discovery_api.h)==""\n"
R"==(Abstract: Interface for metrics discovery DLL)==""\n"
R"==(Notes:)==""\n"
R"==(\*****************************************************************************/)==""\n"
R"==(#include <stdint.h>)==""\n"
R"==(#ifndef __METRICS_DISCOVERY_H_)==""\n"
R"==(#define __METRICS_DISCOVERY_H_)==""\n"
R"==(#ifdef _MSC_VER)==""\n"
R"==(#define MD_STDCALL __stdcall)==""\n"
R"==(#else)==""\n"
R"==(#define MD_STDCALL)==""\n"
R"==(#endif )==""\n"
R"==(#define MD_API_VERSION_COMBINE_MAJOR_MINOR(version) \)==""\n"
R"==(((uint64_t)(version).MajorNumber << 32 | (uint64_t)(version).MinorNumber))==""\n"
R"==(#define MD_API_VERSION_AT_LEAST(requiredVersion, currentVersion) \)==""\n"
R"==((MD_API_VERSION_COMBINE_MAJOR_MINOR((currentVersion)) \)==""\n"
R"==(> MD_API_VERSION_COMBINE_MAJOR_MINOR((requiredVersion)) \)==""\n"
R"==(|| MD_API_VERSION_COMBINE_MAJOR_MINOR((currentVersion)) \)==""\n"
R"==(== MD_API_VERSION_COMBINE_MAJOR_MINOR( \)==""\n"
R"==((requiredVersion)) \)==""\n"
R"==(&& (currentVersion).BuildNumber \)==""\n"
R"==(>= (requiredVersion).BuildNumber))==""\n"
R"==(#define MD_API_BUILD_NUMBER_CURRENT 176)==""\n"
R"==(namespace MetricsDiscovery {)==""\n"
R"==(typedef enum EMD_API_MAJOR_VERSION {)==""\n"
R"==(MD_API_MAJOR_NUMBER_1 = 1,)==""\n"
R"==(MD_API_MAJOR_NUMBER_CURRENT = MD_API_MAJOR_NUMBER_1,)==""\n"
R"==(MD_API_MAJOR_NUMBER_CEIL = 0xFFFFFFFF)==""\n"
R"==(} MD_API_MAJOR_VERSION;)==""\n"
R"==(typedef enum EMD_API_MINOR_VERSION {)==""\n"
R"==(MD_API_MINOR_NUMBER_0 = 0,)==""\n"
R"==(MD_API_MINOR_NUMBER_1 = 1, )==""\n"
R"==(MD_API_MINOR_NUMBER_2 = 2, )==""\n"
R"==(MD_API_MINOR_NUMBER_3 = 3, )==""\n"
R"==(MD_API_MINOR_NUMBER_4 = 4, )==""\n"
R"==(MD_API_MINOR_NUMBER_5 = 5, )==""\n"
R"==(MD_API_MINOR_NUMBER_6 = 6, )==""\n"
R"==(MD_API_MINOR_NUMBER_7 = 7, )==""\n"
R"==(MD_API_MINOR_NUMBER_8 = 8, )==""\n"
R"==(MD_API_MINOR_NUMBER_9 = 9, )==""\n"
R"==(MD_API_MINOR_NUMBER_10)==""\n"
R"==(= 10, )==""\n"
R"==(MD_API_MINOR_NUMBER_11 = 11, )==""\n"
R"==(MD_API_MINOR_NUMBER_12)==""\n"
R"==(= 12, )==""\n"
R"==(MD_API_MINOR_NUMBER_13 = 13, )==""\n"
R"==(MD_API_MINOR_NUMBER_CURRENT = MD_API_MINOR_NUMBER_13,)==""\n"
R"==(MD_API_MINOR_NUMBER_CEIL = 0xFFFFFFFF)==""\n"
R"==(} MD_API_MINOR_VERSION;)==""\n"
R"==(typedef enum ECompletionCode {)==""\n"
R"==(CC_OK = 0,)==""\n"
R"==(CC_READ_PENDING = 1,)==""\n"
R"==(CC_ALREADY_INITIALIZED = 2,)==""\n"
R"==(CC_STILL_INITIALIZED = 3,)==""\n"
R"==(CC_CONCURRENT_GROUP_LOCKED = 4,)==""\n"
R"==(CC_WAIT_TIMEOUT = 5,)==""\n"
R"==(CC_TRY_AGAIN = 6,)==""\n"
R"==(CC_INTERRUPTED = 7,)==""\n"
R"==(CC_ERROR_INVALID_PARAMETER = 40,)==""\n"
R"==(CC_ERROR_NO_MEMORY = 41,)==""\n"
R"==(CC_ERROR_GENERAL = 42,)==""\n"
R"==(CC_ERROR_FILE_NOT_FOUND = 43,)==""\n"
R"==(CC_ERROR_NOT_SUPPORTED = 44,)==""\n"
R"==(CC_ERROR_ACCESS_DENIED = 45,)==""\n"
R"==(CC_LAST_1_0 = 46)==""\n"
R"==(} TCompletionCode;)==""\n"
R"==(/* Forward declarations */)==""\n"
R"==(class IMetricsDevice_1_0;)==""\n"
R"==(class IMetricsDevice_1_1;)==""\n"
R"==(class IMetricsDevice_1_2;)==""\n"
R"==(class IMetricsDevice_1_5;)==""\n"
R"==(class IMetricsDevice_1_10;)==""\n"
R"==(class IMetricsDevice_1_11;)==""\n"
R"==(class IMetricsDevice_1_13;)==""\n"
R"==(class IOverride_1_2;)==""\n"
R"==(class IConcurrentGroup_1_0;)==""\n"
R"==(class IConcurrentGroup_1_1;)==""\n"
R"==(class IConcurrentGroup_1_5;)==""\n"
R"==(class IConcurrentGroup_1_11;)==""\n"
R"==(class IConcurrentGroup_1_13;)==""\n"
R"==(class IMetricSet_1_0;)==""\n"
R"==(class IMetricSet_1_1;)==""\n"
R"==(class IMetricSet_1_4;)==""\n"
R"==(class IMetricSet_1_5;)==""\n"
R"==(class IMetricSet_1_11;)==""\n"
R"==(class IMetricSet_1_13;)==""\n"
R"==(class IMetric_1_0;)==""\n"
R"==(class IInformation_1_0;)==""\n"
R"==(class IEquation_1_0;)==""\n"
R"==(typedef enum EValueType {)==""\n"
R"==(VALUE_TYPE_UINT32,)==""\n"
R"==(VALUE_TYPE_UINT64,)==""\n"
R"==(VALUE_TYPE_FLOAT,)==""\n"
R"==(VALUE_TYPE_BOOL,)==""\n"
R"==(VALUE_TYPE_CSTRING,)==""\n"
R"==(VALUE_TYPE_BYTEARRAY,)==""\n"
R"==(VALUE_TYPE_UINT32_RANGE,)==""\n"
R"==(VALUE_TYPE_UINT64_RANGE,)==""\n"
R"==(VALUE_TYPE_LAST,)==""\n"
R"==(} TValueType;)==""\n"
R"==(typedef struct SByteArray_1_0 {)==""\n"
R"==(uint32_t Size;)==""\n"
R"==(uint8_t *Data;)==""\n"
R"==(} TByteArray_1_0;)==""\n"
R"==(typedef struct STypedValue_1_0 {)==""\n"
R"==(TValueType ValueType;)==""\n"
R"==(union {)==""\n"
R"==(uint32_t ValueUInt32;)==""\n"
R"==(uint64_t ValueUInt64;)==""\n"
R"==(struct {)==""\n"
R"==(uint32_t Low;)==""\n"
R"==(uint32_t High;)==""\n"
R"==(} ValueUInt64Fields;)==""\n"
R"==(float ValueFloat;)==""\n"
R"==(bool ValueBool;)==""\n"
R"==(char *ValueCString;)==""\n"
R"==(TByteArray_1_0 *ValueByteArray; )==""\n"
R"==(};)==""\n"
R"==(} TTypedValue_1_0;)==""\n"
R"==(typedef struct SGlobalSymbol_1_0 {)==""\n"
R"==(const char *SymbolName;)==""\n"
R"==(TTypedValue_1_0 SymbolTypedValue;)==""\n"
R"==(} TGlobalSymbol_1_0;)==""\n"
R"==(typedef struct SApiVersion_1_0 {)==""\n"
R"==(uint32_t MajorNumber;)==""\n"
R"==(uint32_t MinorNumber;)==""\n"
R"==(uint32_t BuildNumber;)==""\n"
R"==(} TApiVersion_1_0;)==""\n"
R"==(typedef struct SMetricsDeviceParams_1_0 {)==""\n"
R"==(TApiVersion_1_0 Version;)==""\n"
R"==(uint32_t ConcurrentGroupsCount;)==""\n"
R"==(uint32_t GlobalSymbolsCount;)==""\n"
R"==(uint32_t DeltaFunctionsCount;)==""\n"
R"==(uint32_t EquationElementTypesCount;)==""\n"
R"==(uint32_t EquationOperationsCount;)==""\n"
R"==(const char *DeviceName;)==""\n"
R"==(} TMetricsDeviceParams_1_0;)==""\n"
R"==(typedef struct SMetricsDeviceParams_1_2 : public SMetricsDeviceParams_1_0 {)==""\n"
R"==(uint32_t OverrideCount;)==""\n"
R"==(} TMetricsDeviceParams_1_2;)==""\n"
R"==(typedef enum EMetricApiType {)==""\n"
R"==(API_TYPE_IOSTREAM = 0x00000001, )==""\n"
R"==(API_TYPE_DX9 = 0x00000002,)==""\n"
R"==(API_TYPE_DX10 = 0x00000004,)==""\n"
R"==(API_TYPE_DX11 = 0x00000008,)==""\n"
R"==(API_TYPE_OGL = 0x00000010,)==""\n"
R"==(API_TYPE_OGL4_X = 0x00000020,)==""\n"
R"==(API_TYPE_OCL = 0x00000040,)==""\n"
R"==(API_TYPE_MEDIA = 0x00000080, )==""\n"
R"==(API_TYPE_DX12 = 0x00000100,)==""\n"
R"==(API_TYPE_BBSTREAM = 0x00000200, )==""\n"
R"==(API_TYPE_VULKAN = 0x00000400,)==""\n"
R"==(API_TYPE_RESERVED = 0x00000800,)==""\n"
R"==(API_TYPE_ALL = 0xFFFFFFFF)==""\n"
R"==(} TMetricApiType;)==""\n"
R"==(typedef enum EMeasurementType {)==""\n"
R"==(MEASUREMENT_TYPE_SNAPSHOT_IO = 0x00000001,)==""\n"
R"==(MEASUREMENT_TYPE_SNAPSHOT_QUERY = 0x00000002,)==""\n"
R"==(MEASUREMENT_TYPE_DELTA_QUERY = 0x00000004,)==""\n"
R"==(MEASUREMENT_TYPE_ALL = 0x0000FFFF,)==""\n"
R"==(} TMeasurementType;)==""\n"
R"==(typedef enum EMetricUsageFlag {)==""\n"
R"==(USAGE_FLAG_OVERVIEW)==""\n"
R"==(= 0x00000001, )==""\n"
R"==(USAGE_FLAG_INDICATE)==""\n"
R"==(= 0x00000002, )==""\n"
R"==(USAGE_FLAG_CORRELATE)==""\n"
R"==(= 0x00000004, )==""\n"
R"==(USAGE_FLAG_SYSTEM = 0x00000020, )==""\n"
R"==(USAGE_FLAG_FRAME = 0x00000040, )==""\n"
R"==(USAGE_FLAG_BATCH = 0x00000080, )==""\n"
R"==(USAGE_FLAG_DRAW = 0x00000100, )==""\n"
R"==(USAGE_FLAG_TIER_1 = 0x00000400,)==""\n"
R"==(USAGE_FLAG_TIER_2 = 0x00000800,)==""\n"
R"==(USAGE_FLAG_TIER_3 = 0x00001000,)==""\n"
R"==(USAGE_FLAG_TIER_4 = 0x00002000,)==""\n"
R"==(USAGE_FLAG_GLASS_JAW = 0x00004000,)==""\n"
R"==(USAGE_FLAG_ALL = 0x0000FFFF,)==""\n"
R"==(} TMetricUsageFlag;)==""\n"
R"==(typedef enum ESamplingType {)==""\n"
R"==(SAMPLING_TYPE_OA_TIMER = 0x00000001,)==""\n"
R"==(SAMPLING_TYPE_OA_EVENT = 0x00000002,)==""\n"
R"==(SAMPLING_TYPE_GPU_QUERY = 0x00000004,)==""\n"
R"==(SAMPLING_TYPE_DMA_BUFFER)==""\n"
R"==(= 0x00000008, )==""\n"
R"==(SAMPLING_TYPE_OAM_TIMER = 0x00000010,)==""\n"
R"==(SAMPLING_TYPE_ALL = 0x0000FFFF,)==""\n"
R"==(} TSamplingType;)==""\n"
R"==(typedef enum EMetricCategory {)==""\n"
R"==(GPU_RENDER = 0x0001,)==""\n"
R"==(GPU_COMPUTE = 0x0002,)==""\n"
R"==(GPU_MEDIA = 0x0004,)==""\n"
R"==(GPU_GENERIC)==""\n"
R"==(= 0x0008, )==""\n"
R"==(} TMetricCategory;)==""\n"
R"==(typedef enum EIoReadFlag {)==""\n"
R"==(IO_READ_FLAG_DROP_OLD_REPORTS = 0x00000001,)==""\n"
R"==(IO_READ_FLAG_GET_CONTEXT_ID_TAGS = 0x00000002,)==""\n"
R"==(} TIoReadFlag;)==""\n"
R"==(typedef enum EOverrideMode {)==""\n"
R"==(OVERRIDE_MODE_GLOBAL = 0x0001,)==""\n"
R"==(OVERRIDE_MODE_LOCAL = 0x0002,)==""\n"
R"==(} TOverrideMode;)==""\n"
R"==(typedef enum EAdapterCapability {)==""\n"
R"==(ADAPTER_CAPABILITY_UNDEFINED = 0,)==""\n"
R"==(ADAPTER_CAPABILITY_RENDER_SUPPORTED = 1 << 0,)==""\n"
R"==(} TAdapterCapability;)==""\n"
R"==(typedef enum EAdapterType {)==""\n"
R"==(ADAPTER_TYPE_UNDEFINED = 0,)==""\n"
R"==(ADAPTER_TYPE_INTEGRATED,)==""\n"
R"==(ADAPTER_TYPE_DISCRETE,)==""\n"
R"==(} TAdapterType;)==""\n"
R"==(typedef enum EAdapterIdType {)==""\n"
R"==(ADAPTER_ID_TYPE_UNDEFINED = 0,)==""\n"
R"==(ADAPTER_ID_TYPE_LUID,)==""\n"
R"==(ADAPTER_ID_TYPE_MAJOR_MINOR,)==""\n"
R"==(} TAdapterIdType;)==""\n"
R"==(typedef struct SAdapterIdLuid_1_6 {)==""\n"
R"==(uint32_t LowPart;)==""\n"
R"==(int32_t HighPart;)==""\n"
R"==(} TAdapterIdLuid_1_6;)==""\n"
R"==(typedef struct SAdapterIdMajorMinor_1_6 {)==""\n"
R"==(int32_t Major;)==""\n"
R"==(int32_t Minor;)==""\n"
R"==(} TAdapterIdMajorMinor_1_6;)==""\n"
R"==(typedef struct SAdapterId_1_6 {)==""\n"
R"==(TAdapterIdType Type;)==""\n"
R"==(union {)==""\n"
R"==(TAdapterIdLuid_1_6 Luid;)==""\n"
R"==(TAdapterIdMajorMinor_1_6 MajorMinor;)==""\n"
R"==(};)==""\n"
R"==(} TAdapterId_1_6;)==""\n"
R"==(typedef struct SAdapterParams_1_6 {)==""\n"
R"==(const char *ShortName;)==""\n"
R"==(TAdapterId_1_6 SystemId; )==""\n"
R"==(uint32_t VendorId;)==""\n"
R"==(uint32_t SubVendorId;)==""\n"
R"==(uint32_t DeviceId;)==""\n"
R"==(uint32_t Platform;)==""\n"
R"==(uint32_t BusNumber;)==""\n"
R"==(uint32_t DeviceNumber;)==""\n"
R"==(uint32_t FunctionNumber;)==""\n"
R"==(TAdapterType Type; )==""\n"
R"==(uint32_t)==""\n"
R"==(CapabilityMask; )==""\n"
R"==(} TAdapterParams_1_6;)==""\n"
R"==(typedef struct SAdapterParams_1_8 : public SAdapterParams_1_6 {)==""\n"
R"==(uint32_t DomainNumber;)==""\n"
R"==(} TAdapterParams_1_8;)==""\n"
R"==(typedef struct SAdapterParams_1_9 : public SAdapterParams_1_8 {)==""\n"
R"==(uint32_t SubDevicesCount;)==""\n"
R"==(} TAdapterParams_1_9;)==""\n"
R"==(typedef struct SSubDeviceParams_1_9 {)==""\n"
R"==(uint32_t EnginesCount;)==""\n"
R"==(} TSubDeviceParams_1_9;)==""\n"
R"==(typedef enum EEngineIdType { ENGINE_ID_TYPE_CLASS_INSTANCE = 0 } TEngineIdType;)==""\n"
R"==(typedef struct SEngineIdClassInstance_1_9 {)==""\n"
R"==(uint32_t Class;)==""\n"
R"==(uint32_t Instance;)==""\n"
R"==(} TEngineIdClassInstance_1_9;)==""\n"
R"==(typedef struct SEngineId_1_9 {)==""\n"
R"==(TEngineIdType Type;)==""\n"
R"==(union {)==""\n"
R"==(TEngineIdClassInstance_1_9 ClassInstance;)==""\n"
R"==(};)==""\n"
R"==(} TEngineId_1_9;)==""\n"
R"==(typedef struct SEngineParams_1_9 {)==""\n"
R"==(TEngineId_1_9 EngineId;)==""\n"
R"==(} TEngineParams_1_9;)==""\n"
R"==(typedef struct SEngineParams_1_13 : public SEngineParams_1_9 {)==""\n"
R"==(uint32_t GtId;)==""\n"
R"==(uint32_t OaUnit;)==""\n"
R"==(} TEngineParams_1_13;)==""\n"
R"==(typedef struct SAdapterGroupParams_1_6 {)==""\n"
R"==(TApiVersion_1_0 Version;)==""\n"
R"==(uint32_t AdapterCount;)==""\n"
R"==(} TAdapterGroupParams_1_6;)==""\n"
R"==(typedef struct SConcurrentGroupParams_1_0 {)==""\n"
R"==(const char *SymbolName; )==""\n"
R"==(const char *Description; )==""\n"
R"==(uint32_t MeasurementTypeMask;)==""\n"
R"==(uint32_t MetricSetsCount;)==""\n"
R"==(uint32_t IoMeasurementInformationCount;)==""\n"
R"==(uint32_t IoGpuContextInformationCount;)==""\n"
R"==(} TConcurrentGroupParams_1_0;)==""\n"
R"==(typedef struct SConcurrentGroupParams_1_13 : SConcurrentGroupParams_1_0 {)==""\n"
R"==(const char *StreamEventName;)==""\n"
R"==(} TConcurrentGroupParams_1_13;)==""\n"
R"==(typedef struct SOverrideParams_1_2 {)==""\n"
R"==(const char *SymbolName; )==""\n"
R"==(const char *)==""\n"
R"==(Description; )==""\n"
R"==(uint32_t ApiMask;)==""\n"
R"==(uint32_t PlatformMask;)==""\n"
R"==(uint32_t OverrideModeMask;)==""\n"
R"==(} TOverrideParams_1_2;)==""\n"
R"==(typedef struct SSetOverrideParams_1_2 {)==""\n"
R"==(bool Enable;)==""\n"
R"==(} TSetOverrideParams_1_2;)==""\n"
R"==(typedef struct SSetFrequencyOverrideParams_1_2 : SSetOverrideParams_1_2 {)==""\n"
R"==(uint32_t FrequencyMhz;)==""\n"
R"==(uint32_t Pid;)==""\n"
R"==(} TSetFrequencyOverrideParams_1_2;)==""\n"
R"==(typedef struct SSetQueryOverrideParams_1_2 : SSetOverrideParams_1_2 {)==""\n"
R"==(uint32_t Period; )==""\n"
R"==(} TSetQueryOverrideParams_1_2;)==""\n"
R"==(typedef struct SSetDriverOverrideParams_1_2 : SSetOverrideParams_1_2 {)==""\n"
R"==(uint32_t Value;)==""\n"
R"==(} TSetDriverOverrideParams_1_2;)==""\n"
R"==(typedef struct SApiSpecificId_1_0 {)==""\n"
R"==(uint32_t D3D9QueryId; )==""\n"
R"==(uint32_t D3D9Fourcc; )==""\n"
R"==(uint32_t D3D1XQueryId; )==""\n"
R"==(uint32_t D3D1XDevDependentId; )==""\n"
R"==(const char *D3D1XDevDependentName; )==""\n"
R"==(uint32_t OGLQueryIntelId; )==""\n"
R"==(const char *OGLQueryIntelName; )==""\n"
R"==(uint32_t OGLQueryARBTargetId; )==""\n"
R"==(uint32_t OCL; )==""\n"
R"==(uint32_t HwConfigId; )==""\n"
R"==(uint32_t placeholder[1];)==""\n"
R"==(} TApiSpecificId_1_0;)==""\n"
R"==(typedef struct SMetricSetParams_1_0 {)==""\n"
R"==(const char *SymbolName; )==""\n"
R"==(const char *ShortName; )==""\n"
R"==(uint32_t ApiMask;)==""\n"
R"==(uint32_t CategoryMask;)==""\n"
R"==(uint32_t RawReportSize; )==""\n"
R"==(uint32_t QueryReportSize; )==""\n"
R"==(uint32_t MetricsCount;)==""\n"
R"==(uint32_t InformationCount;)==""\n"
R"==(uint32_t ComplementarySetsCount;)==""\n"
R"==(TApiSpecificId_1_0 ApiSpecificId;)==""\n"
R"==(uint32_t PlatformMask;)==""\n"
R"==(} TMetricSetParams_1_0;)==""\n"
R"==(typedef struct SMetricSetParams_1_4 : SMetricSetParams_1_0 {)==""\n"
R"==(uint32_t GtMask;)==""\n"
R"==(} TMetricSetParams_1_4;)==""\n"
R"==(typedef struct SMetricSetParams_1_11 : SMetricSetParams_1_4 {)==""\n"
R"==(const char *AvailabilityEquation;)==""\n"
R"==(} TMetricSetParams_1_11;)==""\n"
R"==(typedef enum EMetricResultType {)==""\n"
R"==(RESULT_UINT32,)==""\n"
R"==(RESULT_UINT64,)==""\n"
R"==(RESULT_BOOL,)==""\n"
R"==(RESULT_FLOAT,)==""\n"
R"==(RESULT_LAST)==""\n"
R"==(} TMetricResultType;)==""\n"
R"==(typedef enum EMetricType {)==""\n"
R"==(METRIC_TYPE_DURATION,)==""\n"
R"==(METRIC_TYPE_EVENT,)==""\n"
R"==(METRIC_TYPE_EVENT_WITH_RANGE,)==""\n"
R"==(METRIC_TYPE_THROUGHPUT,)==""\n"
R"==(METRIC_TYPE_TIMESTAMP,)==""\n"
R"==(METRIC_TYPE_FLAG,)==""\n"
R"==(METRIC_TYPE_RATIO,)==""\n"
R"==(METRIC_TYPE_RAW,)==""\n"
R"==(METRIC_TYPE_LAST)==""\n"
R"==(} TMetricType;)==""\n"
R"==(typedef enum EInformationType {)==""\n"
R"==(INFORMATION_TYPE_REPORT_REASON,)==""\n"
R"==(INFORMATION_TYPE_VALUE,)==""\n"
R"==(INFORMATION_TYPE_FLAG,)==""\n"
R"==(INFORMATION_TYPE_TIMESTAMP,)==""\n"
R"==(INFORMATION_TYPE_CONTEXT_ID_TAG,)==""\n"
R"==(INFORMATION_TYPE_SAMPLE_PHASE,)==""\n"
R"==(INFORMATION_TYPE_GPU_NODE,)==""\n"
R"==(INFORMATION_TYPE_LAST)==""\n"
R"==(} TInformationType;)==""\n"
R"==(typedef enum EReportReason {)==""\n"
R"==(REPORT_REASON_UNDEFINED = 0x0000,)==""\n"
R"==(REPORT_REASON_INTERNAL_TIMER = 0x0001,)==""\n"
R"==(REPORT_REASON_INTERNAL_TRIGGER1 = 0x0002,)==""\n"
R"==(REPORT_REASON_INTERNAL_TRIGGER2 = 0x0004,)==""\n"
R"==(REPORT_REASON_INTERNAL_CONTEXT_SWITCH = 0x0008,)==""\n"
R"==(REPORT_REASON_INTERNAL_GO = 0x0010,)==""\n"
R"==(REPORT_REASON_INTERNAL_FREQUENCY_CHANGE = 0x0020,)==""\n"
R"==(REPORT_REASON_INTERNAL_MMIO_TRIGGER = 0x0040,)==""\n"
R"==(REPORT_REASON_QUERY_DEFAULT = 0x0100,)==""\n"
R"==(REPORT_REASON_QUERY_INTERNAL_RESOLVE = 0x0200,)==""\n"
R"==(REPORT_REASON_QUERY_INTERNAL_CLEAR = 0x0400,)==""\n"
R"==(} TReportReason;)==""\n"
R"==(typedef enum ESamplePhase {)==""\n"
R"==(SAMPLE_PHASE_END,)==""\n"
R"==(SAMPLE_PHASE_BEGIN,)==""\n"
R"==(SAMPLE_PHASE_LAST)==""\n"
R"==(} TSamplePhase;)==""\n"
R"==(typedef enum EInformationGpuNode {)==""\n"
R"==(INFORMATION_GPUNODE_3D = 0, )==""\n"
R"==(INFORMATION_GPUNODE_VIDEO = 1, )==""\n"
R"==(INFORMATION_GPUNODE_BLT = 2, )==""\n"
R"==(INFORMATION_GPUNODE_VE = 3, )==""\n"
R"==(INFORMATION_GPUNODE_VCS2 = 4, )==""\n"
R"==(INFORMATION_GPUNODE_REAL_MAX)==""\n"
R"==(= 5, )==""\n"
R"==(INFORMATION_GPUNODE_LAST)==""\n"
R"==(} TInformationGpuNode;)==""\n"
R"==(typedef enum EHwUnitType {)==""\n"
R"==(HW_UNIT_GPU,)==""\n"
R"==(HW_UNIT_SLICE,)==""\n"
R"==(HW_UNIT_SUBSLICE,)==""\n"
R"==(HW_UNIT_SUBSLICE_BANK,)==""\n"
R"==(HW_UNIT_EU_UNIT,)==""\n"
R"==(HW_UNIT_UNCORE,)==""\n"
R"==(HW_UNIT_DUALSUBSLICE,)==""\n"
R"==(HW_UNIT_LAST)==""\n"
R"==(} THwUnitType;)==""\n"
R"==(typedef enum EDeltaFunctionType {)==""\n"
R"==(DELTA_FUNCTION_NULL = 0,)==""\n"
R"==(DELTA_N_BITS,)==""\n"
R"==(DELTA_BOOL_OR, )==""\n"
R"==(DELTA_BOOL_XOR, )==""\n"
R"==(DELTA_GET_PREVIOUS, )==""\n"
R"==(DELTA_GET_LAST, )==""\n"
R"==(DELTA_NS_TIME, )==""\n"
R"==(DELTA_FUNCTION_LAST_1_0)==""\n"
R"==(} TDeltaFunctionType;)==""\n"
R"==(typedef struct SDeltaFunction_1_0 {)==""\n"
R"==(TDeltaFunctionType FunctionType;)==""\n"
R"==(union {)==""\n"
R"==(uint32_t BitsCount; )==""\n"
R"==(};)==""\n"
R"==(} TDeltaFunction_1_0;)==""\n"
R"==(typedef enum EEquationElementType {)==""\n"
R"==(EQUATION_ELEM_OPERATION, )==""\n"
R"==(EQUATION_ELEM_RD_BITFIELD, )==""\n"
R"==(EQUATION_ELEM_RD_UINT8, )==""\n"
R"==(EQUATION_ELEM_RD_UINT16, )==""\n"
R"==(EQUATION_ELEM_RD_UINT32, )==""\n"
R"==(EQUATION_ELEM_RD_UINT64, )==""\n"
R"==(EQUATION_ELEM_RD_FLOAT, )==""\n"
R"==(EQUATION_ELEM_RD_40BIT_CNTR, )==""\n"
R"==(EQUATION_ELEM_IMM_UINT64, )==""\n"
R"==(EQUATION_ELEM_IMM_FLOAT, )==""\n"
R"==(EQUATION_ELEM_SELF_COUNTER_VALUE, )==""\n"
R"==(EQUATION_ELEM_GLOBAL_SYMBOL, )==""\n"
R"==(EQUATION_ELEM_LOCAL_COUNTER_SYMBOL, )==""\n"
R"==(EQUATION_ELEM_OTHER_SET_COUNTER_SYMBOL, )==""\n"
R"==(EQUATION_ELEM_LOCAL_METRIC_SYMBOL, )==""\n"
R"==(EQUATION_ELEM_OTHER_SET_METRIC_SYMBOL, )==""\n"
R"==(EQUATION_ELEM_INFORMATION_SYMBOL, )==""\n"
R"==(EQUATION_ELEM_STD_NORM_GPU_DURATION, )==""\n"
R"==(EQUATION_ELEM_STD_NORM_EU_AGGR_DURATION, )==""\n"
R"==(EQUATION_ELEM_MASK, )==""\n"
R"==(EQUATION_ELEM_LAST_1_0)==""\n"
R"==(} TEquationElementType;)==""\n"
R"==(typedef enum EEquationOperation {)==""\n"
R"==(EQUATION_OPER_RSHIFT, )==""\n"
R"==(EQUATION_OPER_LSHIFT, )==""\n"
R"==(EQUATION_OPER_AND, )==""\n"
R"==(EQUATION_OPER_OR, )==""\n"
R"==(EQUATION_OPER_XOR, )==""\n"
R"==(EQUATION_OPER_XNOR, )==""\n"
R"==(EQUATION_OPER_AND_L, )==""\n"
R"==(EQUATION_OPER_EQUALS, )==""\n"
R"==(EQUATION_OPER_UADD, )==""\n"
R"==(EQUATION_OPER_USUB, )==""\n"
R"==(EQUATION_OPER_UMUL, )==""\n"
R"==(EQUATION_OPER_UDIV, )==""\n"
R"==(EQUATION_OPER_FADD, )==""\n"
R"==(EQUATION_OPER_FSUB, )==""\n"
R"==(EQUATION_OPER_FMUL, )==""\n"
R"==(EQUATION_OPER_FDIV, )==""\n"
R"==(EQUATION_OPER_UGT, )==""\n"
R"==(EQUATION_OPER_ULT, )==""\n"
R"==(EQUATION_OPER_UGTE, )==""\n"
R"==(EQUATION_OPER_ULTE, )==""\n"
R"==(EQUATION_OPER_FGT, )==""\n"
R"==(EQUATION_OPER_FLT, )==""\n"
R"==(EQUATION_OPER_FGTE, )==""\n"
R"==(EQUATION_OPER_FLTE, )==""\n"
R"==(EQUATION_OPER_UMIN, )==""\n"
R"==(EQUATION_OPER_UMAX, )==""\n"
R"==(EQUATION_OPER_FMIN, )==""\n"
R"==(EQUATION_OPER_FMAX, )==""\n"
R"==(EQUATION_OPER_LAST_1_0)==""\n"
R"==(} TEquationOperation;)==""\n"
R"==(typedef enum EOptionDescriptorType {)==""\n"
R"==(OPTION_DESCRIPTOR_TYPE_DISAGGREGATION)==""\n"
R"==(= 0, )==""\n"
R"==(OPTION_DESCRIPTOR_TYPE_LATENCY = 1, )==""\n"
R"==(OPTION_DESCRIPTOR_TYPE_NORMALIZATION_UTILIZATION)==""\n"
R"==(= 2, )==""\n"
R"==(OPTION_DESCRIPTOR_TYPE_NORMALIZATION_AVERAGE)==""\n"
R"==(= 3, )==""\n"
R"==(OPTION_DESCRIPTOR_TYPE_NORMALIZATION_RATE)==""\n"
R"==(= 4, )==""\n"
R"==(OPTION_DESCRIPTOR_TYPE_NORMALIZATION_BYTE)==""\n"
R"==(= 5, )==""\n"
R"==(OPTION_DESCRIPTOR_TYPE_LAST)==""\n"
R"==(} TOptionDescriptorType;)==""\n"
R"==(typedef enum EDisaggregationMode {)==""\n"
R"==(DISAGGREGATION_MODE_NONE = 0,)==""\n"
R"==(DISAGGREGATION_MODE_XECORE = 1,)==""\n"
R"==(DISAGGREGATION_MODE_L3BANK = 2,)==""\n"
R"==(DISAGGREGATION_MODE_SLICE = 3,)==""\n"
R"==(DISAGGREGATION_MODE_SQIDI = 4,)==""\n"
R"==(DISAGGREGATION_MODE_L3NODE = 5,)==""\n"
R"==(DISAGGREGATION_MODE_COPYENGINE = 6,)==""\n"
R"==(DISAGGREGATION_MODE_LAST)==""\n"
R"==(} TDisaggregationMode;)==""\n"
R"==(typedef enum EQueryMode {)==""\n"
R"==(QUERY_MODE_NONE = 0,)==""\n"
R"==(QUERY_MODE_RENDER = 1,)==""\n"
R"==(QUERY_MODE_COMPUTE = 2,)==""\n"
R"==(QUERY_MODE_GLOBAL = 3,)==""\n"
R"==(QUERY_MODE_GLOBAL_EXTENDED = 4,)==""\n"
R"==(QUERY_MODE_LAST)==""\n"
R"==(} TQueryMode;)==""\n"
R"==(typedef enum EQueryModeMask {)==""\n"
R"==(QUERY_MODE_MASK_NONE = 0x00000000,)==""\n"
R"==(QUERY_MODE_MASK_RENDER = 0x00000001,)==""\n"
R"==(QUERY_MODE_MASK_COMPUTE = 0x00000002,)==""\n"
R"==(QUERY_MODE_MASK_GLOBAL = 0x00000004,)==""\n"
R"==(QUERY_MODE_MASK_GLOBAL_EXTENDED = 0x00000008,)==""\n"
R"==(QUERY_MODE_MASK_ALL = 0xFFFFFFFF)==""\n"
R"==(} TQueryModeMask;)==""\n"
R"==(typedef struct SReadParams_1_0 {)==""\n"
R"==(uint32_t ByteOffset;)==""\n"
R"==(uint32_t BitOffset;)==""\n"
R"==(uint32_t BitsCount;)==""\n"
R"==(uint32_t ByteOffsetExt;)==""\n"
R"==(} TReadParams_1_0;)==""\n"
R"==(typedef struct SEquationElement_1_0 {)==""\n"
R"==(TEquationElementType Type;)==""\n"
R"==(union {)==""\n"
R"==(uint64_t ImmediateUInt64;)==""\n"
R"==(float ImmediateFloat;)==""\n"
R"==(TByteArray_1_0 Mask;)==""\n"
R"==(TEquationOperation Operation;)==""\n"
R"==(TReadParams_1_0 ReadParams;)==""\n"
R"==(};)==""\n"
R"==(char *SymbolName;)==""\n"
R"==(} TEquationElement_1_0;)==""\n"
R"==(class IEquation_1_0 {)==""\n"
R"==(public:)==""\n"
R"==(virtual ~IEquation_1_0();)==""\n"
R"==(virtual uint32_t GetEquationElementsCount(void);)==""\n"
R"==(virtual TEquationElement_1_0 *GetEquationElement(uint32_t index);)==""\n"
R"==(};)==""\n"
R"==(typedef struct SMetricParams_1_0 {)==""\n"
R"==(uint32_t IdInSet; )==""\n"
R"==(uint32_t GroupId; )==""\n"
R"==(const char *SymbolName; )==""\n"
R"==(const char *)==""\n"
R"==(ShortName; )==""\n"
R"==(const char *GroupName; )==""\n"
R"==(const char *LongName; )==""\n"
R"==(const char *DxToOglAlias; )==""\n"
R"==(uint32_t UsageFlagsMask; )==""\n"
R"==(uint32_t ApiMask; )==""\n"
R"==(TMetricResultType ResultType; )==""\n"
R"==(const char *MetricResultUnits; )==""\n"
R"==(TMetricType MetricType; )==""\n"
R"==(uint64_t)==""\n"
R"==(LowWatermark; )==""\n"
R"==(uint64_t)==""\n"
R"==(HighWatermark; )==""\n"
R"==(THwUnitType HwUnitType; )==""\n"
R"==(IEquation_1_0 *)==""\n"
R"==(IoReadEquation; )==""\n"
R"==(IEquation_1_0 *)==""\n"
R"==(QueryReadEquation; )==""\n"
R"==(TDeltaFunction_1_0 DeltaFunction; )==""\n"
R"==(IEquation_1_0 *)==""\n"
R"==(NormEquation; )==""\n"
R"==(IEquation_1_0 *)==""\n"
R"==(MaxValueEquation; )==""\n"
R"==(} TMetricParams_1_0;)==""\n"
R"==(typedef struct SMetricParams_1_13 : public SMetricParams_1_0 {)==""\n"
R"==(uint32_t QueryModeMask; )==""\n"
R"==(} TMetricParams_1_13;)==""\n"
R"==(typedef struct SValidValue_1_13 {)==""\n"
R"==(TValueType ValueType;)==""\n"
R"==(union {)==""\n"
R"==(uint32_t ValueUInt32;)==""\n"
R"==(uint64_t ValueUInt64;)==""\n"
R"==(struct {)==""\n"
R"==(uint32_t Min;)==""\n"
R"==(uint32_t Max;)==""\n"
R"==(} ValueUInt32Range;)==""\n"
R"==(struct {)==""\n"
R"==(uint64_t Min;)==""\n"
R"==(uint64_t Max;)==""\n"
R"==(} ValueUInt64Range;)==""\n"
R"==(};)==""\n"
R"==(} TValidValue_1_13;)==""\n"
R"==(typedef struct SMetricPrototypeParams_1_13 {)==""\n"
R"==(const char *SymbolName; )==""\n"
R"==(const char *)==""\n"
R"==(ShortName; )==""\n"
R"==(const char *GroupName; )==""\n"
R"==(const char *LongName; )==""\n"
R"==(const char *DxToOglAlias; )==""\n"
R"==(uint32_t UsageFlagsMask; )==""\n"
R"==(uint32_t ApiMask; )==""\n"
R"==(TMetricResultType ResultType; )==""\n"
R"==(const char *MetricResultUnits; )==""\n"
R"==(TMetricType MetricType; )==""\n"
R"==(THwUnitType HwUnitType; )==""\n"
R"==(uint32_t OptionDescriptorCount; )==""\n"
R"==(TDisaggregationMode DisaggregationMode; )==""\n"
R"==(uint32_t QueryModeMask; )==""\n"
R"==(} TMetricPrototypeParams_1_13;)==""\n"
R"==(typedef struct SMetricPrototypeOptionDescriptor_1_13 {)==""\n"
R"==(TOptionDescriptorType Type;)==""\n"
R"==(const char *SymbolName;)==""\n"
R"==(TValidValue_1_13 *ValidValues;)==""\n"
R"==(uint32_t ValidValueCount;)==""\n"
R"==(} TMetricPrototypeOptionDescriptor_1_13;)==""\n"
R"==(typedef struct SInformationParams_1_0 {)==""\n"
R"==(uint32_t IdInSet; )==""\n"
R"==(const char *SymbolName; )==""\n"
R"==(const char *ShortName; )==""\n"
R"==(const char *GroupName; )==""\n"
R"==(const char *LongName; )==""\n"
R"==(uint32_t ApiMask; )==""\n"
R"==(TInformationType InfoType; )==""\n"
R"==(const char *InfoUnits; )==""\n"
R"==(IEquation_1_0 *)==""\n"
R"==(IoReadEquation; )==""\n"
R"==(IEquation_1_0 *)==""\n"
R"==(QueryReadEquation; )==""\n"
R"==(TDeltaFunction_1_0 OverflowFunction; )==""\n"
R"==(} TInformationParams_1_0;)==""\n"
R"==(class IInformation_1_0 {)==""\n"
R"==(public:)==""\n"
R"==(virtual ~IInformation_1_0();)==""\n"
R"==(virtual TInformationParams_1_0 *GetParams();)==""\n"
R"==(};)==""\n"
R"==(class IMetric_1_0 {)==""\n"
R"==(public:)==""\n"
R"==(virtual ~IMetric_1_0();)==""\n"
R"==(virtual TMetricParams_1_0 *GetParams();)==""\n"
R"==(};)==""\n"
R"==(class IMetric_1_13 : public IMetric_1_0 {)==""\n"
R"==(public:)==""\n"
R"==(virtual ~IMetric_1_13();)==""\n"
R"==(virtual TMetricParams_1_13 *GetParams();)==""\n"
R"==(};)==""\n"
R"==(class IMetricPrototype_1_13 {)==""\n"
R"==(public:)==""\n"
R"==(virtual ~IMetricPrototype_1_13();)==""\n"
R"==(virtual const TMetricPrototypeParams_1_13 *GetParams(void) const;)==""\n"
R"==(virtual IMetricPrototype_1_13 *Clone(void);)==""\n"
R"==(virtual const TMetricPrototypeOptionDescriptor_1_13 *GetOptionDescriptor()==""\n"
R"==(uint32_t index) const;)==""\n"
R"==(virtual TCompletionCode SetOption(const TOptionDescriptorType optionType,)==""\n"
R"==(const TTypedValue_1_0 *typedValue);)==""\n"
R"==(virtual TCompletionCode ChangeNames(const char *symbolName,)==""\n"
R"==(const char *shortName, const char *longName,)==""\n"
R"==(const char *resultUnits);)==""\n"
R"==(};)==""\n"
R"==(class IMetricEnumerator_1_13 {)==""\n"
R"==(public:)==""\n"
R"==(virtual ~IMetricEnumerator_1_13();)==""\n"
R"==(virtual uint32_t GetMetricPrototypeCount(void);)==""\n"
R"==(virtual IMetricPrototype_1_13 *GetMetricPrototype(const uint32_t index);)==""\n"
R"==(virtual TCompletionCode GetMetricPrototypes(const uint32_t index,)==""\n"
R"==(uint32_t *count, IMetricPrototype_1_13 **metrics);)==""\n"
R"==(virtual TCompletionCode RemoveClonedMetricPrototype()==""\n"
R"==(IMetricPrototype_1_13 *clonedPrototype);)==""\n"
R"==(};)==""\n"
R"==(class IMetricSet_1_0 {)==""\n"
R"==(public:)==""\n"
R"==(virtual ~IMetricSet_1_0();)==""\n"
R"==(virtual TMetricSetParams_1_0 *GetParams(void);)==""\n"
R"==(virtual IMetric_1_0 *GetMetric(uint32_t index);)==""\n"
R"==(virtual IInformation_1_0 *GetInformation(uint32_t index);)==""\n"
R"==(virtual IMetricSet_1_0 *GetComplementaryMetricSet(uint32_t index);)==""\n"
R"==(virtual TCompletionCode Activate(void);)==""\n"
R"==(virtual TCompletionCode Deactivate(void);)==""\n"
R"==(virtual IMetric_1_0 *AddCustomMetric(const char *symbolName,)==""\n"
R"==(const char *shortName, const char *groupName, const char *longName,)==""\n"
R"==(const char *dxToOglAlias, uint32_t usageFlagsMask, uint32_t apiMask,)==""\n"
R"==(TMetricResultType resultType, const char *resultUnits,)==""\n"
R"==(TMetricType metricType, int64_t loWatermark, int64_t hiWatermark,)==""\n"
R"==(THwUnitType hwType, const char *ioReadEquation,)==""\n"
R"==(const char *deltaFunction, const char *queryReadEquation,)==""\n"
R"==(const char *normalizationEquation, const char *maxValueEquation,)==""\n"
R"==(const char *signalName);)==""\n"
R"==(};)==""\n"
R"==(class IMetricSet_1_1 : public IMetricSet_1_0 {)==""\n"
R"==(public:)==""\n"
R"==(virtual ~IMetricSet_1_1();)==""\n"
R"==(virtual TCompletionCode SetApiFiltering(uint32_t apiMask);)==""\n"
R"==(virtual TCompletionCode CalculateMetrics(const uint8_t *rawData,)==""\n"
R"==(uint32_t rawDataSize, TTypedValue_1_0 *out, uint32_t outSize,)==""\n"
R"==(uint32_t *outReportCount, bool enableContextFiltering);)==""\n"
R"==(virtual TCompletionCode CalculateIoMeasurementInformation()==""\n"
R"==(TTypedValue_1_0 *out, uint32_t outSize);)==""\n"
R"==(};)==""\n"
R"==(class IMetricSet_1_4 : public IMetricSet_1_1 {)==""\n"
R"==(public:)==""\n"
R"==(virtual ~IMetricSet_1_4();)==""\n"
R"==(virtual TMetricSetParams_1_4 *GetParams(void);)==""\n"
R"==(};)==""\n"
R"==(class IMetricSet_1_5 : public IMetricSet_1_4 {)==""\n"
R"==(public:)==""\n"
R"==(using IMetricSet_1_1::)==""\n"
R"==(CalculateMetrics; )==""\n"
R"==(virtual IMetricSet_1_5 *GetComplementaryMetricSet(uint32_t index);)==""\n"
R"==(virtual TCompletionCode CalculateMetrics(const uint8_t *rawData,)==""\n"
R"==(uint32_t rawDataSize, TTypedValue_1_0 *out, uint32_t outSize,)==""\n"
R"==(uint32_t *outReportCount, TTypedValue_1_0 *outMaxValues,)==""\n"
R"==(uint32_t outMaxValuesSize);)==""\n"
R"==(};)==""\n"
R"==(class IMetricSet_1_11 : public IMetricSet_1_5 {)==""\n"
R"==(public:)==""\n"
R"==(virtual ~IMetricSet_1_11();)==""\n"
R"==(virtual TMetricSetParams_1_11 *GetParams(void);)==""\n"
R"==(};)==""\n"
R"==(class IMetricSet_1_13 : public IMetricSet_1_11 {)==""\n"
R"==(public:)==""\n"
R"==(virtual ~IMetricSet_1_13();)==""\n"
R"==(virtual TCompletionCode Open();)==""\n"
R"==(virtual TCompletionCode AddMetric(IMetricPrototype_1_13 *metricPrototype);)==""\n"
R"==(virtual TCompletionCode RemoveMetric()==""\n"
R"==(IMetricPrototype_1_13 *metricPrototype);)==""\n"
R"==(virtual TCompletionCode Finalize();)==""\n"
R"==(virtual IMetric_1_13 *GetMetric(uint32_t index);)==""\n"
R"==(using IMetricSet_1_0::)==""\n"
R"==(AddCustomMetric; )==""\n"
R"==(virtual IMetric_1_13 *AddCustomMetric(const char *symbolName,)==""\n"
R"==(const char *shortName, const char *groupName, const char *longName,)==""\n"
R"==(const char *dxToOglAlias, uint32_t usageFlagsMask, uint32_t apiMask,)==""\n"
R"==(TMetricResultType resultType, const char *resultUnits,)==""\n"
R"==(TMetricType metricType, int64_t loWatermark, int64_t hiWatermark,)==""\n"
R"==(THwUnitType hwType, const char *ioReadEquation,)==""\n"
R"==(const char *deltaFunction, const char *queryReadEquation,)==""\n"
R"==(const char *normalizationEquation, const char *maxValueEquation,)==""\n"
R"==(const char *signalName, uint32_t queryModeMask);)==""\n"
R"==(};)==""\n"
R"==(class IConcurrentGroup_1_0 {)==""\n"
R"==(public:)==""\n"
R"==(virtual ~IConcurrentGroup_1_0();)==""\n"
R"==(virtual TConcurrentGroupParams_1_0 *GetParams(void);)==""\n"
R"==(virtual IMetricSet_1_0 *GetMetricSet(uint32_t index);)==""\n"
R"==(virtual TCompletionCode OpenIoStream(IMetricSet_1_0 *metricSet,)==""\n"
R"==(uint32_t processId, uint32_t *nsTimerPeriod,)==""\n"
R"==(uint32_t *oaBufferSize);)==""\n"
R"==(virtual TCompletionCode ReadIoStream()==""\n"
R"==(uint32_t *reportsCount, char *reportData, uint32_t readFlags);)==""\n"
R"==(virtual TCompletionCode CloseIoStream(void);)==""\n"
R"==(virtual TCompletionCode WaitForReports(uint32_t milliseconds);)==""\n"
R"==(virtual IInformation_1_0 *GetIoMeasurementInformation(uint32_t index);)==""\n"
R"==(virtual IInformation_1_0 *GetIoGpuContextInformation(uint32_t index);)==""\n"
R"==(};)==""\n"
R"==(class IConcurrentGroup_1_1 : public IConcurrentGroup_1_0 {)==""\n"
R"==(public:)==""\n"
R"==(virtual IMetricSet_1_1 *GetMetricSet(uint32_t index);)==""\n"
R"==(};)==""\n"
R"==(class IConcurrentGroup_1_3 : public IConcurrentGroup_1_1 {)==""\n"
R"==(public:)==""\n"
R"==(virtual TCompletionCode SetIoStreamSamplingType(TSamplingType type);)==""\n"
R"==(};)==""\n"
R"==(class IConcurrentGroup_1_5 : public IConcurrentGroup_1_3 {)==""\n"
R"==(public:)==""\n"
R"==(virtual IMetricSet_1_5 *GetMetricSet(uint32_t index);)==""\n"
R"==(};)==""\n"
R"==(class IConcurrentGroup_1_11 : public IConcurrentGroup_1_5 {)==""\n"
R"==(public:)==""\n"
R"==(virtual IMetricSet_1_11 *GetMetricSet(uint32_t index);)==""\n"
R"==(};)==""\n"
R"==(class IConcurrentGroup_1_13 : public IConcurrentGroup_1_11 {)==""\n"
R"==(public:)==""\n"
R"==(virtual TConcurrentGroupParams_1_13 *GetParams(void);)==""\n"
R"==(virtual IMetricSet_1_13 *GetMetricSet(uint32_t index);)==""\n"
R"==(virtual IMetricEnumerator_1_13 *GetMetricEnumerator(void);)==""\n"
R"==(virtual IMetricEnumerator_1_13 *GetMetricEnumeratorFromFile()==""\n"
R"==(const char *fileName);)==""\n"
R"==(virtual IMetricSet_1_13 *AddMetricSet()==""\n"
R"==(const char *symbolName, const char *shortName);)==""\n"
R"==(virtual TCompletionCode RemoveMetricSet(IMetricSet_1_13 *metricSet);)==""\n"
R"==(};)==""\n"
R"==(class IOverride_1_2 {)==""\n"
R"==(public:)==""\n"
R"==(virtual ~IOverride_1_2();)==""\n"
R"==(virtual TOverrideParams_1_2 *GetParams(void);)==""\n"
R"==(virtual TCompletionCode SetOverride()==""\n"
R"==(TSetOverrideParams_1_2 *params, uint32_t paramsSize);)==""\n"
R"==(};)==""\n"
R"==(class IMetricsDevice_1_0 {)==""\n"
R"==(public:)==""\n"
R"==(virtual ~IMetricsDevice_1_0();)==""\n"
R"==(virtual TMetricsDeviceParams_1_0 *GetParams(void);)==""\n"
R"==(virtual IConcurrentGroup_1_0 *GetConcurrentGroup(uint32_t index);)==""\n"
R"==(virtual TGlobalSymbol_1_0 *GetGlobalSymbol(uint32_t index);)==""\n"
R"==(virtual TTypedValue_1_0 *GetGlobalSymbolValueByName(const char *name);)==""\n"
R"==(virtual TCompletionCode GetLastError(void);)==""\n"
R"==(virtual TCompletionCode GetGpuCpuTimestamps(uint64_t *gpuTimestampNs,)==""\n"
R"==(uint64_t *cpuTimestampNs, uint32_t *cpuId);)==""\n"
R"==(};)==""\n"
R"==(class IMetricsDevice_1_1 : public IMetricsDevice_1_0 {)==""\n"
R"==(public:)==""\n"
R"==(virtual IConcurrentGroup_1_1 *GetConcurrentGroup(uint32_t index);)==""\n"
R"==(};)==""\n"
R"==(class IMetricsDevice_1_2 : public IMetricsDevice_1_1 {)==""\n"
R"==(public:)==""\n"
R"==(virtual TMetricsDeviceParams_1_2 *GetParams(void);)==""\n"
R"==(virtual IOverride_1_2 *GetOverride(uint32_t index);)==""\n"
R"==(virtual IOverride_1_2 *GetOverrideByName(const char *symbolName);)==""\n"
R"==(};)==""\n"
R"==(class IMetricsDevice_1_5 : public IMetricsDevice_1_2 {)==""\n"
R"==(public:)==""\n"
R"==(virtual IConcurrentGroup_1_5 *GetConcurrentGroup(uint32_t index);)==""\n"
R"==(};)==""\n"
R"==(class IMetricsDevice_1_10 : public IMetricsDevice_1_5 {)==""\n"
R"==(public:)==""\n"
R"==(using IMetricsDevice_1_0::)==""\n"
R"==(GetGpuCpuTimestamps; )==""\n"
R"==(virtual TCompletionCode GetGpuCpuTimestamps(uint64_t *gpuTimestampNs,)==""\n"
R"==(uint64_t *cpuTimestampNs, uint32_t *cpuId,)==""\n"
R"==(uint64_t *correlationIndicatorNs);)==""\n"
R"==(};)==""\n"
R"==(class IMetricsDevice_1_11 : public IMetricsDevice_1_10 {)==""\n"
R"==(public:)==""\n"
R"==(virtual IConcurrentGroup_1_11 *GetConcurrentGroup(uint32_t index);)==""\n"
R"==(};)==""\n"
R"==(class IMetricsDevice_1_13 : public IMetricsDevice_1_11 {)==""\n"
R"==(public:)==""\n"
R"==(virtual IConcurrentGroup_1_13 *GetConcurrentGroup(uint32_t index);)==""\n"
R"==(};)==""\n"
R"==(class IAdapter_1_6 {)==""\n"
R"==(public:)==""\n"
R"==(virtual ~IAdapter_1_6();)==""\n"
R"==(virtual const TAdapterParams_1_6 *GetParams(void) const;)==""\n"
R"==(virtual TCompletionCode Reset();)==""\n"
R"==(virtual TCompletionCode OpenMetricsDevice()==""\n"
R"==(IMetricsDevice_1_5 **metricsDevice);)==""\n"
R"==(virtual TCompletionCode OpenMetricsDeviceFromFile(const char *fileName,)==""\n"
R"==(void *openParams, IMetricsDevice_1_5 **metricsDevice);)==""\n"
R"==(virtual TCompletionCode CloseMetricsDevice()==""\n"
R"==(IMetricsDevice_1_5 *metricsDevice);)==""\n"
R"==(virtual TCompletionCode SaveMetricsDeviceToFile(const char *fileName,)==""\n"
R"==(void *saveParams, IMetricsDevice_1_5 *metricsDevice);)==""\n"
R"==(};)==""\n"
R"==(class IAdapter_1_8 : public IAdapter_1_6 {)==""\n"
R"==(public:)==""\n"
R"==(virtual const TAdapterParams_1_8 *GetParams(void) const;)==""\n"
R"==(};)==""\n"
R"==(class IAdapter_1_9 : public IAdapter_1_8 {)==""\n"
R"==(public:)==""\n"
R"==(virtual const TAdapterParams_1_9 *GetParams(void) const;)==""\n"
R"==(virtual const TSubDeviceParams_1_9 *GetSubDeviceParams()==""\n"
R"==(const uint32_t subDeviceIndex);)==""\n"
R"==(virtual const TEngineParams_1_9 *GetEngineParams()==""\n"
R"==(const uint32_t subDeviceIndex, const uint32_t engineIndex);)==""\n"
R"==(virtual TCompletionCode OpenMetricsSubDevice()==""\n"
R"==(const uint32_t subDeviceIndex, IMetricsDevice_1_5 **metricsDevice);)==""\n"
R"==(virtual TCompletionCode OpenMetricsSubDeviceFromFile()==""\n"
R"==(const uint32_t subDeviceIndex, const char *fileName,)==""\n"
R"==(void *openParams, IMetricsDevice_1_5 **metricsDevice);)==""\n"
R"==(};)==""\n"
R"==(class IAdapter_1_10 : public IAdapter_1_9 {)==""\n"
R"==(public:)==""\n"
R"==(using IAdapter_1_6::OpenMetricsDevice;)==""\n"
R"==(using IAdapter_1_6::OpenMetricsDeviceFromFile;)==""\n"
R"==(using IAdapter_1_9::OpenMetricsSubDevice;)==""\n"
R"==(using IAdapter_1_9::OpenMetricsSubDeviceFromFile;)==""\n"
R"==(virtual TCompletionCode OpenMetricsDevice()==""\n"
R"==(IMetricsDevice_1_10 **metricsDevice);)==""\n"
R"==(virtual TCompletionCode OpenMetricsDeviceFromFile(const char *fileName,)==""\n"
R"==(void *openParams, IMetricsDevice_1_10 **metricsDevice);)==""\n"
R"==(virtual TCompletionCode OpenMetricsSubDevice()==""\n"
R"==(const uint32_t subDeviceIndex, IMetricsDevice_1_10 **metricsDevice);)==""\n"
R"==(virtual TCompletionCode OpenMetricsSubDeviceFromFile()==""\n"
R"==(const uint32_t subDeviceIndex, const char *fileName,)==""\n"
R"==(void *openParams, IMetricsDevice_1_10 **metricsDevice);)==""\n"
R"==(};)==""\n"
R"==(class IAdapter_1_11 : public IAdapter_1_10 {)==""\n"
R"==(public:)==""\n"
R"==(using IAdapter_1_10::OpenMetricsDevice;)==""\n"
R"==(using IAdapter_1_10::OpenMetricsDeviceFromFile;)==""\n"
R"==(using IAdapter_1_10::OpenMetricsSubDevice;)==""\n"
R"==(using IAdapter_1_10::OpenMetricsSubDeviceFromFile;)==""\n"
R"==(virtual TCompletionCode OpenMetricsDevice()==""\n"
R"==(IMetricsDevice_1_11 **metricsDevice);)==""\n"
R"==(virtual TCompletionCode OpenMetricsDeviceFromFile(const char *fileName,)==""\n"
R"==(void *openParams, IMetricsDevice_1_11 **metricsDevice);)==""\n"
R"==(virtual TCompletionCode OpenMetricsSubDevice()==""\n"
R"==(const uint32_t subDeviceIndex, IMetricsDevice_1_11 **metricsDevice);)==""\n"
R"==(virtual TCompletionCode OpenMetricsSubDeviceFromFile()==""\n"
R"==(const uint32_t subDeviceIndex, const char *fileName,)==""\n"
R"==(void *openParams, IMetricsDevice_1_11 **metricsDevice);)==""\n"
R"==(using IAdapter_1_6::SaveMetricsDeviceToFile;)==""\n"
R"==(virtual TCompletionCode SaveMetricsDeviceToFile(const char *fileName,)==""\n"
R"==(void *saveParams, IMetricsDevice_1_11 *metricsDevice,)==""\n"
R"==(const uint32_t minMajorApiVersion,)==""\n"
R"==(const uint32_t minMinorApiVersion);)==""\n"
R"==(};)==""\n"
R"==(class IAdapter_1_13 : public IAdapter_1_11 {)==""\n"
R"==(public:)==""\n"
R"==(using IAdapter_1_11::OpenMetricsDevice;)==""\n"
R"==(using IAdapter_1_11::OpenMetricsDeviceFromFile;)==""\n"
R"==(using IAdapter_1_11::OpenMetricsSubDevice;)==""\n"
R"==(using IAdapter_1_11::OpenMetricsSubDeviceFromFile;)==""\n"
R"==(virtual TCompletionCode OpenMetricsDevice()==""\n"
R"==(IMetricsDevice_1_13 **metricsDevice);)==""\n"
R"==(virtual TCompletionCode OpenMetricsDeviceFromFile(const char *fileName,)==""\n"
R"==(void *openParams, IMetricsDevice_1_13 **metricsDevice);)==""\n"
R"==(virtual TCompletionCode OpenMetricsSubDevice()==""\n"
R"==(const uint32_t subDeviceIndex, IMetricsDevice_1_13 **metricsDevice);)==""\n"
R"==(virtual TCompletionCode OpenMetricsSubDeviceFromFile()==""\n"
R"==(const uint32_t subDeviceIndex, const char *fileName,)==""\n"
R"==(void *openParams, IMetricsDevice_1_13 **metricsDevice);)==""\n"
R"==(virtual const TEngineParams_1_13 *GetEngineParams()==""\n"
R"==(const uint32_t subDeviceIndex, const uint32_t engineIndex);)==""\n"
R"==(};)==""\n"
R"==(class IAdapterGroup_1_6 {)==""\n"
R"==(public:)==""\n"
R"==(virtual ~IAdapterGroup_1_6();)==""\n"
R"==(virtual const TAdapterGroupParams_1_6 *GetParams(void) const;)==""\n"
R"==(virtual IAdapter_1_6 *GetAdapter(uint32_t index);)==""\n"
R"==(virtual TCompletionCode Close();)==""\n"
R"==(};)==""\n"
R"==(class IAdapterGroup_1_8 : public IAdapterGroup_1_6 {)==""\n"
R"==(public:)==""\n"
R"==(virtual IAdapter_1_8 *GetAdapter(uint32_t index);)==""\n"
R"==(};)==""\n"
R"==(class IAdapterGroup_1_9 : public IAdapterGroup_1_8 {)==""\n"
R"==(public:)==""\n"
R"==(virtual IAdapter_1_9 *GetAdapter(uint32_t index);)==""\n"
R"==(};)==""\n"
R"==(class IAdapterGroup_1_10 : public IAdapterGroup_1_9 {)==""\n"
R"==(public:)==""\n"
R"==(virtual IAdapter_1_10 *GetAdapter(uint32_t index);)==""\n"
R"==(};)==""\n"
R"==(class IAdapterGroup_1_11 : public IAdapterGroup_1_10 {)==""\n"
R"==(public:)==""\n"
R"==(virtual IAdapter_1_11 *GetAdapter(uint32_t index);)==""\n"
R"==(};)==""\n"
R"==(class IAdapterGroup_1_13 : public IAdapterGroup_1_11 {)==""\n"
R"==(public:)==""\n"
R"==(virtual IAdapter_1_13 *GetAdapter(uint32_t index);)==""\n"
R"==(};)==""\n"
R"==(using IAdapterGroupLatest = IAdapterGroup_1_13;)==""\n"
R"==(using IAdapterLatest = IAdapter_1_13;)==""\n"
R"==(using IConcurrentGroupLatest = IConcurrentGroup_1_13;)==""\n"
R"==(using IEquationLatest = IEquation_1_0;)==""\n"
R"==(using IInformationLatest = IInformation_1_0;)==""\n"
R"==(using IMetricEnumeratorLatest = IMetricEnumerator_1_13;)==""\n"
R"==(using IMetricLatest = IMetric_1_13;)==""\n"
R"==(using IMetricPrototypeLatest = IMetricPrototype_1_13;)==""\n"
R"==(using IMetricSetLatest = IMetricSet_1_13;)==""\n"
R"==(using IMetricsDeviceLatest = IMetricsDevice_1_13;)==""\n"
R"==(using IOverrideLatest = IOverride_1_2;)==""\n"
R"==(using TAdapterGroupParamsLatest = TAdapterGroupParams_1_6;)==""\n"
R"==(using TAdapterIdLatest = TAdapterId_1_6;)==""\n"
R"==(using TAdapterIdLuidLatest = TAdapterIdLuid_1_6;)==""\n"
R"==(using TAdapterIdMajorMinorLatest = TAdapterIdMajorMinor_1_6;)==""\n"
R"==(using TAdapterParamsLatest = TAdapterParams_1_9;)==""\n"
R"==(using TApiSpecificIdLatest = TApiSpecificId_1_0;)==""\n"
R"==(using TApiVersionLatest = TApiVersion_1_0;)==""\n"
R"==(using TByteArrayLatest = TByteArray_1_0;)==""\n"
R"==(using TConcurrentGroupParamsLatest = TConcurrentGroupParams_1_13;)==""\n"
R"==(using TDeltaFunctionLatest = TDeltaFunction_1_0;)==""\n"
R"==(using TEngineIdClassInstanceLatest = TEngineIdClassInstance_1_9;)==""\n"
R"==(using TEngineIdLatest = TEngineId_1_9;)==""\n"
R"==(using TEngineParamsLatest = TEngineParams_1_13;)==""\n"
R"==(using TEquationElementLatest = TEquationElement_1_0;)==""\n"
R"==(using TGlobalSymbolLatest = TGlobalSymbol_1_0;)==""\n"
R"==(using TInformationParamsLatest = TInformationParams_1_0;)==""\n"
R"==(using TMetricParamsLatest = TMetricParams_1_13;)==""\n"
R"==(using TMetricPrototypeOptionDescriptorLatest)==""\n"
R"==(= TMetricPrototypeOptionDescriptor_1_13;)==""\n"
R"==(using TMetricPrototypeParamsLatest = TMetricPrototypeParams_1_13;)==""\n"
R"==(using TMetricSetParamsLatest = TMetricSetParams_1_11;)==""\n"
R"==(using TMetricsDeviceParamsLatest = TMetricsDeviceParams_1_2;)==""\n"
R"==(using TOverrideParamsLatest = TOverrideParams_1_2;)==""\n"
R"==(using TReadParamsLatest = TReadParams_1_0;)==""\n"
R"==(using TSetDriverOverrideParamsLatest = TSetDriverOverrideParams_1_2;)==""\n"
R"==(using TSetFrequencyOverrideParamsLatest = TSetFrequencyOverrideParams_1_2;)==""\n"
R"==(using TSetOverrideParamsLatest = TSetOverrideParams_1_2;)==""\n"
R"==(using TSetQueryOverrideParamsLatest = TSetQueryOverrideParams_1_2;)==""\n"
R"==(using TSubDeviceParamsLatest = TSubDeviceParams_1_9;)==""\n"
R"==(using TTypedValueLatest = TTypedValue_1_0;)==""\n"
R"==(using TValidValueLatest = TValidValue_1_13;)==""\n"
R"==(#ifdef __cplusplus)==""\n"
R"==(extern "C" {)==""\n"
R"==(#endif)==""\n"
R"==(typedef TCompletionCode(MD_STDCALL *OpenAdapterGroup_fn)()==""\n"
R"==(IAdapterGroupLatest **adapterGroup);)==""\n"
R"==(typedef TCompletionCode(MD_STDCALL *OpenMetricsDevice_fn)()==""\n"
R"==(IMetricsDeviceLatest **metricsDevice);)==""\n"
R"==(typedef TCompletionCode(MD_STDCALL *OpenMetricsDeviceFromFile_fn)()==""\n"
R"==(const char *fileName, void *openParams,)==""\n"
R"==(IMetricsDeviceLatest **metricsDevice);)==""\n"
R"==(typedef TCompletionCode(MD_STDCALL *CloseMetricsDevice_fn)()==""\n"
R"==(IMetricsDeviceLatest *metricsDevice);)==""\n"
R"==(typedef TCompletionCode(MD_STDCALL *SaveMetricsDeviceToFile_fn)()==""\n"
R"==(const char *fileName, void *saveParams,)==""\n"
R"==(IMetricsDeviceLatest *metricsDevice);)==""\n"
R"==(#ifdef __cplusplus)==""\n"
R"==(})==""\n"
R"==(#endif)==""\n"
R"==(}; )==""\n"
R"==(#endif )==""\n"
R"==()==";
}
}
}
}
}