namespace dnnl {
namespace impl {
namespace gpu {
namespace intel {
namespace ocl {
const char *ref_bnorm_kernel = R"==(/*******************************************************************************)==""\n"
R"==(* Copyright 2019-2024 Intel Corporation)==""\n"
R"==(*)==""\n"
R"==(* Licensed under the Apache License, Version 2.0 (the "License");)==""\n"
R"==(* you may not use this file except in compliance with the License.)==""\n"
R"==(* You may obtain a copy of the License at)==""\n"
R"==(*)==""\n"
R"==(* http:)==""\n"
R"==(*)==""\n"
R"==(* Unless required by applicable law or agreed to in writing, software)==""\n"
R"==(* distributed under the License is distributed on an "AS IS" BASIS,)==""\n"
R"==(* WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.)==""\n"
R"==(* See the License for the specific language governing permissions and)==""\n"
R"==(* limitations under the License.)==""\n"
R"==(*******************************************************************************/)==""\n"
R"==(#include "gpu/intel/ocl/dispatch.h")==""\n"
R"==(#include "gpu/intel/ocl/ocl_types.h")==""\n"
R"==(int reduce_index(int x[5]) {)==""\n"
R"==(int dim[5] = {MB, IC, ID, IH, IW};)==""\n"
R"==(dim[REDUCE_DIM_IDX] = 1;)==""\n"
R"==(return x[0] * (dim[2] * dim[3] * dim[4]) + x[2] * (dim[3] * dim[4]))==""\n"
R"==(+ x[3] * dim[4] + x[4];)==""\n"
R"==(})==""\n"
R"==(#if IS_FWD == 1)==""\n"
R"==(#if CALCULATE_STATS == 1)==""\n"
R"==(NAMED_KERNEL_ATTR(CALC))==""\n"
R"==(__kernel void calculate_mean(__global DATA_T *src, __global float *mean) {)==""\n"
R"==(int x[5];)==""\n"
R"==(x[0] = GWS_GET_STAT_MB();)==""\n"
R"==(x[1] = GWS_GET_STAT_IC();)==""\n"
R"==(x[2] = GWS_GET_STAT_ID();)==""\n"
R"==(x[3] = GWS_GET_STAT_IH();)==""\n"
R"==(x[4] = GWS_GET_STAT_IW();)==""\n"
R"==(float sum = 0;)==""\n"
R"==(for (int i = 0; i < REDUCE_DIM; i++) {)==""\n"
R"==(x[REDUCE_DIM_IDX] = i;)==""\n"
R"==(sum += TO_DEF_ACC_DATA_T(src[SRC_OFF(x[0], x[1], x[2], x[3], x[4])]);)==""\n"
R"==(})==""\n"
R"==(x[REDUCE_DIM_IDX] = 0;)==""\n"
R"==(int reduce_idx = reduce_index(x);)==""\n"
R"==(mean[reduce_idx * IC + x[1]] = sum;)==""\n"
R"==(})==""\n"
R"==(NAMED_KERNEL_ATTR(CALC))==""\n"
R"==(__kernel void calculate_variance()==""\n"
R"==(__global DATA_T *src, __global float *mean, __global float *variance) {)==""\n"
R"==(int x[5];)==""\n"
R"==(x[0] = GWS_GET_STAT_MB();)==""\n"
R"==(x[1] = GWS_GET_STAT_IC();)==""\n"
R"==(x[2] = GWS_GET_STAT_ID();)==""\n"
R"==(x[3] = GWS_GET_STAT_IH();)==""\n"
R"==(x[4] = GWS_GET_STAT_IW();)==""\n"
R"==(float sum = 0;)==""\n"
R"==(for (int i = 0; i < REDUCE_DIM; i++) {)==""\n"
R"==(x[REDUCE_DIM_IDX] = i;)==""\n"
R"==(DEF_ACC_DATA_T v0)==""\n"
R"==(= TO_DEF_ACC_DATA_T(src[SRC_OFF(x[0], x[1], x[2], x[3], x[4])]))==""\n"
R"==(- mean[x[1]];)==""\n"
R"==(sum += v0 * v0;)==""\n"
R"==(})==""\n"
R"==(variance += MB * ID * IH * IW * IC / REDUCE_DIM;)==""\n"
R"==(x[REDUCE_DIM_IDX] = 0;)==""\n"
R"==(int reduce_idx = reduce_index(x);)==""\n"
R"==(variance[reduce_idx * IC + x[1]] = sum;)==""\n"
R"==(})==""\n"
R"==(NAMED_KERNEL_ATTR(REDUCE))==""\n"
R"==(__kernel void reduce_mean(__global float *reduce_temp, __global float *mean) {)==""\n"
R"==(const int c = GWS_GET_REDUCE_STAT_IC();)==""\n"
R"==(reduce_temp += c;)==""\n"
R"==(float sum = 0.0f;)==""\n"
R"==(int reduce_size = MB * ID * IH * IW / REDUCE_DIM;)==""\n"
R"==(for (int i = 0; i < reduce_size; i++) {)==""\n"
R"==(sum += reduce_temp[i * IC];)==""\n"
R"==(})==""\n"
R"==(mean[c] = sum / (MB * ID * IH * IW);)==""\n"
R"==(})==""\n"
R"==(NAMED_KERNEL_ATTR(REDUCE))==""\n"
R"==(__kernel void reduce_variance()==""\n"
R"==(__global float *reduce_temp, __global float *variance) {)==""\n"
R"==(const int c = GWS_GET_REDUCE_STAT_IC();)==""\n"
R"==(#if SAVE_STATS == 0)==""\n"
R"==(variance += IC;)==""\n"
R"==(#endif)==""\n"
R"==(float sum = 0.0f;)==""\n"
R"==(int reduce_size = MB * ID * IH * IW / REDUCE_DIM;)==""\n"
R"==(reduce_temp += reduce_size * IC + c;)==""\n"
R"==(for (int i = 0; i < reduce_size; i++))==""\n"
R"==(sum += reduce_temp[i * IC];)==""\n"
R"==(variance[c] = sum / (MB * ID * IH * IW);)==""\n"
R"==(})==""\n"
R"==(#endif)==""\n"
R"==(KERNEL_ATTR)==""\n"
R"==(__kernel void ref_bnorm_fwd(__global DATA_T *src, __global float *mean,)==""\n"
R"==(__global float *variance, __global DATA_T *dst, __global float *scale,)==""\n"
R"==(__global float *shift, __global char *ws, float eps,)==""\n"
R"==(__global DATA_T *src_add, float relu_alpha) {)==""\n"
R"==(const int n = GWS_GET_MB();)==""\n"
R"==(const int c = GWS_GET_IC();)==""\n"
R"==(const int d = GWS_GET_ID();)==""\n"
R"==(const int h = GWS_GET_IH();)==""\n"
R"==(const int w = GWS_GET_IW();)==""\n"
R"==(#if USE_SCALE == 1)==""\n"
R"==(float sm = scale[c];)==""\n"
R"==(#else)==""\n"
R"==(float sm = 1;)==""\n"
R"==(#endif)==""\n"
R"==(#if USE_SHIFT == 1)==""\n"
R"==(float sv = shift[c];)==""\n"
R"==(#else)==""\n"
R"==(float sv = 0;)==""\n"
R"==(#endif)==""\n"
R"==(#if SAVE_STATS == 0 && CALCULATE_STATS == 1)==""\n"
R"==(variance += IC;)==""\n"
R"==(#endif)==""\n"
R"==(float v_mean = mean[c];)==""\n"
R"==(float v_variance = variance[c];)==""\n"
R"==(const int off = SRC_OFF(n, c, d, h, w);)==""\n"
R"==(float v0 = TO_DEF_ACC_DATA_T(src[off]);)==""\n"
R"==(float sqrt_variance = 1.0f / sqrt(v_variance + eps);)==""\n"
R"==(float bn_res = sm * (v0 - v_mean) * sqrt_variance + sv;)==""\n"
R"==(#if FUSE_BN_ADD_RELU == 1)==""\n"
R"==(bn_res += TO_DEF_ACC_DATA_T(src_add[off]);)==""\n"
R"==(#endif)==""\n"
R"==(#if FUSE_BN_RELU == 1)==""\n"
R"==(if (bn_res <= 0) {)==""\n"
R"==(bn_res = 0;)==""\n"
R"==(#if IS_TRAINING == 1)==""\n"
R"==(ws[off] = 0;)==""\n"
R"==(} else {)==""\n"
R"==(ws[off] = -1;)==""\n"
R"==(#endif)==""\n"
R"==(})==""\n"
R"==(#endif)==""\n"
R"==(#if WITH_RELU)==""\n"
R"==(#if WITH_LEAKY_RELU)==""\n"
R"==(if (bn_res < 0) { bn_res *= relu_alpha; })==""\n"
R"==(#else)==""\n"
R"==(bn_res = max(bn_res, 0.0f);)==""\n"
R"==(#endif )==""\n"
R"==(#endif )==""\n"
R"==(dst[off] = TO_DATA_T(bn_res);)==""\n"
R"==(})==""\n"
R"==(#endif)==""\n"
R"==(#if IS_BWD == 1)==""\n"
R"==(NAMED_KERNEL_ATTR(CALC))==""\n"
R"==(__kernel void calculate_stats(__global DATA_T *src, __global float *mean,)==""\n"
R"==(__global DATA_T *diff_dst, __global char *ws,)==""\n"
R"==(__global float *reduce_temp) {)==""\n"
R"==(float diff_gamma = 0;)==""\n"
R"==(float diff_beta = 0;)==""\n"
R"==(int x[5];)==""\n"
R"==(x[0] = GWS_GET_STAT_MB();)==""\n"
R"==(x[1] = GWS_GET_STAT_IC();)==""\n"
R"==(x[2] = GWS_GET_STAT_ID();)==""\n"
R"==(x[3] = GWS_GET_STAT_IH();)==""\n"
R"==(x[4] = GWS_GET_STAT_IW();)==""\n"
R"==(for (int i = 0; i < REDUCE_DIM; i++) {)==""\n"
R"==(x[REDUCE_DIM_IDX] = i;)==""\n"
R"==(int off = SRC_OFF(x[0], x[1], x[2], x[3], x[4]);)==""\n"
R"==(float dd = CONVERT_FLOAT_T(diff_dst[off]);)==""\n"
R"==(#if FUSE_BN_RELU == 1)==""\n"
R"==(if (!ws[off]) dd = 0;)==""\n"
R"==(#endif)==""\n"
R"==(diff_gamma += (CONVERT_FLOAT_T(src[off]) - mean[x[1]]) * dd;)==""\n"
R"==(diff_beta += dd;)==""\n"
R"==(})==""\n"
R"==(int ss_off = MB * ID * IH * IW * IC / REDUCE_DIM;)==""\n"
R"==(x[REDUCE_DIM_IDX] = 0;)==""\n"
R"==(int reduce_idx = reduce_index(x);)==""\n"
R"==(reduce_temp[reduce_idx * IC + x[1]] = diff_gamma;)==""\n"
R"==(reduce_temp[ss_off + reduce_idx * IC + x[1]] = diff_beta;)==""\n"
R"==(})==""\n"
R"==(NAMED_KERNEL_ATTR(REDUCE))==""\n"
R"==(__kernel void reduce_stats(__global float *reduce_temp,)==""\n"
R"==(__global float *diff_scale, __global float *diff_shift,)==""\n"
R"==(__global float *variance, float eps) {)==""\n"
R"==(const int c = GWS_GET_REDUCE_STAT_IC();)==""\n"
R"==(float diff_gamma = 0.0f;)==""\n"
R"==(float diff_beta = 0.0f;)==""\n"
R"==(int reduce_size = MB * ID * IH * IW / REDUCE_DIM;)==""\n"
R"==(for (int i = 0; i < reduce_size; i++) {)==""\n"
R"==(diff_gamma += reduce_temp[c + i * IC];)==""\n"
R"==(diff_beta += reduce_temp[IC * reduce_size + c + i * IC];)==""\n"
R"==(})==""\n"
R"==(float sqrt_variance = 1.0f / sqrt(variance[c] + eps);)==""\n"
R"==(diff_scale[c] = diff_gamma * sqrt_variance;)==""\n"
R"==(#if USE_SHIFT == 1)==""\n"
R"==(diff_shift[c] = diff_beta;)==""\n"
R"==(#else)==""\n"
R"==(diff_shift[IC * reduce_size + c] = diff_beta;)==""\n"
R"==(#endif)==""\n"
R"==(})==""\n"
R"==(KERNEL_ATTR)==""\n"
R"==(__kernel void ref_bnorm_bwd(__global DATA_T *src, __global float *mean,)==""\n"
R"==(__global float *variance, __global DATA_T *diff_dst,)==""\n"
R"==(__global float *scale, __global char *ws, __global DATA_T *diff_src,)==""\n"
R"==(__global float *diff_scale, __global float *diff_shift, float eps,)==""\n"
R"==(__global DATA_T *diff_src_add) {)==""\n"
R"==(const int n = GWS_GET_MB();)==""\n"
R"==(const int c = GWS_GET_IC();)==""\n"
R"==(const int d = GWS_GET_ID();)==""\n"
R"==(const int h = GWS_GET_IH();)==""\n"
R"==(const int w = GWS_GET_IW();)==""\n"
R"==(float v_variance = variance[c];)==""\n"
R"==(float sqrt_variance = 1.0f / sqrt(v_variance + eps);)==""\n"
R"==(#if USE_SCALE == 1)==""\n"
R"==(float gamma = scale[c];)==""\n"
R"==(#else)==""\n"
R"==(float gamma = 1;)==""\n"
R"==(#endif)==""\n"
R"==(#if CALCULATE_STATS == 1)==""\n"
R"==(float v_mean = mean[c];)==""\n"
R"==(float diff_gamma = diff_scale[c];)==""\n"
R"==(#if USE_SHIFT == 1)==""\n"
R"==(float diff_beta = diff_shift[c];)==""\n"
R"==(#else)==""\n"
R"==(int reduce_size = MB * ID * IH * IW / REDUCE_DIM;)==""\n"
R"==(float diff_beta = diff_shift[reduce_size * IC + c];)==""\n"
R"==(#endif )==""\n"
R"==(#endif)==""\n"
R"==(const int off = SRC_OFF(n, c, d, h, w);)==""\n"
R"==(float dd = TO_DEF_ACC_DATA_T(diff_dst[off]);)==""\n"
R"==(#if FUSE_BN_RELU == 1)==""\n"
R"==(if (!ws[off]) dd = 0;)==""\n"
R"==(#if FUSE_BN_ADD_RELU == 1)==""\n"
R"==(diff_src_add[off] = TO_DATA_T(dd);)==""\n"
R"==(#endif)==""\n"
R"==(#endif)==""\n"
R"==(float v_diff_src = dd;)==""\n"
R"==(#if CALCULATE_STATS == 1)==""\n"
R"==(v_diff_src -= diff_beta / (MB * ID * IH * IW))==""\n"
R"==(+ (CONVERT_FLOAT_T(src[off]) - v_mean) * diff_gamma * sqrt_variance)==""\n"
R"==(/ (MB * ID * IH * IW);)==""\n"
R"==(#endif)==""\n"
R"==(v_diff_src *= gamma * sqrt_variance;)==""\n"
R"==(diff_src[off] = TO_DATA_T(v_diff_src);)==""\n"
R"==(})==""\n"
R"==(#endif)==""\n"
R"==()==";
}
}
}
}
}