namespace dnnl {
namespace impl {
namespace gpu {
namespace intel {
namespace ocl {
const char *ref_gemm_kernel = R"==(/*******************************************************************************)==""\n"
R"==(* Copyright 2019-2024 Intel Corporation)==""\n"
R"==(*)==""\n"
R"==(* Licensed under the Apache License, Version 2.0 (the "License");)==""\n"
R"==(* you may not use this file except in compliance with the License.)==""\n"
R"==(* You may obtain a copy of the License at)==""\n"
R"==(*)==""\n"
R"==(* http:)==""\n"
R"==(*)==""\n"
R"==(* Unless required by applicable law or agreed to in writing, software)==""\n"
R"==(* distributed under the License is distributed on an "AS IS" BASIS,)==""\n"
R"==(* WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.)==""\n"
R"==(* See the License for the specific language governing permissions and)==""\n"
R"==(* limitations under the License.)==""\n"
R"==(*******************************************************************************/)==""\n"
R"==(#include "gpu/intel/ocl/gemm/ocl_gemm_attrs.h")==""\n"
R"==(#include "gpu/intel/ocl/ocl_post_ops.h")==""\n"
R"==(#include "gpu/intel/ocl/ocl_types.h")==""\n"
R"==(void get_strides(int mask, long dim0, long dim1, long dim2, long *str0,)==""\n"
R"==(long *str1, long *str2) {)==""\n"
R"==(int ndims = dim0 > 1 ? 3 : 2;)==""\n"
R"==(long dims[3];)==""\n"
R"==(dims[0] = (ndims > 2 && mask & (1 << 0)) ? dim0 : 1;)==""\n"
R"==(dims[1] = mask & (1 << (ndims - 1)) ? dim1 : 1;)==""\n"
R"==(dims[2] = mask & (1 << (ndims - 2)) ? dim2 : 1;)==""\n"
R"==(*str0 = dims[0] == 1 ? 0 : dims[1] * dims[2];)==""\n"
R"==(*str1 = dims[1] == 1 ? 0 : 1;)==""\n"
R"==(*str2 = dims[2] == 1 ? 0 : dims[1];)==""\n"
R"==(})==""\n"
R"==(__kernel void ref_gemm(__global A_DATA_T *a, __global B_DATA_T *b,)==""\n"
R"==(__global C_DATA_T *c, __global BIA_DATA_T *bias, long offset_a0,)==""\n"
R"==(long offset_b0, long offset_c0, long offset_bias0, int transa,)==""\n"
R"==(int transb, long MB, long M, long N, long K, long stride_a,)==""\n"
R"==(long stride_b, long stride_c, long lda, long ldb, long ldc,)==""\n"
R"==(float eltwise_alpha, float eltwise_beta, float eltwise_scale,)==""\n"
R"==(int bias_mask, __global int *ao, __global int *bo, __global int *c0,)==""\n"
R"==(int c0_mask, __global float *scales, long scale_stride, float beta) {)==""\n"
R"==(int n = get_global_id(1);)==""\n"
R"==(int mb = get_global_id(2);)==""\n"
R"==(#if WITH_BIAS)==""\n"
R"==(bias += offset_bias0;)==""\n"
R"==(long b_strides[3];)==""\n"
R"==(get_strides()==""\n"
R"==(bias_mask, MB, M, N, &b_strides[0], &b_strides[1], &b_strides[2]);)==""\n"
R"==(#endif)==""\n"
R"==(a += offset_a0;)==""\n"
R"==(b += offset_b0;)==""\n"
R"==(c += offset_c0;)==""\n"
R"==(#if WITH_DST_ZPOINTS)==""\n"
R"==(long c0_strides[3];)==""\n"
R"==(get_strides()==""\n"
R"==(c0_mask, MB, M, N, &c0_strides[0], &c0_strides[1], &c0_strides[2]);)==""\n"
R"==(#endif)==""\n"
R"==(for (long m = 0; m < M; ++m) {)==""\n"
R"==(ACC_DATA_T acc = 0;)==""\n"
R"==(for (long k = 0; k < K; ++k) {)==""\n"
R"==(long off_a = mb * stride_a + (transa ? m * lda + k : k * lda + m);)==""\n"
R"==(long off_b = mb * stride_b + (transb ? k * ldb + n : n * ldb + k);)==""\n"
R"==(acc += TO_ACC(A_TO_REF(a[off_a]) - ATTR_A0))==""\n"
R"==(* TO_ACC(B_TO_REF(b[off_b]) - ATTR_B0);)==""\n"
R"==(})==""\n"
R"==(long off_c = mb * stride_c + n * ldc + m;)==""\n"
R"==(#if WITH_BIAS || NON_DEFAULT_ATTRS)==""\n"
R"==(POST_OP_DATA_T temp = (POST_OP_DATA_T)acc;)==""\n"
R"==(#if WITH_BIAS)==""\n"
R"==(long off_bias = mb * b_strides[0] + m * b_strides[1] + n * b_strides[2];)==""\n"
R"==(temp += BIA_TO_REF(bias[off_bias]);)==""\n"
R"==(#endif)==""\n"
R"==(#if WITH_SCALES)==""\n"
R"==(temp *= scales[scale_stride * n];)==""\n"
R"==(#endif)==""\n"
R"==(#if WITH_SUM)==""\n"
R"==(temp += (POST_OP_DATA_T)(beta * C_TO_REF(c[off_c]));)==""\n"
R"==(#endif)==""\n"
R"==(#if WITH_ELTWISE)==""\n"
R"==(temp = fwd_eltwise(temp, eltwise_alpha, eltwise_beta, eltwise_scale);)==""\n"
R"==(#endif)==""\n"
R"==(#if WITH_DST_ZPOINTS)==""\n"
R"==(long off_c0)==""\n"
R"==(= mb * c0_strides[0] + m * c0_strides[1] + n * c0_strides[2];)==""\n"
R"==(temp += c0[off_c0];)==""\n"
R"==(#endif)==""\n"
R"==(c[off_c] = TO_C(temp);)==""\n"
R"==(#else)==""\n"
R"==(c[off_c] = TO_C(acc);)==""\n"
R"==(#endif)==""\n"
R"==(})==""\n"
R"==(})==""\n"
R"==()==";
}
}
}
}
}