namespace dnnl {
namespace impl {
namespace gpu {
namespace intel {
namespace ocl {
const char *ref_inner_product_kernel = R"==(/*******************************************************************************)==""\n"
R"==(* Copyright 2019-2024 Intel Corporation)==""\n"
R"==(*)==""\n"
R"==(* Licensed under the Apache License, Version 2.0 (the "License");)==""\n"
R"==(* you may not use this file except in compliance with the License.)==""\n"
R"==(* You may obtain a copy of the License at)==""\n"
R"==(*)==""\n"
R"==(* http:)==""\n"
R"==(*)==""\n"
R"==(* Unless required by applicable law or agreed to in writing, software)==""\n"
R"==(* distributed under the License is distributed on an "AS IS" BASIS,)==""\n"
R"==(* WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.)==""\n"
R"==(* See the License for the specific language governing permissions and)==""\n"
R"==(* limitations under the License.)==""\n"
R"==(*******************************************************************************/)==""\n"
R"==(#include "gpu/intel/ocl/dispatch.h")==""\n"
R"==(#include "gpu/intel/ocl/ocl_post_ops.h")==""\n"
R"==(#include "gpu/intel/ocl/ocl_types.h")==""\n"
R"==(#if IS_FWD == 1)==""\n"
R"==(KERNEL_ATTR)==""\n"
R"==(__kernel void ref_inner_product_fwd(__global SRC_DATA_T *src,)==""\n"
R"==(__global WEI_DATA_T *wei, __global BIA_DATA_T *bias,)==""\n"
R"==(__global DST_DATA_T *dst POST_OP_ARGS, __global float *src_scales,)==""\n"
R"==(__global float *wei_scales, __global float *dst_scales) {)==""\n"
R"==(const int mb = GWS_GET_MB();)==""\n"
R"==(const int oc = GWS_GET_OC();)==""\n"
R"==(ACC_DATA_T d = 0;)==""\n"
R"==(#if HAS_SPATIAL == 1)==""\n"
R"==(for (int ic = 0; ic < IC; ++ic))==""\n"
R"==(for (int kd = 0; kd < KD; ++kd))==""\n"
R"==(for (int kh = 0; kh < KH; ++kh))==""\n"
R"==(for (int kw = 0; kw < KW; ++kw) {)==""\n"
R"==(const uint src_off = SRC_OFF(mb, ic, kd, kh, kw);)==""\n"
R"==(const uint wei_off = WEI_OFF(0, oc, ic, kd, kh, kw);)==""\n"
R"==(#else)==""\n"
R"==(for (int ic = 0; ic < IC_TOTAL; ++ic) {)==""\n"
R"==(const uint src_off = mb * IC_TOTAL + ic;)==""\n"
R"==(const uint wei_off = oc * IC_TOTAL + ic;)==""\n"
R"==(#endif)==""\n"
R"==(d += SRC_TO_REF(src[src_off]) * WEI_TO_REF(wei[wei_off]);)==""\n"
R"==(})==""\n"
R"==(DATA_T tmp = d;)==""\n"
R"==(#if WITH_SRC_SCALES)==""\n"
R"==(tmp *= src_scales[0];)==""\n"
R"==(#endif)==""\n"
R"==(#if WITH_WEI_SCALES)==""\n"
R"==(#if WEI_SCALES_MASK == 0)==""\n"
R"==(tmp *= wei_scales[0];)==""\n"
R"==(#else)==""\n"
R"==(tmp *= wei_scales[oc];)==""\n"
R"==(#endif)==""\n"
R"==(#endif)==""\n"
R"==(#if WITH_BIAS)==""\n"
R"==(tmp += BIA_TO_REF(bias[oc]);)==""\n"
R"==(#endif)==""\n"
R"==(float dest_data;)==""\n"
R"==(#if WITH_SUM)==""\n"
R"==(dest_data = DST_TO_REF(dst[mb * OC + oc]);)==""\n"
R"==(#endif)==""\n"
R"==(APPLY_POST_OPS_SERIAL_BINARY_2D()==""\n"
R"==(tmp, DATA_T, dest_data, float, mb, 1, oc, 1);)==""\n"
R"==(#if WITH_DST_SCALES)==""\n"
R"==(tmp /= dst_scales[0];)==""\n"
R"==(#endif)==""\n"
R"==(dst[mb * OC + oc] = TO_DST(tmp);)==""\n"
R"==(})==""\n"
R"==(#endif)==""\n"
R"==(#if IS_BWD_D == 1)==""\n"
R"==(KERNEL_ATTR)==""\n"
R"==(__kernel void ref_inner_product_bwd_data(__global SRC_DATA_T *diff_src,)==""\n"
R"==(__global WEI_DATA_T *wei, __global DST_DATA_T *diff_dst) {)==""\n"
R"==(const int mb = GWS_GET_MB_IC() / IC;)==""\n"
R"==(const int ic = GWS_GET_MB_IC() % IC;)==""\n"
R"==(const int kd = GWS_GET_KD();)==""\n"
R"==(const int kh = GWS_GET_KH();)==""\n"
R"==(const int kw = GWS_GET_KW();)==""\n"
R"==(float ds = 0.0f;)==""\n"
R"==(for (int oc = 0; oc < OC; ++oc) {)==""\n"
R"==(const uint diff_dst_off = DST_OFF(mb, oc, 0, 0, 0);)==""\n"
R"==(const uint wei_off = WEI_OFF(0, oc, ic, kd, kh, kw);)==""\n"
R"==(ds += DST_TO_REF(diff_dst[diff_dst_off]) * WEI_TO_REF(wei[wei_off]);)==""\n"
R"==(})==""\n"
R"==(const uint diff_src_off = SRC_OFF(mb, ic, kd, kh, kw);)==""\n"
R"==(diff_src[diff_src_off] = REF_TO_SRC(ds);)==""\n"
R"==(})==""\n"
R"==(#endif)==""\n"
R"==(#if IS_BWD_W == 1)==""\n"
R"==(KERNEL_ATTR)==""\n"
R"==(__kernel void ref_inner_product_bwd_weights(__global SRC_DATA_T *src,)==""\n"
R"==(__global WEI_DATA_T *diff_wei, __global BIA_DATA_T *diff_bias,)==""\n"
R"==(__global DST_DATA_T *diff_dst) {)==""\n"
R"==(const int oc = GWS_GET_OC();)==""\n"
R"==(const int ic = GWS_GET_IC();)==""\n"
R"==(const int kd = GWS_GET_KD();)==""\n"
R"==(const int kh = GWS_GET_KH();)==""\n"
R"==(const int kw = GWS_GET_KW();)==""\n"
R"==(float ds = 0.0f;)==""\n"
R"==(for (int mb = 0; mb < MB; ++mb) {)==""\n"
R"==(const uint diff_dst_off = DST_OFF(mb, oc, 0, 0, 0);)==""\n"
R"==(const uint src_off = SRC_OFF(mb, ic, kd, kh, kw);)==""\n"
R"==(ds += DST_TO_REF(diff_dst[diff_dst_off]) * SRC_TO_REF(src[src_off]);)==""\n"
R"==(})==""\n"
R"==(const uint diff_wei_off = WEI_OFF(0, oc, ic, kd, kh, kw);)==""\n"
R"==(diff_wei[diff_wei_off] = REF_TO_WEI(ds);)==""\n"
R"==(#if WITH_BIAS == 1)==""\n"
R"==(if (ic == 0) {)==""\n"
R"==(float db = 0.0f;)==""\n"
R"==(for (int mb = 0; mb < MB; ++mb) {)==""\n"
R"==(const uint diff_dst_off = DST_OFF(mb, oc, 0, 0, 0);)==""\n"
R"==(db += DST_TO_REF(diff_dst[diff_dst_off]);)==""\n"
R"==(})==""\n"
R"==(diff_bias[oc] = REF_TO_BIA(db);)==""\n"
R"==(})==""\n"
R"==(#endif)==""\n"
R"==(})==""\n"
R"==(#endif)==""\n"
R"==()==";
}
}
}
}
}