namespace dnnl {
namespace impl {
namespace gpu {
namespace intel {
namespace ocl {
const char *ref_lrn_kernel = R"==(/*******************************************************************************)==""\n"
R"==(* Copyright 2019-2024 Intel Corporation)==""\n"
R"==(*)==""\n"
R"==(* Licensed under the Apache License, Version 2.0 (the "License");)==""\n"
R"==(* you may not use this file except in compliance with the License.)==""\n"
R"==(* You may obtain a copy of the License at)==""\n"
R"==(*)==""\n"
R"==(* http:)==""\n"
R"==(*)==""\n"
R"==(* Unless required by applicable law or agreed to in writing, software)==""\n"
R"==(* distributed under the License is distributed on an "AS IS" BASIS,)==""\n"
R"==(* WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.)==""\n"
R"==(* See the License for the specific language governing permissions and)==""\n"
R"==(* limitations under the License.)==""\n"
R"==(*******************************************************************************/)==""\n"
R"==(#include "gpu/intel/ocl/dispatch.h")==""\n"
R"==(#include "gpu/intel/ocl/ocl_types.h")==""\n"
R"==(#if IS_FWD == 1)==""\n"
R"==(KERNEL_ATTR)==""\n"
R"==(__kernel void ref_lrn_fwd(__global const DATA_T *src,)==""\n"
R"==(#if IS_TRAINING == 1)==""\n"
R"==(__global DEF_ACC_DATA_T *ws,)==""\n"
R"==(#endif)==""\n"
R"==(__global DATA_T *dst) {)==""\n"
R"==(const uint mb = GWS_GET_MB();)==""\n"
R"==(const uint ic = GWS_GET_IC();)==""\n"
R"==(const uint id = GWS_GET_ID();)==""\n"
R"==(const uint ih = GWS_GET_IH();)==""\n"
R"==(const uint iw = GWS_GET_IW();)==""\n"
R"==(const uint src_index = SRC_OFF(mb, ic, id, ih, iw);)==""\n"
R"==(const uint dst_index = DST_OFF(mb, ic, id, ih, iw);)==""\n"
R"==(DEF_ACC_DATA_T sum = 0.0f;)==""\n"
R"==(#if ACROSS_CHANNEL)==""\n"
R"==(for (int j = 0; j < LOCAL_SIZE; j++) {)==""\n"
R"==(const int z_idx = (j + ic - PADDING);)==""\n"
R"==(bool zero = (z_idx < 0 || z_idx >= IC);)==""\n"
R"==(DEF_ACC_DATA_T val = zero)==""\n"
R"==(? 0.0f)==""\n"
R"==(: TO_DEF_ACC_DATA_T(src[SRC_OFF(mb, z_idx, id, ih, iw)]);)==""\n"
R"==(sum += val * val;)==""\n"
R"==(})==""\n"
R"==(#else)==""\n"
R"==(const int d = (int)id - PADDING;)==""\n"
R"==(const int h = (int)ih - PADDING;)==""\n"
R"==(const int w = (int)iw - PADDING;)==""\n"
R"==(const int d_start = max(d, 0);)==""\n"
R"==(const int h_start = max(h, 0);)==""\n"
R"==(const int w_start = max(w, 0);)==""\n"
R"==(const int d_end = min(d + LOCAL_SIZE, ID);)==""\n"
R"==(const int h_end = min(h + LOCAL_SIZE, IH);)==""\n"
R"==(const int w_end = min(w + LOCAL_SIZE, IW);)==""\n"
R"==(for (int k = d_start; k < d_end; ++k) {)==""\n"
R"==(for (int j = h_start; j < h_end; ++j) {)==""\n"
R"==(for (int i = w_start; i < w_end; ++i) {)==""\n"
R"==(DEF_ACC_DATA_T val)==""\n"
R"==(= TO_DEF_ACC_DATA_T(src[SRC_OFF(mb, ic, k, j, i)]);)==""\n"
R"==(sum += val * val;)==""\n"
R"==(})==""\n"
R"==(})==""\n"
R"==(})==""\n"
R"==(#endif)==""\n"
R"==(const DEF_ACC_DATA_T num_elements_div = NUM_ELEMENTS_DIV;)==""\n"
R"==(const DEF_ACC_DATA_T base = (DEF_ACC_DATA_T)LRN_K)==""\n"
R"==(+ (DEF_ACC_DATA_T)LRN_ALPHA * sum * num_elements_div;)==""\n"
R"==(const DEF_ACC_DATA_T normalization_factor)==""\n"
R"==(= native_powr(base, (DEF_ACC_DATA_T)(-LRN_BETA));)==""\n"
R"==(const DEF_ACC_DATA_T val = TO_DEF_ACC_DATA_T(src[src_index]);)==""\n"
R"==(const DEF_ACC_DATA_T normres = val * normalization_factor;)==""\n"
R"==(#if IS_TRAINING == 1)==""\n"
R"==(ws[dst_index] = base;)==""\n"
R"==(#endif)==""\n"
R"==(dst[dst_index] = TO_DATA_T(normres);)==""\n"
R"==(})==""\n"
R"==(#endif)==""\n"
R"==(#if IS_BWD == 1)==""\n"
R"==(KERNEL_ATTR)==""\n"
R"==(__kernel void ref_lrn_bwd(__global const DATA_T *src,)==""\n"
R"==(__global const DATA_T *diff_dst, __global DEF_ACC_DATA_T *ws,)==""\n"
R"==(__global DATA_T *diff_src) {)==""\n"
R"==(const uint mb = GWS_GET_MB();)==""\n"
R"==(const uint ic = GWS_GET_IC();)==""\n"
R"==(const uint id = GWS_GET_ID();)==""\n"
R"==(const uint ih = GWS_GET_IH();)==""\n"
R"==(const uint iw = GWS_GET_IW();)==""\n"
R"==(const uint src_index = SRC_OFF(mb, ic, id, ih, iw);)==""\n"
R"==(const uint dst_index = DST_OFF(mb, ic, id, ih, iw);)==""\n"
R"==(const DEF_ACC_DATA_T num_elements_div = NUM_ELEMENTS_DIV;)==""\n"
R"==(DEF_ACC_DATA_T B = 0;)==""\n"
R"==(#if ACROSS_CHANNEL)==""\n"
R"==(for (int j = 0; j < LOCAL_SIZE; j++) {)==""\n"
R"==(const int z_idx = (j + ic - PADDING);)==""\n"
R"==(bool zero = (z_idx < 0 || z_idx >= IC);)==""\n"
R"==(if (!zero) {)==""\n"
R"==(DEF_ACC_DATA_T val)==""\n"
R"==(= TO_DEF_ACC_DATA_T(src[SRC_OFF(mb, z_idx, id, ih, iw)]);)==""\n"
R"==(DEF_ACC_DATA_T omega = ws[SRC_OFF(mb, z_idx, id, ih, iw)];)==""\n"
R"==(DEF_ACC_DATA_T tmp = (DEF_ACC_DATA_T)1.0f)==""\n"
R"==(/ native_powr(omega, (DEF_ACC_DATA_T)LRN_BETA + 1);)==""\n"
R"==(B += tmp * val)==""\n"
R"==(* TO_DEF_ACC_DATA_T()==""\n"
R"==(diff_dst[DST_OFF(mb, z_idx, id, ih, iw)]);)==""\n"
R"==(})==""\n"
R"==(})==""\n"
R"==(#else)==""\n"
R"==(const int d = (int)id - PADDING;)==""\n"
R"==(const int h = (int)ih - PADDING;)==""\n"
R"==(const int w = (int)iw - PADDING;)==""\n"
R"==(const int d_start = max(d, 0);)==""\n"
R"==(const int h_start = max(h, 0);)==""\n"
R"==(const int w_start = max(w, 0);)==""\n"
R"==(const int d_end = min(d + LOCAL_SIZE, ID);)==""\n"
R"==(const int h_end = min(h + LOCAL_SIZE, IH);)==""\n"
R"==(const int w_end = min(w + LOCAL_SIZE, IW);)==""\n"
R"==(for (int k = d_start; k < d_end; ++k) {)==""\n"
R"==(for (int j = h_start; j < h_end; ++j) {)==""\n"
R"==(for (int i = w_start; i < w_end; ++i) {)==""\n"
R"==(int data_off = SRC_OFF(mb, ic, k, j, i);)==""\n"
R"==(DEF_ACC_DATA_T val = TO_DEF_ACC_DATA_T(src[data_off]);)==""\n"
R"==(DEF_ACC_DATA_T omega = ws[data_off];)==""\n"
R"==(DEF_ACC_DATA_T tmp = (DEF_ACC_DATA_T)1.0f)==""\n"
R"==(/ native_powr(omega, (DEF_ACC_DATA_T)(LRN_BETA + 1));)==""\n"
R"==(B += tmp * val * TO_DEF_ACC_DATA_T(diff_dst[data_off]);)==""\n"
R"==(})==""\n"
R"==(})==""\n"
R"==(})==""\n"
R"==(#endif)==""\n"
R"==(const DEF_ACC_DATA_T A)==""\n"
R"==(= native_powr(ws[src_index], (DEF_ACC_DATA_T)-LRN_BETA))==""\n"
R"==(* TO_DEF_ACC_DATA_T(diff_dst[dst_index]);)==""\n"
R"==(diff_src[src_index] = TO_DATA_T(A)==""\n"
R"==(- TO_DEF_ACC_DATA_T(src[src_index]) * 2 * (DEF_ACC_DATA_T)LRN_ALPHA)==""\n"
R"==(* (DEF_ACC_DATA_T)LRN_BETA * num_elements_div * B);)==""\n"
R"==(})==""\n"
R"==(#endif)==""\n"
R"==()==";
}
}
}
}
}