namespace dnnl {
namespace impl {
namespace gpu {
namespace intel {
namespace ocl {
const char *ref_matmul_kernel = R"==(/*******************************************************************************)==""\n"
R"==(* Copyright 2019-2024 Intel Corporation)==""\n"
R"==(*)==""\n"
R"==(* Licensed under the Apache License, Version 2.0 (the "License");)==""\n"
R"==(* you may not use this file except in compliance with the License.)==""\n"
R"==(* You may obtain a copy of the License at)==""\n"
R"==(*)==""\n"
R"==(* http:)==""\n"
R"==(*)==""\n"
R"==(* Unless required by applicable law or agreed to in writing, software)==""\n"
R"==(* distributed under the License is distributed on an "AS IS" BASIS,)==""\n"
R"==(* WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.)==""\n"
R"==(* See the License for the specific language governing permissions and)==""\n"
R"==(* limitations under the License.)==""\n"
R"==(*******************************************************************************/)==""\n"
R"==(#include "gpu/intel/ocl/ocl_post_ops.h")==""\n"
R"==(#include "gpu/intel/ocl/ocl_types.h")==""\n"
R"==(#define offset6D(d0, d1, d2, d3, d4, d5, s0, s1, s2, s3, s4, s5) \)==""\n"
R"==(((d0) * (s0) + (d1) * (s1) + (d2) * (s2) + (d3) * (s3) + (d4) * (s4) \)==""\n"
R"==(+ (d5) * (s5)))==""\n"
R"==(#if WITH_DROPOUT)==""\n"
R"==(uint get_dropout_threshold(float p) {)==""\n"
R"==(if (p >= 1.f) return 0xFFFFFFFFu;)==""\n"
R"==(char exponent = 126 - ((as_uint(p) >> 23) & 0x7F);)==""\n"
R"==(if ((p <= 0.f) || (exponent > 31)) return 0u;)==""\n"
R"==(uint mantissa = (as_uint(p) << 8) | 0x80000000u;)==""\n"
R"==(if (!exponent) return (convert_ulong(mantissa) * 0xFFFFFFFFuL) >> 32;)==""\n"
R"==(return ((convert_ulong(mantissa >> exponent) * 0xFFFFFFFFuL) >> 32))==""\n"
R"==(+ !!(mantissa & ((1u << exponent) - 1u));)==""\n"
R"==(})==""\n"
R"==(#endif)==""\n"
R"==(__kernel void ref_matmul(__global SRC_DATA_T *A, __global WEI_DATA_T *B,)==""\n"
R"==(__global DST_DATA_T *C, __global BIA_DATA_T *bia, __global int *a0,)==""\n"
R"==(__global WEI_ZP_DATA_T *b0, long wei_zp_stride_n, long wei_zp_stride_k,)==""\n"
R"==(long wei_zp_group_k, __global int *c0,)==""\n"
R"==(__global SRC_SCALES_DATA_T *src_scales, long src_scale_stride_k,)==""\n"
R"==(long src_scale_stride_m, long src_scale_group_k,)==""\n"
R"==(__global WEI_SCALES_DATA_T *wei_scales, long wei_scale_stride_n,)==""\n"
R"==(long wei_scale_stride_k, long wei_scale_group_k,)==""\n"
R"==(__global DST_SCALES_DATA_T *dst_scales, long group_K, long K, long N,)==""\n"
R"==(long M, long D0, long D1, long D2, long bia_stride_d3,)==""\n"
R"==(long bia_stride_d2, long bia_stride_d1, long bia_stride_d0,)==""\n"
R"==(long bia_stride_m, long bia_stride_n, long a_stride_d3,)==""\n"
R"==(long a_stride_d2, long a_stride_d1, long a_stride_d0, long a_stride_m,)==""\n"
R"==(long a_stride_k, long b_stride_d3, long b_stride_d2, long b_stride_d1,)==""\n"
R"==(long b_stride_d0, long b_stride_k, long b_stride_n, long c_stride_d3,)==""\n"
R"==(long c_stride_d2, long c_stride_d1, long c_stride_d0, long c_stride_m,)==""\n"
R"==(long c_stride_n)==""\n"
R"==(#if WITH_DROPOUT)==""\n"
R"==(,)==""\n"
R"==(__global uchar *dropout_mask_buf, __global uint *dropout_seed_buf,)==""\n"
R"==(__global float *dropout_p_buf POST_OP_ARGS) {)==""\n"
R"==(uint dropout_seed = dropout_seed_buf[0];)==""\n"
R"==(uint dropout_threshold = get_dropout_threshold(dropout_p_buf[0]);)==""\n"
R"==(float dropout_inv_q)==""\n"
R"==(= (dropout_p_buf[0] != 1.f) ? 1.f / (1.f - dropout_p_buf[0]) : 0.f;)==""\n"
R"==(#else)==""\n"
R"==(POST_OP_ARGS) {)==""\n"
R"==(#endif)==""\n"
R"==(long n = get_global_id(1);)==""\n"
R"==(int mb = get_global_id(2);)==""\n"
R"==(#if WITH_SRC_ZPOINTS)==""\n"
R"==(int src_zp = a0[0];)==""\n"
R"==(#else)==""\n"
R"==(int src_zp = 0;)==""\n"
R"==(#endif)==""\n"
R"==(#if WITH_DST_ZPOINTS)==""\n"
R"==(int dst_zp = c0[0];)==""\n"
R"==(#else)==""\n"
R"==(int dst_zp = 0;)==""\n"
R"==(#endif)==""\n"
R"==(long d3 = mb / D0 / D1 / D2;)==""\n"
R"==(long d2 = (mb / D0 / D1) % D2;)==""\n"
R"==(long d1 = (mb / D0) % D1;)==""\n"
R"==(long d0 = mb % D0;)==""\n"
R"==(long n_groups_k = K / group_K;)==""\n"
R"==(for (long m = 0; m < M; ++m) {)==""\n"
R"==(FLT_ACC_DATA_T acc = 0.f;)==""\n"
R"==(for (long g = 0; g < n_groups_k; g++) {)==""\n"
R"==(ACC_DATA_T acc_g = 0;)==""\n"
R"==(for (long k_g = 0; k_g < group_K; ++k_g) {)==""\n"
R"==(auto k = k_g + g * group_K;)==""\n"
R"==(#if RUNTIME_DIMS)==""\n"
R"==(long src_off = offset6D(m, k, d0, d1, d2, d3, a_stride_m,)==""\n"
R"==(a_stride_k, a_stride_d0, a_stride_d1, a_stride_d2,)==""\n"
R"==(a_stride_d3);)==""\n"
R"==(long wei_off = offset6D(k, n, d0, d1, d2, d3, b_stride_k,)==""\n"
R"==(b_stride_n, b_stride_d0, b_stride_d1, b_stride_d2,)==""\n"
R"==(b_stride_d3);)==""\n"
R"==(#else)==""\n"
R"==(#if NDIMS == 5)==""\n"
R"==(long src_off)==""\n"
R"==(= SRC_OFF(d2 % SRC_D0, d1 % SRC_D1, d0 % SRC_D2, m, k);)==""\n"
R"==(long wei_off = WEI_OFF()==""\n"
R"==(0, d2 % WEI_D0, d1 % WEI_D1, d0 % WEI_D2, k, n);)==""\n"
R"==(#elif NDIMS == 4)==""\n"
R"==(long src_off = SRC_OFF(d1 % SRC_D0, d0 % SRC_D1, 0, m, k);)==""\n"
R"==(long wei_off = WEI_OFF(0, d1 % WEI_D0, d0 % WEI_D1, 0, k, n);)==""\n"
R"==(#elif NDIMS == 3)==""\n"
R"==(long src_off = SRC_OFF(d0 % SRC_D0, m, 0, 0, k);)==""\n"
R"==(long wei_off = WEI_OFF(0, d0 % WEI_D0, k, 0, 0, n);)==""\n"
R"==(#else)==""\n"
R"==(long src_off = SRC_OFF(m, k, 0, 0, 0);)==""\n"
R"==(long wei_off = WEI_OFF(0, k, n, 0, 0, 0);)==""\n"
R"==(#endif)==""\n"
R"==(#endif)==""\n"
R"==(int wei_zp = 0;)==""\n"
R"==(#if WITH_WEI_ZPOINTS)==""\n"
R"==(wei_zp = WEI_ZP_TO_REF(b0,)==""\n"
R"==(wei_zp_stride_n * n)==""\n"
R"==(+ wei_zp_stride_k * (k / wei_zp_group_k));)==""\n"
R"==(#endif)==""\n"
R"==(ACC_DATA_T s = TO_ACC(SRC_TO_REF(A[src_off]) - src_zp);)==""\n"
R"==(#if WEI_DT_S4 || WEI_DT_U4)==""\n"
R"==(ACC_DATA_T w_raw = WEI_TO_REF(GET_HALF_BYTE(B, wei_off));)==""\n"
R"==(#else)==""\n"
R"==(ACC_DATA_T w_raw = WEI_TO_REF(B[wei_off]);)==""\n"
R"==(#endif)==""\n"
R"==(ACC_DATA_T w = TO_ACC(w_raw - wei_zp);)==""\n"
R"==(acc_g += s * w;)==""\n"
R"==(})==""\n"
R"==(FLT_ACC_DATA_T src_scale = 1.f;)==""\n"
R"==(FLT_ACC_DATA_T wei_scale = 1.f;)==""\n"
R"==(#if WITH_SRC_SCALES)==""\n"
R"==(src_scale = SRC_SCALES_TO_REF(src_scales[src_scale_stride_k)==""\n"
R"==(* (g * group_K / src_scale_group_k))==""\n"
R"==(+ src_scale_stride_m * m]);)==""\n"
R"==(#endif)==""\n"
R"==(#if WITH_WEI_SCALES)==""\n"
R"==(wei_scale = WEI_SCALES_TO_REF(wei_scales[wei_scale_stride_n * n)==""\n"
R"==(+ wei_scale_stride_k * (g * group_K / wei_scale_group_k)]);)==""\n"
R"==(#endif)==""\n"
R"==(FLT_ACC_DATA_T acc_g_to_f)==""\n"
R"==(= ACC_TO_REF(acc_g) * src_scale * wei_scale;)==""\n"
R"==(acc += acc_g_to_f;)==""\n"
R"==(})==""\n"
R"==(#if RUNTIME_DIMS)==""\n"
R"==(long dst_off = offset6D(m, n, d0, d1, d2, d3, c_stride_m, c_stride_n,)==""\n"
R"==(c_stride_d0, c_stride_d1, c_stride_d2, c_stride_d3);)==""\n"
R"==(#else)==""\n"
R"==(#if NDIMS == 5)==""\n"
R"==(long dst_off = DST_OFF(d2 % DST_D0, d1 % DST_D1, d0 % DST_D2, m, n);)==""\n"
R"==(#elif NDIMS == 4)==""\n"
R"==(long dst_off = DST_OFF(d1 % DST_D0, d0 % DST_D1, 0, m, n);)==""\n"
R"==(#elif NDIMS == 3)==""\n"
R"==(long dst_off = DST_OFF(d0 % DST_D0, m, 0, 0, n);)==""\n"
R"==(#else)==""\n"
R"==(long dst_off = DST_OFF(m, n, 0, 0, 0);)==""\n"
R"==(#endif)==""\n"
R"==(#endif)==""\n"
R"==(#if WITH_BIAS || WITH_DROPOUT || NON_DEFAULT_ATTRS)==""\n"
R"==(POST_OP_DATA_T temp = (POST_OP_DATA_T)acc;)==""\n"
R"==(#if WITH_BIAS)==""\n"
R"==(long bia_off = offset6D(m, n, d0, d1, d2, d3, bia_stride_m,)==""\n"
R"==(bia_stride_n, bia_stride_d0, bia_stride_d1, bia_stride_d2,)==""\n"
R"==(bia_stride_d3);)==""\n"
R"==(temp += BIA_TO_REF(bia[bia_off]);)==""\n"
R"==(#endif )==""\n"
R"==(float dst_data;)==""\n"
R"==(#if WITH_SUM)==""\n"
R"==(dst_data = convert_float(DATA_TO_REF(C[dst_off]));)==""\n"
R"==(#endif )==""\n"
R"==(float po_acc = convert_float(temp);)==""\n"
R"==(#if WITH_DROPOUT)==""\n"
R"==(const ulong2 ctr_mul = (ulong2)(0xD2511F53uL, 0xCD9E8D57uL);)==""\n"
R"==(const ulong key_add = as_ulong((uint2)(0x9E3779B9u, 0xBB67AE85u));)==""\n"
R"==(const uint16 key0 = (uint16)(dropout_seed))==""\n"
R"==(+ as_uint16((ulong8)(key_add)))==""\n"
R"==(* (uint16)()==""\n"
R"==(0, 0, 1, 1, 2, 2, 3, 3, 4, 4, 5, 5, 6, 6, 7, 7);)==""\n"
R"==(const uint4 key1 = (uint4)(dropout_seed))==""\n"
R"==(+ as_uint4((ulong2)(key_add)) * (uint4)(8, 8, 9, 9);)==""\n"
R"==(uint4 ctr = (uint4)(dst_off & ~3L) + (uint4)(3, 2, 1, 0);)==""\n"
R"==(#define PHILOX_4UINT_ROUND(mul, ctr, key) \)==""\n"
R"==(as_uint4(convert_ulong2(ctr.s31) * mul) ^ (uint4)(ctr.s20 ^ key, 0, 0).s3120)==""\n"
R"==(ctr = PHILOX_4UINT_ROUND(ctr_mul, ctr, key0.s01);)==""\n"
R"==(ctr = PHILOX_4UINT_ROUND(ctr_mul, ctr, key0.s23);)==""\n"
R"==(ctr = PHILOX_4UINT_ROUND(ctr_mul, ctr, key0.s45);)==""\n"
R"==(ctr = PHILOX_4UINT_ROUND(ctr_mul, ctr, key0.s67);)==""\n"
R"==(ctr = PHILOX_4UINT_ROUND(ctr_mul, ctr, key0.s89);)==""\n"
R"==(ctr = PHILOX_4UINT_ROUND(ctr_mul, ctr, key0.sAB);)==""\n"
R"==(ctr = PHILOX_4UINT_ROUND(ctr_mul, ctr, key0.sCD);)==""\n"
R"==(ctr = PHILOX_4UINT_ROUND(ctr_mul, ctr, key0.sEF);)==""\n"
R"==(ctr = PHILOX_4UINT_ROUND(ctr_mul, ctr, key1.s01);)==""\n"
R"==(ctr = PHILOX_4UINT_ROUND(ctr_mul, ctr, key1.s23);)==""\n"
R"==(#undef PHILOX_4UINT_ROUND)==""\n"
R"==(uchar dropout = ctr[~dst_off & 3L] > dropout_threshold;)==""\n"
R"==(po_acc = (dropout) ? po_acc * dropout_inv_q : 0;)==""\n"
R"==(dropout_mask_buf[dst_off] = dropout;)==""\n"
R"==(#endif)==""\n"
R"==(if (DST_NDIMS == 2))==""\n"
R"==(APPLY_POST_OPS_SERIAL(po_acc, float, dst_data, float, m, 1, n, 1, 0,)==""\n"
R"==(1, 0, 1, 0, 1, 0, 1);)==""\n"
R"==(if (DST_NDIMS == 3))==""\n"
R"==(APPLY_POST_OPS_SERIAL(po_acc, float, dst_data, float, d0, 1, m, 1,)==""\n"
R"==(n, 1, 0, 1, 0, 1, 0, 1);)==""\n"
R"==(if (DST_NDIMS == 4))==""\n"
R"==(APPLY_POST_OPS_SERIAL(po_acc, float, dst_data, float, d1, 1, d0, 1,)==""\n"
R"==(m, 1, n, 1, 0, 1, 0, 1);)==""\n"
R"==(if (DST_NDIMS == 5))==""\n"
R"==(APPLY_POST_OPS_SERIAL(po_acc, float, dst_data, float, d2, 1, d1, 1,)==""\n"
R"==(d0, 1, m, 1, n, 1, 0, 1);)==""\n"
R"==(if (DST_NDIMS == 6))==""\n"
R"==(APPLY_POST_OPS_SERIAL(po_acc, float, dst_data, float, d3, 1, d2, 1,)==""\n"
R"==(d1, 1, d0, 1, m, 1, n, 1);)==""\n"
R"==(#if WITH_DST_SCALES)==""\n"
R"==(po_acc /= DST_SCALES_TO_REF(dst_scales[0]);)==""\n"
R"==(#endif)==""\n"
R"==(po_acc += dst_zp;)==""\n"
R"==(C[dst_off] = TO_DST(po_acc);)==""\n"
R"==(#else )==""\n"
R"==(C[dst_off] = TO_DST(acc);)==""\n"
R"==(#endif )==""\n"
R"==(})==""\n"
R"==(})==""\n"
R"==()==";
}
}
}
}
}