namespace dnnl {
namespace impl {
namespace gpu {
namespace intel {
namespace ocl {
const char *ref_sparse_matmul_kernel = R"==(/*******************************************************************************)==""\n"
R"==(* Copyright 2024 Intel Corporation)==""\n"
R"==(*)==""\n"
R"==(* Licensed under the Apache License, Version 2.0 (the "License");)==""\n"
R"==(* you may not use this file except in compliance with the License.)==""\n"
R"==(* You may obtain a copy of the License at)==""\n"
R"==(*)==""\n"
R"==(* http:)==""\n"
R"==(*)==""\n"
R"==(* Unless required by applicable law or agreed to in writing, software)==""\n"
R"==(* distributed under the License is distributed on an "AS IS" BASIS,)==""\n"
R"==(* WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.)==""\n"
R"==(* See the License for the specific language governing permissions and)==""\n"
R"==(* limitations under the License.)==""\n"
R"==(*******************************************************************************/)==""\n"
R"==(#include "gpu/intel/ocl/ocl_post_ops.h")==""\n"
R"==(#include "gpu/intel/ocl/ocl_types.h")==""\n"
R"==(__kernel void ref_sparse_matmul(__global const SRC_DATA_T *A_values,)==""\n"
R"==(__global const int *A_rows, __global const int *A_cols,)==""\n"
R"==(__global const WEI_DATA_T *B, __global DST_DATA_T *C, const int nnz) {)==""\n"
R"==(int m = get_global_id(0);)==""\n"
R"==(int n = get_global_id(1);)==""\n"
R"==(long dst_off = DST_OFF(m, n, 0, 0, 0);)==""\n"
R"==(float accum = 0.0f;)==""\n"
R"==(for (int idx = 0; idx < nnz; idx++) {)==""\n"
R"==(int a_row = A_rows[idx];)==""\n"
R"==(if (a_row == m) {)==""\n"
R"==(int a_col = A_cols[idx];)==""\n"
R"==(float val = SRC_TO_REF(A_values[idx]);)==""\n"
R"==(long wei_off = WEI_OFF(0, a_col, n, 0, 0, 0);)==""\n"
R"==(accum += val * WEI_TO_REF(B[wei_off]);)==""\n"
R"==(})==""\n"
R"==(})==""\n"
R"==(C[dst_off] = TO_DST(accum);)==""\n"
R"==(})==""\n"
R"==()==";
}
}
}
}
}