namespace dnnl {
namespace impl {
namespace gpu {
namespace intel {
namespace ocl {
const char *reusable_bnorm_kernel = R"==(/*******************************************************************************)==""\n"
R"==(* Copyright 2023-2024 Intel Corporation)==""\n"
R"==(*)==""\n"
R"==(* Licensed under the Apache License, Version 2.0 (the "License");)==""\n"
R"==(* you may not use this file except in compliance with the License.)==""\n"
R"==(* You may obtain a copy of the License at)==""\n"
R"==(*)==""\n"
R"==(* http:)==""\n"
R"==(*)==""\n"
R"==(* Unless required by applicable law or agreed to in writing, software)==""\n"
R"==(* distributed under the License is distributed on an "AS IS" BASIS,)==""\n"
R"==(* WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.)==""\n"
R"==(* See the License for the specific language governing permissions and)==""\n"
R"==(* limitations under the License.)==""\n"
R"==(*******************************************************************************/)==""\n"
R"==(#include "gpu/intel/ocl/dispatch.h")==""\n"
R"==(#include "gpu/intel/ocl/ocl_types.h")==""\n"
R"==(#include "gpu/intel/ocl/types_interop.h")==""\n"
R"==(NAMED_KERNEL_ATTR(CALC))==""\n"
R"==(__kernel void reusable_calculate_mean(__global DATA_T *src,)==""\n"
R"==(__global float *mean, off_t reduce_dim_stride, off_t reduce_dim,)==""\n"
R"==(dispatch_gws_rt_params_t gws_params) {)==""\n"
R"==(src = GWS_GET_BUFFER_POS_NAMED(SRC, CALC, gws_params, src);)==""\n"
R"==(mean = GWS_GET_BUFFER_POS_NAMED(DST, CALC, gws_params, mean);)==""\n"
R"==(float sum = 0;)==""\n"
R"==(unroll_16_for(off_t i = 0; i < reduce_dim; i++) {)==""\n"
R"==(sum += TO_DEF_ACC_DATA_T(src[i * (off_t)reduce_dim_stride]);)==""\n"
R"==(})==""\n"
R"==(*mean = sum;)==""\n"
R"==(})==""\n"
R"==(NAMED_KERNEL_ATTR(CALC))==""\n"
R"==(__kernel void reusable_calculate_variance(__global DATA_T *src,)==""\n"
R"==(__global float *mean, __global float *variance, off_t reduce_dim_stride,)==""\n"
R"==(off_t reduce_dim, dispatch_gws_rt_params_t gws_params) {)==""\n"
R"==(const off_t c = GWS_GET_OFF_NAMED(IC_DIM, CALC, gws_params);)==""\n"
R"==(src = GWS_GET_BUFFER_POS_NAMED(SRC, CALC, gws_params, src);)==""\n"
R"==(variance = GWS_GET_BUFFER_POS_NAMED(DST, CALC, gws_params, variance);)==""\n"
R"==(float sum = 0;)==""\n"
R"==(unroll_16_for(off_t i = 0; i < reduce_dim; i++) {)==""\n"
R"==(DEF_ACC_DATA_T v0 = TO_DEF_ACC_DATA_T(src[i * (off_t)reduce_dim_stride]))==""\n"
R"==(- mean[c];)==""\n"
R"==(sum += v0 * v0;)==""\n"
R"==(})==""\n"
R"==(*variance = sum;)==""\n"
R"==(})==""\n"
R"==(NAMED_KERNEL_ATTR(REDUCE))==""\n"
R"==(__kernel void reusable_reduce_mean(__global float *reduce_temp,)==""\n"
R"==(__global float *mean, off_t ic, off_t reduce_dim, off_t div,)==""\n"
R"==(dispatch_gws_rt_params_t gws_params) {)==""\n"
R"==(reduce_temp)==""\n"
R"==(= GWS_GET_BUFFER_POS_NAMED(BUFFER, REDUCE, gws_params, reduce_temp);)==""\n"
R"==(mean = GWS_GET_BUFFER_POS_NAMED(BUFFER, REDUCE, gws_params, mean);)==""\n"
R"==(float sum = 0.0f;)==""\n"
R"==(unroll_16_for(off_t i = 0; i < reduce_dim; i++) {)==""\n"
R"==(sum += reduce_temp[i * (off_t)ic];)==""\n"
R"==(})==""\n"
R"==(*mean = sum / div;)==""\n"
R"==(})==""\n"
R"==(NAMED_KERNEL_ATTR(REDUCE))==""\n"
R"==(__kernel void reusable_reduce_variance(__global float *reduce_temp,)==""\n"
R"==(__global float *variance, off_t ic, off_t reduce_dim, off_t div,)==""\n"
R"==(dispatch_gws_rt_params_t gws_params) {)==""\n"
R"==(reduce_temp)==""\n"
R"==(= GWS_GET_BUFFER_POS_NAMED(BUFFER, REDUCE, gws_params, reduce_temp);)==""\n"
R"==(variance = GWS_GET_BUFFER_POS_NAMED(BUFFER, REDUCE, gws_params, variance);)==""\n"
R"==(float sum = 0.0f;)==""\n"
R"==(unroll_16_for(off_t i = 0; i < reduce_dim; i++) {)==""\n"
R"==(sum += reduce_temp[i * (off_t)ic];)==""\n"
R"==(})==""\n"
R"==(*variance = sum / div;)==""\n"
R"==(})==""\n"
R"==(KERNEL_ATTR)==""\n"
R"==(__kernel void reusable_bnorm_fwd(__global DATA_T *src, __global float *mean,)==""\n"
R"==(__global float *variance, __global DATA_T *dst, __global float *scale,)==""\n"
R"==(__global float *shift, __global char *ws, float eps,)==""\n"
R"==(__global DATA_T *src_add, float relu_alpha,)==""\n"
R"==(dispatch_gws_rt_params_t gws_params) {)==""\n"
R"==(const off_t c = GWS_GET_OFF(IC_DIM, gws_params);)==""\n"
R"==(src = GWS_GET_BUFFER_POS(BUFFER, gws_params, src);)==""\n"
R"==(src_add = GWS_GET_BUFFER_POS(BUFFER, gws_params, src_add);)==""\n"
R"==(ws = GWS_GET_BUFFER_POS(BUFFER, gws_params, ws);)==""\n"
R"==(dst = GWS_GET_BUFFER_POS(BUFFER, gws_params, dst);)==""\n"
R"==(float sm = USE_SCALE ? scale[c] : 1;)==""\n"
R"==(float sv = USE_SHIFT ? shift[c] : 0;)==""\n"
R"==(float v_mean = mean[c];)==""\n"
R"==(float v_variance = variance[c];)==""\n"
R"==(float v0 = TO_DEF_ACC_DATA_T(*src);)==""\n"
R"==(float sqrt_variance = 1.0f / sqrt(v_variance + eps);)==""\n"
R"==(float bn_res = sm * (v0 - v_mean) * sqrt_variance + sv;)==""\n"
R"==(if (FUSE_BN_ADD_RELU) bn_res += TO_DEF_ACC_DATA_T(*src_add);)==""\n"
R"==(#if FUSE_BN_RELU == 1)==""\n"
R"==(if (bn_res <= 0) {)==""\n"
R"==(bn_res = 0;)==""\n"
R"==(#if IS_TRAINING == 1)==""\n"
R"==(*ws = 0;)==""\n"
R"==(} else {)==""\n"
R"==(*ws = -1;)==""\n"
R"==(#endif)==""\n"
R"==(})==""\n"
R"==(#endif)==""\n"
R"==(#if WITH_RELU)==""\n"
R"==(#if WITH_LEAKY_RELU)==""\n"
R"==(if (bn_res < 0) bn_res *= relu_alpha;)==""\n"
R"==(#else)==""\n"
R"==(bn_res = max(bn_res, 0.0f);)==""\n"
R"==(#endif )==""\n"
R"==(#endif )==""\n"
R"==(*dst = TO_DATA_T(bn_res);)==""\n"
R"==(})==""\n"
R"==(NAMED_KERNEL_ATTR(CALC))==""\n"
R"==(__kernel void reusable_calculate_stats(__global DATA_T *src,)==""\n"
R"==(__global float *mean, __global DATA_T *diff_dst, __global char *ws,)==""\n"
R"==(__global float *reduce_temp, __global float *reduce_temp_shift,)==""\n"
R"==(off_t reduce_dim_stride, off_t reduce_dim,)==""\n"
R"==(dispatch_gws_rt_params_t gws_params) {)==""\n"
R"==(float diff_gamma = 0;)==""\n"
R"==(float diff_beta = 0;)==""\n"
R"==(const off_t c = GWS_GET_OFF_NAMED(IC_DIM, CALC, gws_params);)==""\n"
R"==(reduce_temp = GWS_GET_BUFFER_POS_NAMED(DST, CALC, gws_params, reduce_temp);)==""\n"
R"==(reduce_temp_shift = GWS_GET_BUFFER_POS_NAMED()==""\n"
R"==(DST, CALC, gws_params, reduce_temp_shift);)==""\n"
R"==(diff_dst = GWS_GET_BUFFER_POS_NAMED(SRC, CALC, gws_params, diff_dst);)==""\n"
R"==(ws = GWS_GET_BUFFER_POS_NAMED(SRC, CALC, gws_params, ws);)==""\n"
R"==(src = GWS_GET_BUFFER_POS_NAMED(SRC, CALC, gws_params, src);)==""\n"
R"==(unroll_16_for(off_t i = 0; i < reduce_dim; i++) {)==""\n"
R"==(const off_t offi = i * (off_t)reduce_dim_stride;)==""\n"
R"==(float dd = CONVERT_FLOAT_T(diff_dst[offi]);)==""\n"
R"==(if (FUSE_BN_RELU && !ws[offi]) dd = 0;)==""\n"
R"==(diff_gamma += (CONVERT_FLOAT_T(src[offi]) - mean[c]) * dd;)==""\n"
R"==(diff_beta += dd;)==""\n"
R"==(})==""\n"
R"==(*reduce_temp = diff_gamma;)==""\n"
R"==(*reduce_temp_shift = diff_beta;)==""\n"
R"==(})==""\n"
R"==(NAMED_KERNEL_ATTR(REDUCE))==""\n"
R"==(__kernel void reusable_reduce_stats(__global float *reduce_temp,)==""\n"
R"==(__global float *reduce_temp_shift, __global float *diff_scale,)==""\n"
R"==(__global float *diff_shift, __global float *variance, float eps,)==""\n"
R"==(off_t ic, off_t reduce_dim, dispatch_gws_rt_params_t gws_params) {)==""\n"
R"==(reduce_temp)==""\n"
R"==(= GWS_GET_BUFFER_POS_NAMED(BUFFER, REDUCE, gws_params, reduce_temp);)==""\n"
R"==(reduce_temp_shift = GWS_GET_BUFFER_POS_NAMED()==""\n"
R"==(BUFFER, REDUCE, gws_params, reduce_temp_shift);)==""\n"
R"==(variance = GWS_GET_BUFFER_POS_NAMED(BUFFER, REDUCE, gws_params, variance);)==""\n"
R"==(diff_scale)==""\n"
R"==(= GWS_GET_BUFFER_POS_NAMED(BUFFER, REDUCE, gws_params, diff_scale);)==""\n"
R"==(diff_shift)==""\n"
R"==(= GWS_GET_BUFFER_POS_NAMED(BUFFER, REDUCE, gws_params, diff_shift);)==""\n"
R"==(float diff_gamma = 0.0f;)==""\n"
R"==(float diff_beta = 0.0f;)==""\n"
R"==(unroll_16_for(off_t i = 0; i < reduce_dim; i++) {)==""\n"
R"==(diff_gamma += reduce_temp[i * (off_t)ic];)==""\n"
R"==(diff_beta += reduce_temp_shift[i * (off_t)ic];)==""\n"
R"==(})==""\n"
R"==(float sqrt_variance = 1.0f / sqrt(*variance + eps);)==""\n"
R"==(*diff_scale = diff_gamma * sqrt_variance;)==""\n"
R"==(*diff_shift = diff_beta;)==""\n"
R"==(})==""\n"
R"==(KERNEL_ATTR)==""\n"
R"==(__kernel void reusable_bnorm_bwd(__global DATA_T *src, __global float *mean,)==""\n"
R"==(__global float *variance, __global DATA_T *diff_dst,)==""\n"
R"==(__global float *scale, __global char *ws, __global DATA_T *diff_src,)==""\n"
R"==(__global float *diff_scale, __global float *diff_shift, float eps,)==""\n"
R"==(__global DATA_T *diff_src_add, off_t div,)==""\n"
R"==(dispatch_gws_rt_params_t gws_params) {)==""\n"
R"==(const off_t c = GWS_GET_OFF(IC_DIM, gws_params);)==""\n"
R"==(diff_dst = GWS_GET_BUFFER_POS(BUFFER, gws_params, diff_dst);)==""\n"
R"==(ws = GWS_GET_BUFFER_POS(BUFFER, gws_params, ws);)==""\n"
R"==(diff_src_add = GWS_GET_BUFFER_POS(BUFFER, gws_params, diff_src_add);)==""\n"
R"==(src = GWS_GET_BUFFER_POS(BUFFER, gws_params, src);)==""\n"
R"==(diff_src = GWS_GET_BUFFER_POS(BUFFER, gws_params, diff_src);)==""\n"
R"==(float v_variance = variance[c];)==""\n"
R"==(float sqrt_variance = 1.0f / sqrt(v_variance + eps);)==""\n"
R"==(float gamma = USE_SCALE ? scale[c] : 1;)==""\n"
R"==(float dd = TO_DEF_ACC_DATA_T(*diff_dst);)==""\n"
R"==(#if FUSE_BN_RELU == 1)==""\n"
R"==(if (!*ws) dd = 0;)==""\n"
R"==(if (FUSE_BN_ADD_RELU) *diff_src_add = TO_DATA_T(dd);)==""\n"
R"==(#endif)==""\n"
R"==(float v_diff_src = dd;)==""\n"
R"==(#if CALCULATE_STATS == 1)==""\n"
R"==(float v_mean = mean[c];)==""\n"
R"==(float diff_gamma = diff_scale[c];)==""\n"
R"==(float diff_beta = diff_shift[c];)==""\n"
R"==(v_diff_src -= diff_beta / div)==""\n"
R"==(+ (CONVERT_FLOAT_T(*src) - v_mean) * diff_gamma * sqrt_variance)==""\n"
R"==(/ div;)==""\n"
R"==(#endif)==""\n"
R"==(v_diff_src *= gamma * sqrt_variance;)==""\n"
R"==(*diff_src = TO_DATA_T(v_diff_src);)==""\n"
R"==(})==""\n"
R"==()==";
}
}
}
}
}