namespace dnnl {
namespace impl {
namespace gpu {
namespace intel {
namespace ocl {
const char *rnn_reorder_kernel = R"==(/*******************************************************************************)==""\n"
R"==(* Copyright 2019-2024 Intel Corporation)==""\n"
R"==(*)==""\n"
R"==(* Licensed under the Apache License, Version 2.0 (the "License");)==""\n"
R"==(* you may not use this file except in compliance with the License.)==""\n"
R"==(* You may obtain a copy of the License at)==""\n"
R"==(*)==""\n"
R"==(* http:)==""\n"
R"==(*)==""\n"
R"==(* Unless required by applicable law or agreed to in writing, software)==""\n"
R"==(* distributed under the License is distributed on an "AS IS" BASIS,)==""\n"
R"==(* WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.)==""\n"
R"==(* See the License for the specific language governing permissions and)==""\n"
R"==(* limitations under the License.)==""\n"
R"==(*******************************************************************************/)==""\n"
R"==(#define DT_UNDEF)==""\n"
R"==(#include "gpu/intel/ocl/dispatch.h")==""\n"
R"==(#include "gpu/intel/ocl/ocl_types.h")==""\n"
R"==(#if IN_TYPE_F16 || OUT_TYPE_F16)==""\n"
R"==(#pragma OPENCL EXTENSION cl_khr_fp16 : enable)==""\n"
R"==(#endif)==""\n"
R"==(#define IN_OFF(x0, x1, x2, x3, x4, x5) \)==""\n"
R"==((((x0) % SRC_B0) * SRC_SB0 + ((x0) / SRC_B0) * SRC_S0 \)==""\n"
R"==(+ ((x1) % SRC_B1) * SRC_SB1 + ((x1) / SRC_B1) * SRC_S1 \)==""\n"
R"==(+ ((x2) % SRC_B2) * SRC_SB2 + ((x2) / SRC_B2) * SRC_S2 \)==""\n"
R"==(+ ((x3) % SRC_B3) * SRC_SB3 + ((x3) / SRC_B3) * SRC_S3 \)==""\n"
R"==(+ ((x4) % SRC_B4) * SRC_SB4 + ((x4) / SRC_B4) * SRC_S4 \)==""\n"
R"==(+ ((x5) % SRC_B5) * SRC_SB5 + ((x5) / SRC_B5) * SRC_S5))==""\n"
R"==(#define OUT_OFF(x0, x1, x2, x3, x4, x5) \)==""\n"
R"==((((x0) % DST_B0) * DST_SB0 + ((x0) / DST_B0) * DST_S0 \)==""\n"
R"==(+ ((x1) % DST_B1) * DST_SB1 + ((x1) / DST_B1) * DST_S1 \)==""\n"
R"==(+ ((x2) % DST_B2) * DST_SB2 + ((x2) / DST_B2) * DST_S2 \)==""\n"
R"==(+ ((x3) % DST_B3) * DST_SB3 + ((x3) / DST_B3) * DST_S3 \)==""\n"
R"==(+ ((x4) % DST_B4) * DST_SB4 + ((x4) / DST_B4) * DST_S4 \)==""\n"
R"==(+ ((x5) % DST_B5) * DST_SB5 + ((x5) / DST_B5) * DST_S5))==""\n"
R"==(#if IN_TYPE_F32)==""\n"
R"==(#define DT_IN float)==""\n"
R"==(#else)==""\n"
R"==(#error Unimplemented)==""\n"
R"==(#endif )==""\n"
R"==(#if OUT_TYPE_S8)==""\n"
R"==(#define DT_OUT char)==""\n"
R"==(#else)==""\n"
R"==(#error Unimplemented)==""\n"
R"==(#endif )==""\n"
R"==(#if OUT_TYPE_S8)==""\n"
R"==(#define CONVERT_F32_TO_OUT convert_char_sat_rte)==""\n"
R"==(#define CONVERT_F32_TO_OUT8 convert_char8_sat_rte)==""\n"
R"==(#else)==""\n"
R"==(#error Unimplemented)==""\n"
R"==(#endif)==""\n"
R"==(#define CONVERT_IN_TO_OUT(x) CONVERT_F32_TO_OUT(x))==""\n"
R"==(#define QZ_B0(v, scale) CONVERT_F32_TO_OUT(v *scale))==""\n"
R"==(#define REORDER(_out, _in, _s) \)==""\n"
R"==(do { \)==""\n"
R"==(_out = QZ_B0(_in, _s); \)==""\n"
R"==(} while (0))==""\n"
R"==(#define COMP_DT float)==""\n"
R"==(#define COMP_DST_OFFSET_EL (DST_D0 * DST_S0))==""\n"
R"==(#define COMP_OFF(i0, i1, i2, i3) \)==""\n"
R"==(((((i0) * (DST_D1) + (i1)) * (DST_D3) + (i2)) * (DST_D4) + (i3)))==""\n"
R"==(KERNEL_ATTR)==""\n"
R"==(__kernel void wei_reorder(__global DT_IN *input, __global DT_IN *scales,)==""\n"
R"==(__global DT_OUT *output) {)==""\n"
R"==(__global char *temp = (__global char *)(output + COMP_DST_OFFSET_EL);)==""\n"
R"==(__global COMP_DT *comp)==""\n"
R"==(= (__global COMP_DT *)(((unsigned long)temp + (sizeof(COMP_DT) - 1)))==""\n"
R"==(& -sizeof(COMP_DT));)==""\n"
R"==(#if REF_REORDER)==""\n"
R"==(const int d0 = GWS_GET_D0();)==""\n"
R"==(const int d1 = GWS_GET_D1();)==""\n"
R"==(const int d3 = GWS_GET_D3();)==""\n"
R"==(const int d4 = GWS_GET_D4();)==""\n"
R"==(#if MASK)==""\n"
R"==(float s = scales[d3 * SRC_D4 + d4];)==""\n"
R"==(#else)==""\n"
R"==(float s = scales[0];)==""\n"
R"==(#endif)==""\n"
R"==(int reduction = 0;)==""\n"
R"==(for (int d2 = 0; d2 < SRC_D2; ++d2) {)==""\n"
R"==(const int in_off = IN_OFF(d0, d1, d2, d3, d4, 0);)==""\n"
R"==(const int out_off = OUT_OFF(d0, d1, d2, d3, d4, 0);)==""\n"
R"==(REORDER(output[out_off], input[in_off], s);)==""\n"
R"==(reduction += convert_int(QZ_B0(input[in_off], s));)==""\n"
R"==(})==""\n"
R"==(comp[COMP_OFF(d0, d1, d3, d4)] = convert_float(reduction);)==""\n"
R"==(#else)==""\n"
R"==(#error Unimplemented)==""\n"
R"==(#endif)==""\n"
R"==(})==""\n"
R"==()==";
}
}
}
}
}