namespace dnnl {
namespace impl {
namespace gpu {
namespace intel {
namespace ocl {
const char *simple_binary_kernel = R"==(/*******************************************************************************)==""\n"
R"==(* Copyright 2019-2024 Intel Corporation)==""\n"
R"==(*)==""\n"
R"==(* Licensed under the Apache License, Version 2.0 (the "License");)==""\n"
R"==(* you may not use this file except in compliance with the License.)==""\n"
R"==(* You may obtain a copy of the License at)==""\n"
R"==(*)==""\n"
R"==(* http:)==""\n"
R"==(*)==""\n"
R"==(* Unless required by applicable law or agreed to in writing, software)==""\n"
R"==(* distributed under the License is distributed on an "AS IS" BASIS,)==""\n"
R"==(* WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.)==""\n"
R"==(* See the License for the specific language governing permissions and)==""\n"
R"==(* limitations under the License.)==""\n"
R"==(*******************************************************************************/)==""\n"
R"==(#include "gpu/intel/ocl/binary_common.h")==""\n"
R"==(#if IS_TENSOR_OP && IS_DENSE && IS_SAME_MD && !WITH_BINARY_POST_OP)==""\n"
R"==(KERNEL_ATTR)==""\n"
R"==(__kernel void simple_binary(__global DATA_T *src0, __global DATA_T *src1,)==""\n"
R"==(__global DST_DATA_T *dst POST_OP_ARGS, __global float *src0_scale,)==""\n"
R"==(__global float *src1_scale) {)==""\n"
R"==(int off = GWS_GET_IDX();)==""\n"
R"==(float tmp_src0 = SRC0_TO_FLOAT(src0[off]);)==""\n"
R"==(float tmp_src1 = SRC1_TO_FLOAT(src1[off]);)==""\n"
R"==(float d = 0;)==""\n"
R"==(#if WITH_SRC0_SCALE)==""\n"
R"==(tmp_src0 = tmp_src0 * (*src0_scale);)==""\n"
R"==(#endif)==""\n"
R"==(#if WITH_SRC1_SCALE)==""\n"
R"==(tmp_src1 = tmp_src1 * (*src1_scale);)==""\n"
R"==(#endif)==""\n"
R"==(d = binary_op(BINARY_ALG, tmp_src0, tmp_src1);)==""\n"
R"==(float dst_data;)==""\n"
R"==(#if WITH_SUM)==""\n"
R"==(dst_data = CONVERT_FLOAT_T(dst[off]);)==""\n"
R"==(#endif)==""\n"
R"==(APPLY_POST_OPS_SERIAL()==""\n"
R"==(d, float, dst_data, float, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0);)==""\n"
R"==(dst[off] = TO_DST(d);)==""\n"
R"==(})==""\n"
R"==(#else)==""\n"
R"==(KERNEL_ATTR)==""\n"
R"==(__kernel void simple_binary(__global SRC0_DATA_T *src0,)==""\n"
R"==(__global SRC1_DATA_T *src1, __global DST_DATA_T *dst POST_OP_ARGS,)==""\n"
R"==(__global float *src0_scale, __global float *src1_scale) {)==""\n"
R"==(int dims0[6] = {0};)==""\n"
R"==(dims0[0] = GWS_GET_D0();)==""\n"
R"==(dims0[1] = GWS_GET_D1();)==""\n"
R"==(dims0[2] = GWS_GET_D2();)==""\n"
R"==(dims0[3] = GWS_GET_D3();)==""\n"
R"==(dims0[4] = GWS_GET_D4();)==""\n"
R"==(dims0[5] = GWS_GET_D5();)==""\n"
R"==(int d1_block = GWS_GET_D1_BLOCK();)==""\n"
R"==(int dims0_po[6])==""\n"
R"==(= {dims0[0], dims0[1], dims0[2], dims0[3], dims0[4], dims0[5]};)==""\n"
R"==(int d1_init = GWS_GET_D1();)==""\n"
R"==(int dst_off = DST_OFF()==""\n"
R"==(dims0[0], dims0[1], dims0[2], dims0[3], dims0[4], dims0[5]);)==""\n"
R"==(#if TENSOR_OP)==""\n"
R"==(int src0_off = SRC0_OFF()==""\n"
R"==(dims0[0], dims0[1], dims0[2], dims0[3], dims0[4], dims0[5]);)==""\n"
R"==(int src1_off = SRC1_OFF()==""\n"
R"==(dims0[0], dims0[1], dims0[2], dims0[3], dims0[4], dims0[5]);)==""\n"
R"==(#else)==""\n"
R"==(int src0_off)==""\n"
R"==(= SRC0_OFF(dims0[0] * !SRC0_BCAST_DIM0, dims0[1] * !SRC0_BCAST_DIM1,)==""\n"
R"==(dims0[2] * !SRC0_BCAST_DIM2, dims0[3] * !SRC0_BCAST_DIM3,)==""\n"
R"==(dims0[4] * !SRC0_BCAST_DIM4, dims0[5] * !SRC0_BCAST_DIM5);)==""\n"
R"==(int src1_off)==""\n"
R"==(= SRC1_OFF(dims0[0] * !SRC1_BCAST_DIM0, dims0[1] * !SRC1_BCAST_DIM1,)==""\n"
R"==(dims0[2] * !SRC1_BCAST_DIM2, dims0[3] * !SRC1_BCAST_DIM3,)==""\n"
R"==(dims0[4] * !SRC1_BCAST_DIM4, dims0[5] * !SRC1_BCAST_DIM5);)==""\n"
R"==(#endif)==""\n"
R"==(int block_size = d1_block;)==""\n"
R"==(if (dims0[0] >= DST_D0) {)==""\n"
R"==(for (int ic = 0; ic < block_size; ++ic) {)==""\n"
R"==(dst[dst_off] = TO_DST(0.0f);)==""\n"
R"==(dst_off++;)==""\n"
R"==(})==""\n"
R"==(return;)==""\n"
R"==(})==""\n"
R"==(if (d1_init + block_size <= DST_D1) {)==""\n"
R"==(for (int ic = 0; ic < block_size; ++ic) {)==""\n"
R"==(float tmp_src0 = SRC0_TO_FLOAT(src0[src0_off]);)==""\n"
R"==(float tmp_src1 = SRC1_TO_FLOAT(src1[src1_off]);)==""\n"
R"==(float d = 0;)==""\n"
R"==(#if WITH_SRC0_SCALE)==""\n"
R"==(tmp_src0 = tmp_src0 * (*src0_scale);)==""\n"
R"==(#endif)==""\n"
R"==(#if WITH_SRC1_SCALE)==""\n"
R"==(tmp_src1 = tmp_src1 * (*src1_scale);)==""\n"
R"==(#endif)==""\n"
R"==(d = binary_op(BINARY_ALG, tmp_src0, tmp_src1);)==""\n"
R"==(float dst_data;)==""\n"
R"==(#if WITH_SUM)==""\n"
R"==(dst_data = CONVERT_FLOAT_T(dst[dst_off]);)==""\n"
R"==(#endif)==""\n"
R"==(APPLY_POST_OPS_SERIAL(d, float, dst_data, float, dims0_po[0], 1,)==""\n"
R"==(dims0_po[1], 1, dims0_po[2], 1, dims0_po[3], 1, dims0_po[4],)==""\n"
R"==(1, dims0_po[5], 1);)==""\n"
R"==(dst[dst_off] = TO_DST(d);)==""\n"
R"==(#if USE_UNROLL_16B || SRC0_UNROLL_16B)==""\n"
R"==(src0_off++;)==""\n"
R"==(dst_off++;)==""\n"
R"==(++dims0_po[1];)==""\n"
R"==(if (USE_UNROLL_16B && (SRC1_D1 > 1)) {)==""\n"
R"==(src1_off++;)==""\n"
R"==(} else if (SRC0_UNROLL_16B && (SRC1_D1 > 1)) {)==""\n"
R"==(src1_off += SRC1_S1_0; )==""\n"
R"==(})==""\n"
R"==(#endif)==""\n"
R"==(})==""\n"
R"==(} else {)==""\n"
R"==(for (int ic = 0; ic < DST_D1 - d1_init; ic++) {)==""\n"
R"==(float tmp_src0 = SRC0_TO_FLOAT(src0[src0_off]);)==""\n"
R"==(float tmp_src1 = SRC1_TO_FLOAT(src1[src1_off]);)==""\n"
R"==(float d = 0;)==""\n"
R"==(#if WITH_SRC0_SCALE)==""\n"
R"==(tmp_src0 = tmp_src0 * (*src0_scale);)==""\n"
R"==(#endif)==""\n"
R"==(#if WITH_SRC1_SCALE)==""\n"
R"==(tmp_src1 = tmp_src1 * (*src1_scale);)==""\n"
R"==(#endif)==""\n"
R"==(d = binary_op(BINARY_ALG, tmp_src0, tmp_src1);)==""\n"
R"==(float dst_data;)==""\n"
R"==(#if WITH_SUM)==""\n"
R"==(dst_data = CONVERT_FLOAT_T(dst[dst_off]);)==""\n"
R"==(#endif)==""\n"
R"==(APPLY_POST_OPS_SERIAL(d, float, dst_data, float, dims0_po[0], 1,)==""\n"
R"==(dims0_po[1], 1, dims0_po[2], 1, dims0_po[3], 1, dims0_po[4],)==""\n"
R"==(1, dims0_po[5], 1);)==""\n"
R"==(dst[dst_off] = TO_DST(d);)==""\n"
R"==(#if USE_UNROLL_16B || SRC0_UNROLL_16B)==""\n"
R"==(src0_off++;)==""\n"
R"==(dst_off++;)==""\n"
R"==(++dims0_po[1];)==""\n"
R"==(if (USE_UNROLL_16B && (SRC1_D1 > 1)) {)==""\n"
R"==(src1_off++;)==""\n"
R"==(} else if (SRC0_UNROLL_16B && (SRC1_D1 > 1)) {)==""\n"
R"==(src1_off += SRC1_S1_0; )==""\n"
R"==(})==""\n"
R"==(#endif)==""\n"
R"==(})==""\n"
R"==(#if DST_D1 != DST_PD1)==""\n"
R"==(for (int ic = 0; ic < min(DST_PD1 - DST_D1, block_size); ic++) {)==""\n"
R"==(dst[dst_off] = TO_DST(0.0f);)==""\n"
R"==(dst_off++;)==""\n"
R"==(})==""\n"
R"==(#endif)==""\n"
R"==(})==""\n"
R"==(})==""\n"
R"==(#endif)==""\n"
R"==()==";
}
}
}
}
}