namespace dnnl {
namespace impl {
namespace gpu {
namespace intel {
namespace ocl {
const char *tile_ops_header = R"==(/*******************************************************************************)==""\n"
R"==(* Copyright 2024 Intel Corporation)==""\n"
R"==(*)==""\n"
R"==(* Licensed under the Apache License, Version 2.0 (the "License");)==""\n"
R"==(* you may not use this file except in compliance with the License.)==""\n"
R"==(* You may obtain a copy of the License at)==""\n"
R"==(*)==""\n"
R"==(* http:)==""\n"
R"==(*)==""\n"
R"==(* Unless required by applicable law or agreed to in writing, software)==""\n"
R"==(* distributed under the License is distributed on an "AS IS" BASIS,)==""\n"
R"==(* WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.)==""\n"
R"==(* See the License for the specific language governing permissions and)==""\n"
R"==(* limitations under the License.)==""\n"
R"==(*******************************************************************************/)==""\n"
R"==(#ifndef GPU_OCL_TILE_OPS_H)==""\n"
R"==(#define GPU_OCL_TILE_OPS_H)==""\n"
R"==(#include "gpu/intel/ocl/ocl_generic_vector_ops.h")==""\n"
R"==(float __builtin_IB_atomic_max_local_f32(__local float *, float);)==""\n"
R"==(__attribute__((overloadable)) float local_atomic_max(local float *p, float v) {)==""\n"
R"==(return __builtin_IB_atomic_max_local_f32(p, v);)==""\n"
R"==(})==""\n"
R"==(__attribute__((overloadable)) half local_atomic_max()==""\n"
R"==(local half *p, half v) { /* not implemented */)==""\n"
R"==(return v;)==""\n"
R"==(})==""\n"
R"==(__attribute__((overloadable)) uint local_atomic_max(local uint *p, uint v) {)==""\n"
R"==(return atomic_max(p, v);)==""\n"
R"==(})==""\n"
R"==(__attribute__((overloadable)) int local_atomic_max(local int *p, int v) {)==""\n"
R"==(return atomic_max(p, v);)==""\n"
R"==(})==""\n"
R"==(#define DEF_BLOCK_LOAD_STORE(type, itype, suffix, n) \)==""\n"
R"==(__attribute__((overloadable)) type##n block_load( \)==""\n"
R"==(const global type *p, int vlen) \)==""\n"
R"==(__attribute__((enable_if(vlen == n, "wrong vector length"))) { \)==""\n"
R"==(return as_##type##n( \)==""\n"
R"==(intel_sub_group_block_read##suffix##n((global void *)p)); \)==""\n"
R"==(} \)==""\n"
R"==(__attribute__((overloadable)) void block_store( \)==""\n"
R"==(global type *p, type##n v) { \)==""\n"
R"==(intel_sub_group_block_write##suffix##n( \)==""\n"
R"==((global itype *)p, as_##itype##n(v)); \)==""\n"
R"==(})==""\n"
R"==(#define DEF_BLOCK_LOAD_STORE1(type, itype, suffix) \)==""\n"
R"==(__attribute__((overloadable)) \)==""\n"
R"==(type##1 block_load(const global type *p, int vlen) __attribute__( \)==""\n"
R"==((enable_if(vlen == 1, "wrong vector length"))) { \)==""\n"
R"==(type##1 x; \)==""\n"
R"==(x[0] = as_##type( \)==""\n"
R"==(intel_sub_group_block_read##suffix((global void *)p)); \)==""\n"
R"==(return x; \)==""\n"
R"==(} \)==""\n"
R"==(__attribute__((overloadable)) void block_store( \)==""\n"
R"==(global type *p, type##1 v) { \)==""\n"
R"==(intel_sub_group_block_write##suffix( \)==""\n"
R"==((global itype *)p, as_##itype(v[0])); \)==""\n"
R"==(})==""\n"
R"==(#define DEF_BLOCK_LOAD_STORE16(type, itype, suffix) \)==""\n"
R"==(__attribute__((overloadable)) \)==""\n"
R"==(type##16 block_load(const global type *p, int vlen) __attribute__( \)==""\n"
R"==((enable_if(vlen == 16, "wrong vector length"))) { \)==""\n"
R"==(type##16 x; \)==""\n"
R"==(x.s01234567 = as_##type##8( \)==""\n"
R"==(intel_sub_group_block_read##suffix##8((global void *)p)); \)==""\n"
R"==(x.s89abcdef = as_##type##8(intel_sub_group_block_read##suffix##8( \)==""\n"
R"==((global void *)(p + 8 * get_sub_group_size()))); \)==""\n"
R"==(return x; \)==""\n"
R"==(} \)==""\n"
R"==(__attribute__((overloadable)) void block_store( \)==""\n"
R"==(global type *p, type##16 v) { \)==""\n"
R"==(intel_sub_group_block_write##suffix##8( \)==""\n"
R"==((global itype *)p, as_##itype##8(v.s01234567)); \)==""\n"
R"==(intel_sub_group_block_write##suffix##8( \)==""\n"
R"==((global itype *)(p + 8 * get_sub_group_size()), \)==""\n"
R"==(as_##itype##8(v.s89abcdef)); \)==""\n"
R"==(})==""\n"
R"==(DEF_BLOCK_LOAD_STORE1(half, ushort, _us))==""\n"
R"==(DEF_BLOCK_LOAD_STORE(half, ushort, _us, 2))==""\n"
R"==(DEF_BLOCK_LOAD_STORE(half, ushort, _us, 4))==""\n"
R"==(DEF_BLOCK_LOAD_STORE(half, ushort, _us, 8))==""\n"
R"==(DEF_BLOCK_LOAD_STORE(half, ushort, _us, 16))==""\n"
R"==(DEF_BLOCK_LOAD_STORE1(uint, uint, ))==""\n"
R"==(DEF_BLOCK_LOAD_STORE(uint, uint, , 2))==""\n"
R"==(DEF_BLOCK_LOAD_STORE(uint, uint, , 4))==""\n"
R"==(DEF_BLOCK_LOAD_STORE(uint, uint, , 8))==""\n"
R"==(DEF_BLOCK_LOAD_STORE16(uint, uint, ))==""\n"
R"==(#define DEF_BLOCK2D_LOAD_STORE(type, itype, vl, SG, suffix, BR, BC) \)==""\n"
R"==(itype##vl __builtin_IB_subgroup_block_read_flat_##suffix( \)==""\n"
R"==(long, int, int, int, int2); \)==""\n"
R"==(void __builtin_IB_subgroup_block_write_flat_##suffix( \)==""\n"
R"==(long, int, int, int, int2, itype##vl); \)==""\n"
R"==(__attribute__((overloadable)) type##vl block2d_load(const global type *p, \)==""\n"
R"==(int w, int h, int ld, int x, int y, int br, int bc, \)==""\n"
R"==(int sg) __attribute__((enable_if(br == BR, "wrong #rows"))) \)==""\n"
R"==(__attribute__((enable_if(bc == BC, "wrong #columns"))) \)==""\n"
R"==(__attribute__( \)==""\n"
R"==((enable_if(sg == SG, "wrong subgroup size"))) { \)==""\n"
R"==(ulong pp = as_long(p); \)==""\n"
R"==(ulong prem = pp & 0x3F; \)==""\n"
R"==(pp &= ~0x3F; \)==""\n"
R"==(x += (prem / sizeof(type)); \)==""\n"
R"==(w += prem; \)==""\n"
R"==(int2 coord = {x, y}; \)==""\n"
R"==(return as_##type##vl(__builtin_IB_subgroup_block_read_flat_##suffix( \)==""\n"
R"==(pp, w - 1, h - 1, ld - 1, coord)); \)==""\n"
R"==(} \)==""\n"
R"==(__attribute__((overloadable)) void block2d_store(type##vl v, \)==""\n"
R"==(global type *p, int w, int h, int ld, int x, int y, int br, \)==""\n"
R"==(int bc, \)==""\n"
R"==(int sg) __attribute__((enable_if(br == BR, "wrong #rows"))) \)==""\n"
R"==(__attribute__((enable_if(bc == BC, "wrong #columns"))) \)==""\n"
R"==(__attribute__( \)==""\n"
R"==((enable_if(sg == SG, "wrong subgroup size"))) { \)==""\n"
R"==(ulong pp = as_long(p); \)==""\n"
R"==(ulong prem = pp & 0x3F; \)==""\n"
R"==(pp &= ~0x3F; \)==""\n"
R"==(x += (prem / sizeof(type)); \)==""\n"
R"==(w += prem; \)==""\n"
R"==(int2 coord = {x, y}; \)==""\n"
R"==(__builtin_IB_subgroup_block_write_flat_##suffix( \)==""\n"
R"==(pp, w - 1, h - 1, ld - 1, coord, as_##itype##vl(v)); \)==""\n"
R"==(})==""\n"
R"==(DEF_BLOCK2D_LOAD_STORE(half, ushort, 8, 16, u16_m4k32v1, 32, 4))==""\n"
R"==(DEF_BLOCK2D_LOAD_STORE(half, ushort, 16, 16, u16_m8k32v1, 32, 8))==""\n"
R"==(#define tile_fill(t, v) \)==""\n"
R"==(do { \)==""\n"
R"==(_Pragma("unroll") for (int i = 0; i < sizeof(t.x) / sizeof(t.x[0]); \)==""\n"
R"==(i++) t.x[i] \)==""\n"
R"==(= v; \)==""\n"
R"==(} while (0))==""\n"
R"==(#define tile_elementwise(t, f) \)==""\n"
R"==(do { \)==""\n"
R"==(_Pragma("unroll") for (int i = 0; i < sizeof(t.x) / sizeof(t.x[0]); \)==""\n"
R"==(i++) t.x[i] \)==""\n"
R"==(= f(t.x[i]); \)==""\n"
R"==(} while (0))==""\n"
R"==(#define tile_elementwise_s(t, f) \)==""\n"
R"==(do { \)==""\n"
R"==(_Pragma("unroll") for (int i = 0; i < sizeof(t.x) / sizeof(t.x[0]); \)==""\n"
R"==(i++) { \)==""\n"
R"==(_Pragma("unroll") for (int s = 0; \)==""\n"
R"==(s < sizeof(t.x[0]) / sizeof(t.x[0][0]); \)==""\n"
R"==(s++) t.x[i][s] \)==""\n"
R"==(= f(t.x[i][s]); \)==""\n"
R"==(} \)==""\n"
R"==(} while (0))==""\n"
R"==(#define tile_binary(t, t2, f) \)==""\n"
R"==(do { \)==""\n"
R"==(_Pragma("unroll") for (int i = 0; i < sizeof(t.x) / sizeof(t.x[0]); \)==""\n"
R"==(i++) t.x[i] \)==""\n"
R"==(= f(t.x[i], t2.x[i]); \)==""\n"
R"==(} while (0))==""\n"
R"==(#define tile_copy(t, t_new) \)==""\n"
R"==(do { \)==""\n"
R"==(_Pragma("unroll") for (int i = 0; i < sizeof(t.x) / sizeof(t.x[0]); \)==""\n"
R"==(i++) t_new.x[i] \)==""\n"
R"==(= __builtin_convertvector(t.x[i], __typeof__(t_new.x[i])); \)==""\n"
R"==(} while (0))==""\n"
R"==(#define tile_copy_to_half2(t, t_new) \)==""\n"
R"==(do { \)==""\n"
R"==(_Pragma("unroll") for (int i = 0; i < sizeof(t.x) / sizeof(t.x[0]); \)==""\n"
R"==(i++) { \)==""\n"
R"==(_Pragma("unroll") for (int s = 0; \)==""\n"
R"==(s < sizeof(t.x[0]) / sizeof(t.x[0][0]) / 2; \)==""\n"
R"==(s++) { \)==""\n"
R"==(half2 v = {t.x[i][2 * s], t.x[i][2 * s + 1]}; \)==""\n"
R"==(t_new.x[i][s] = as_uint(v); \)==""\n"
R"==(} \)==""\n"
R"==(} \)==""\n"
R"==(} while (0))==""\n"
R"==(#define tile_access(t, i0, j, sg, br, bc, nbr) \)==""\n"
R"==((t).x[(i0) / (br) + (nbr) * ((j) / (bc))] \)==""\n"
R"==([((i0) % (br)) / (sg) + ((j) % (bc)) * ((br) / (sg))])==""\n"
R"==(#define xlane_tile_access(t, i, j, sg, br, bc, nbr) \)==""\n"
R"==(sub_group_broadcast(tile_access(t, i, j, sg, br, bc, nbr), i % sg))==""\n"
R"==(#define DECLARE_2D_TILE_OPS(tile_type, element_type, sg, br, bc, nbr, nbc) \)==""\n"
R"==(__attribute__((overloadable)) void tile_load_full(tile_type *t, \)==""\n"
R"==(const global element_type *ptr, int ld, int offset_r, \)==""\n"
R"==(int offset_c) { \)==""\n"
R"==(ptr += ld * offset_c + offset_r; \)==""\n"
R"==(_Pragma("unroll") for (int j = 0; j < bc * nbc; j++, ptr += ld) { \)==""\n"
R"==(_Pragma("unroll") for (int i0 = 0; i0 < br * nbr; i0 += sg) { \)==""\n"
R"==(int i = i0 + get_sub_group_local_id(); \)==""\n"
R"==(tile_access(*t, i0, j, sg, br, bc, nbr) = ptr[i]; \)==""\n"
R"==(} \)==""\n"
R"==(} \)==""\n"
R"==(} \)==""\n"
R"==(__attribute__((overloadable)) void tile_load_full(tile_type *t, \)==""\n"
R"==(const local element_type *ptr, int ld, int offset_r, \)==""\n"
R"==(int offset_c) { \)==""\n"
R"==(ptr += ld * offset_c + offset_r; \)==""\n"
R"==(_Pragma("unroll") for (int j = 0; j < bc * nbc; j++, ptr += ld) { \)==""\n"
R"==(_Pragma("unroll") for (int i0 = 0; i0 < br * nbr; i0 += sg) { \)==""\n"
R"==(int i = i0 + get_sub_group_local_id(); \)==""\n"
R"==(tile_access(*t, i0, j, sg, br, bc, nbr) = ptr[i]; \)==""\n"
R"==(} \)==""\n"
R"==(} \)==""\n"
R"==(} \)==""\n"
R"==(__attribute__((overloadable)) void tile_load(tile_type *t, \)==""\n"
R"==(const global element_type *ptr, int m, int n, int ld, \)==""\n"
R"==(int offset_r, int offset_c) { \)==""\n"
R"==(if (m >= offset_r + br * nbr && n >= offset_c + bc * nbc) { \)==""\n"
R"==(tile_load_full(t, ptr, ld, offset_r, offset_c); \)==""\n"
R"==(return; \)==""\n"
R"==(} \)==""\n"
R"==(ptr += ld * offset_c + offset_r; \)==""\n"
R"==(_Pragma("unroll") for (int j = 0; j < bc * nbc; j++, ptr += ld) { \)==""\n"
R"==(if (offset_c + j < n) { \)==""\n"
R"==(_Pragma("unroll") for (int i0 = 0; i0 < br * nbr; i0 += sg) { \)==""\n"
R"==(int i = i0 + get_sub_group_local_id(); \)==""\n"
R"==(if (offset_r + i < m) \)==""\n"
R"==(tile_access(*t, i0, j, sg, br, bc, nbr) = ptr[i]; \)==""\n"
R"==(} \)==""\n"
R"==(} \)==""\n"
R"==(} \)==""\n"
R"==(} \)==""\n"
R"==(__attribute__((overloadable)) void tile_load(tile_type *t, \)==""\n"
R"==(const global element_type *ptr, int m, int n, int offset_r, \)==""\n"
R"==(int offset_c) { \)==""\n"
R"==(tile_load(t, ptr, m, n, m, offset_r, offset_c); \)==""\n"
R"==(} \)==""\n"
R"==(__attribute__((overloadable)) void tile_load_t_full(tile_type *t, \)==""\n"
R"==(const global element_type *ptr, int ld, int offset_r, \)==""\n"
R"==(int offset_c) { \)==""\n"
R"==(ptr += ld * offset_r + offset_c; \)==""\n"
R"==(_Pragma("unroll") for (int i0 = 0; i0 < br * nbr; \)==""\n"
R"==(i0 += sg, ptr += ld * sg) { \)==""\n"
R"==(_Pragma("unroll") for (int j = 0; j < bc * nbc; j++) { \)==""\n"
R"==(tile_access(*t, i0, j, sg, br, bc, nbr) \)==""\n"
R"==(= ptr[get_sub_group_local_id() * ld + j]; \)==""\n"
R"==(} \)==""\n"
R"==(} \)==""\n"
R"==(} \)==""\n"
R"==(__attribute__((overloadable)) void tile_load_t(tile_type *t, \)==""\n"
R"==(const global element_type *ptr, int m, int n, int ld, \)==""\n"
R"==(int offset_r, int offset_c) { \)==""\n"
R"==(if (m >= offset_r + br * nbr && n >= offset_c + bc * nbc) { \)==""\n"
R"==(tile_load_t_full(t, ptr, ld, offset_r, offset_c); \)==""\n"
R"==(return; \)==""\n"
R"==(} \)==""\n"
R"==(ptr += ld * offset_r + offset_c; \)==""\n"
R"==(_Pragma("unroll") for (int i0 = 0; i0 < br * nbr; \)==""\n"
R"==(i0 += sg, ptr += ld * sg) { \)==""\n"
R"==(int i = i0 + get_sub_group_local_id(); \)==""\n"
R"==(if (offset_r + i < m) \)==""\n"
R"==(_Pragma("unroll") for (int j = 0; j < bc * nbc; j++) { \)==""\n"
R"==(if (offset_c + j < n) { \)==""\n"
R"==(tile_access(*t, i0, j, sg, br, bc, nbr) \)==""\n"
R"==(= ptr[get_sub_group_local_id() * ld + j]; \)==""\n"
R"==(} \)==""\n"
R"==(} \)==""\n"
R"==(} \)==""\n"
R"==(} \)==""\n"
R"==(__attribute__((overloadable)) void tile_load_t(tile_type *t, \)==""\n"
R"==(const global element_type *ptr, int m, int n, int offset_r, \)==""\n"
R"==(int offset_c) { \)==""\n"
R"==(tile_load_t(t, ptr, m, n, n, offset_r, offset_c); \)==""\n"
R"==(} \)==""\n"
R"==(__attribute__((overloadable)) void tile_store_full(tile_type t, \)==""\n"
R"==(local element_type *ptr, int ld, int offset_r, int offset_c) { \)==""\n"
R"==(ptr += ld * offset_c + offset_r; \)==""\n"
R"==(_Pragma("unroll") for (int j = 0; j < bc * nbc; j++, ptr += ld) { \)==""\n"
R"==(_Pragma("unroll") for (int i0 = 0; i0 < br * nbr; i0 += sg) { \)==""\n"
R"==(int i = i0 + get_sub_group_local_id(); \)==""\n"
R"==(ptr[i] = tile_access(t, i0, j, sg, br, bc, nbr); \)==""\n"
R"==(} \)==""\n"
R"==(} \)==""\n"
R"==(} \)==""\n"
R"==(__attribute__((overloadable)) void tile_store_full(tile_type t, \)==""\n"
R"==(global element_type *ptr, int ld, int offset_r, int offset_c) { \)==""\n"
R"==(ptr += ld * offset_c + offset_r; \)==""\n"
R"==(_Pragma("unroll") for (int j = 0; j < bc * nbc; j++, ptr += ld) { \)==""\n"
R"==(_Pragma("unroll") for (int i0 = 0; i0 < br * nbr; i0 += sg) { \)==""\n"
R"==(int i = i0 + get_sub_group_local_id(); \)==""\n"
R"==(ptr[i] = tile_access(t, i0, j, sg, br, bc, nbr); \)==""\n"
R"==(} \)==""\n"
R"==(} \)==""\n"
R"==(} \)==""\n"
R"==(__attribute__((overloadable)) void tile_store(tile_type t, \)==""\n"
R"==(global element_type *ptr, int m, int n, int ld, int offset_r, \)==""\n"
R"==(int offset_c) { \)==""\n"
R"==(if (m >= offset_r + br * nbr && n >= offset_c + bc * nbc) { \)==""\n"
R"==(tile_store_full(t, ptr, ld, offset_r, offset_c); \)==""\n"
R"==(return; \)==""\n"
R"==(} \)==""\n"
R"==(ptr += ld * offset_c + offset_r; \)==""\n"
R"==(_Pragma("unroll") for (int j = 0; j < bc * nbc; j++, ptr += ld) { \)==""\n"
R"==(if (offset_c + j < n) { \)==""\n"
R"==(_Pragma("unroll") for (int i0 = 0; i0 < br * nbr; i0 += sg) { \)==""\n"
R"==(int i = i0 + get_sub_group_local_id(); \)==""\n"
R"==(if (offset_r + i < m) \)==""\n"
R"==(ptr[i] = tile_access(t, i0, j, sg, br, bc, nbr); \)==""\n"
R"==(} \)==""\n"
R"==(} \)==""\n"
R"==(} \)==""\n"
R"==(} \)==""\n"
R"==(__attribute__((overloadable)) void tile_store(tile_type t, \)==""\n"
R"==(global element_type *ptr, int m, int n, int offset_r, \)==""\n"
R"==(int offset_c) { \)==""\n"
R"==(tile_store(t, ptr, m, n, m, offset_r, offset_c); \)==""\n"
R"==(} \)==""\n"
R"==(__attribute__((overloadable)) void tile_store_t_sys_src1(tile_type t, \)==""\n"
R"==(local element_type *ptr, int ld, int offset_r, int offset_c) { \)==""\n"
R"==(offset_c += get_sub_group_local_id(); \)==""\n"
R"==(int offset_r0 = offset_r & (sg - 1); \)==""\n"
R"==(int offset_r1 = offset_r & ~(sg - 1); \)==""\n"
R"==(ptr += offset_r0 + sg * offset_c + ld * offset_r1; \)==""\n"
R"==(_Pragma("unroll") for (int j0 = 0; j0 < br * nbr; \)==""\n"
R"==(j0 += sg, ptr += sg * sg) { \)==""\n"
R"==(_Pragma("unroll") for (int i = 0; i < bc * nbc; i++) ptr[i] \)==""\n"
R"==(= tile_access(t, j0, i, sg, br, bc, nbr); \)==""\n"
R"==(} \)==""\n"
R"==(} \)==""\n"
R"==(__attribute__((overloadable)) void tile_store_t_sys_src2(tile_type t, \)==""\n"
R"==(local element_type *ptr, int tile_n, int ld, int offset_r, \)==""\n"
R"==(int offset_c) { \)==""\n"
R"==(const int cp = 32 / sizeof(element_type); \)==""\n"
R"==(offset_c += get_sub_group_local_id(); \)==""\n"
R"==(int offset_r0 = offset_r & (cp - 1); \)==""\n"
R"==(int offset_r1 = offset_r & ~(cp - 1); \)==""\n"
R"==(ptr += offset_r0 + tile_n * offset_r1; \)==""\n"
R"==(_Pragma("unroll") for (int j0 = 0; j0 < br * nbr; \)==""\n"
R"==(j0 += sg, offset_c += sg) { \)==""\n"
R"==(int offset_c0 = offset_c & (tile_n - 1); \)==""\n"
R"==(int offset_c1 = offset_c & ~(tile_n - 1); \)==""\n"
R"==(local element_type *ptr_j = ptr + cp * offset_c0 + ld * offset_c1; \)==""\n"
R"==(_Pragma("unroll") for (int i = 0; i < bc * nbc; i++) { \)==""\n"
R"==(*ptr_j = tile_access(t, j0, i, sg, br, bc, nbr); \)==""\n"
R"==(ptr_j++; \)==""\n"
R"==(if ((~i & (cp - 1)) == 0) ptr_j += cp * (tile_n - 1); \)==""\n"
R"==(} \)==""\n"
R"==(} \)==""\n"
R"==(} \)==""\n"
R"==(__attribute__((overloadable)) void tile_atomic_max_full(tile_type t, \)==""\n"
R"==(local element_type *ptr, int ld, int offset_r, int offset_c) { \)==""\n"
R"==(ptr += ld * offset_c + offset_r; \)==""\n"
R"==(_Pragma("unroll") for (int j = 0; j < bc * nbc; j++, ptr += ld) { \)==""\n"
R"==(_Pragma("unroll") for (int i0 = 0; i0 < br * nbr; i0 += sg) { \)==""\n"
R"==(int i = i0 + get_sub_group_local_id(); \)==""\n"
R"==((void)local_atomic_max( \)==""\n"
R"==(ptr + i, tile_access(t, i0, j, sg, br, bc, nbr)); \)==""\n"
R"==(} \)==""\n"
R"==(} \)==""\n"
R"==(})==""\n"
R"==(#define DECLARE_2D_TILE_VREDUCE(tile_type, sg, br, bc, nbr, nbc, rtile_type, \)==""\n"
R"==(rsg, rbr, rbc, rnbr, rnbc) \)==""\n"
R"==(__attribute__((overloadable)) void tile_vreduce_add( \)==""\n"
R"==(tile_type t, rtile_type *tr) { \)==""\n"
R"==(_Pragma("unroll") for (int j = 0; j < bc * nbc; j++) { \)==""\n"
R"==(_Pragma("unroll") for (int i0 = 0; i0 < br * nbr; i0 += sg) { \)==""\n"
R"==(tile_access(*tr, i0, 0, rsg, rbr, rbc, rnbr) \)==""\n"
R"==(+= tile_access(t, i0, j, sg, br, bc, nbr); \)==""\n"
R"==(} \)==""\n"
R"==(} \)==""\n"
R"==(} \)==""\n"
R"==(__attribute__((overloadable)) void tile_vreduce_max( \)==""\n"
R"==(tile_type t, rtile_type *tr) { \)==""\n"
R"==(_Pragma("unroll") for (int j = 0; j < bc * nbc; j++) { \)==""\n"
R"==(_Pragma("unroll") for (int i0 = 0; i0 < br * nbr; i0 += sg) { \)==""\n"
R"==(tile_access(*tr, i0, 0, rsg, rbr, rbc, rnbr) \)==""\n"
R"==(= max(tile_access(t, i0, j, sg, br, bc, nbr), \)==""\n"
R"==(tile_access(*tr, i0, 0, rsg, rbr, rbc, rnbr)); \)==""\n"
R"==(} \)==""\n"
R"==(} \)==""\n"
R"==(} \)==""\n"
R"==(__attribute__((overloadable)) void tile_vbroadcast_sub( \)==""\n"
R"==(tile_type *t, rtile_type tr) { \)==""\n"
R"==(_Pragma("unroll") for (int j = 0; j < bc * nbc; j++) { \)==""\n"
R"==(_Pragma("unroll") for (int i0 = 0; i0 < br * nbr; i0 += sg) { \)==""\n"
R"==(tile_access(*t, i0, j, sg, br, bc, nbr) \)==""\n"
R"==(-= tile_access(tr, i0, 0, rsg, rbr, rbc, rnbr); \)==""\n"
R"==(} \)==""\n"
R"==(} \)==""\n"
R"==(} \)==""\n"
R"==(__attribute__((overloadable)) void tile_vbroadcast_mul( \)==""\n"
R"==(tile_type *t, rtile_type tr) { \)==""\n"
R"==(_Pragma("unroll") for (int j = 0; j < bc * nbc; j++) { \)==""\n"
R"==(_Pragma("unroll") for (int i0 = 0; i0 < br * nbr; i0 += sg) { \)==""\n"
R"==(tile_access(*t, i0, j, sg, br, bc, nbr) \)==""\n"
R"==(*= tile_access(tr, i0, 0, rsg, rbr, rbc, rnbr); \)==""\n"
R"==(} \)==""\n"
R"==(} \)==""\n"
R"==(})==""\n"
R"==(#define DECLARE_2D_TILE_HREDUCE(tile_type, sg, br, bc, nbr, nbc, rtile_type, \)==""\n"
R"==(rsg, rbr, rbc, rnbr, rnbc) \)==""\n"
R"==(__attribute__((overloadable)) void tile_hbroadcast_add( \)==""\n"
R"==(tile_type *t, rtile_type tr) { \)==""\n"
R"==(_Pragma("unroll") for (int j = 0; j < bc * nbc; j++) { \)==""\n"
R"==(_Pragma("unroll") for (int i0 = 0; i0 < br * nbr; i0 += sg) { \)==""\n"
R"==(tile_access(*t, i0, j, sg, br, bc, nbr) \)==""\n"
R"==(+= xlane_tile_access(tr, j, 0, rsg, rbr, rbc, rnbr); \)==""\n"
R"==(} \)==""\n"
R"==(} \)==""\n"
R"==(} \)==""\n"
R"==(__attribute__((overloadable)) void tile_hbroadcast_mul( \)==""\n"
R"==(tile_type *t, rtile_type tr) { \)==""\n"
R"==(_Pragma("unroll") for (int j = 0; j < bc * nbc; j++) { \)==""\n"
R"==(_Pragma("unroll") for (int i0 = 0; i0 < br * nbr; i0 += sg) { \)==""\n"
R"==(tile_access(*t, i0, j, sg, br, bc, nbr) \)==""\n"
R"==(*= xlane_tile_access(tr, j, 0, rsg, rbr, rbc, rnbr); \)==""\n"
R"==(} \)==""\n"
R"==(} \)==""\n"
R"==(} \)==""\n"
R"==(__attribute__((overloadable)) void tile_hbroadcast_min( \)==""\n"
R"==(tile_type *t, rtile_type tr) { \)==""\n"
R"==(_Pragma("unroll") for (int j = 0; j < bc * nbc; j++) { \)==""\n"
R"==(_Pragma("unroll") for (int i0 = 0; i0 < br * nbr; i0 += sg) { \)==""\n"
R"==(tile_access(*t, i0, j, sg, br, bc, nbr) = min( \)==""\n"
R"==(tile_access(*t, i0, j, sg, br, bc, nbr), \)==""\n"
R"==(xlane_tile_access(tr, j, 0, rsg, rbr, rbc, rnbr)); \)==""\n"
R"==(} \)==""\n"
R"==(} \)==""\n"
R"==(})==""\n"
R"==(#define DECLARE_2D_TILE_RSELECT(tile_type0, sg0, br0, bc0, nbr0, nbc0, \)==""\n"
R"==(tile_type1, sg1, br1, bc1, nbr1, nbc1) \)==""\n"
R"==(__attribute__((overloadable)) void tile_rselect( \)==""\n"
R"==(tile_type0 *t0, tile_type1 t1, int idx) { \)==""\n"
R"==(_Pragma("unroll") for (int j = 0; j < bc0 * nbc0; j++) { \)==""\n"
R"==(_Pragma("unroll") for (int i0 = 0; i0 < br0 * nbr0; i0 += sg0) { \)==""\n"
R"==(tile_access(*t0, i0, j, sg0, br0, bc0, nbr0) \)==""\n"
R"==(= tile_access(t1, i0, j, sg1, br1, bc1, nbr1); \)==""\n"
R"==(_Pragma("unroll") for (int z = 1; \)==""\n"
R"==(z < (br1 * nbr1 / br0 * nbr0); \)==""\n"
R"==(z++) if (z == idx) { \)==""\n"
R"==(tile_access(*t0, i0, j, sg0, br0, bc0, nbr0) \)==""\n"
R"==(= tile_access(t1, i0 + z * br0 * nbr0, j, sg1, \)==""\n"
R"==(br1, bc1, nbr1); \)==""\n"
R"==(} \)==""\n"
R"==(} \)==""\n"
R"==(} \)==""\n"
R"==(})==""\n"
R"==(#define DECLARE_2D_TILE_COPY_REBLOCK(tile_type0, sg0, br0, bc0, nbr0, nbc0, \)==""\n"
R"==(tile_type1, sg1, br1, bc1, nbr1, nbc1) \)==""\n"
R"==(__attribute__((overloadable)) void tile_copy_reblock( \)==""\n"
R"==(tile_type0 t0, tile_type1 *t1) { \)==""\n"
R"==(_Pragma("unroll") for (int j = 0; j < bc0 * nbc0; j++) { \)==""\n"
R"==(_Pragma("unroll") for (int i0 = 0; i0 < br0 * nbr0; i0 += sg0) { \)==""\n"
R"==(tile_access(*t1, i0, j, sg1, br1, bc1, nbr1) \)==""\n"
R"==(= tile_access(t0, i0, j, sg0, br0, bc0, nbr0); \)==""\n"
R"==(} \)==""\n"
R"==(} \)==""\n"
R"==(})==""\n"
R"==(#define DECLARE_2D_TILE(tile_type, element_type, sg, br, bc, nbr, nbc) \)==""\n"
R"==(typedef element_type __attribute__((ext_vector_type(br * bc / sg))) \)==""\n"
R"==(_e_##tile_type; \)==""\n"
R"==(typedef struct { \)==""\n"
R"==(_e_##tile_type x[nbr * nbc]; \)==""\n"
R"==(} tile_type; \)==""\n"
R"==(DECLARE_2D_TILE_OPS(tile_type, element_type, sg, br, bc, nbr, nbc))==""\n"
R"==(/* Requires bc == 1 currently */)==""\n"
R"==(#define DECLARE_2D_TILE_BLOCK_OPS( \)==""\n"
R"==(tile_type, element_type, sg, br, bc, nbr, nbc) \)==""\n"
R"==(__attribute__((overloadable)) void tile_load_block(tile_type *t, \)==""\n"
R"==(const global element_type *ptr, int ld, int offset_r, \)==""\n"
R"==(int offset_c) { \)==""\n"
R"==(ptr += ld * offset_c + offset_r; \)==""\n"
R"==(_Pragma("unroll") for (int jj = 0; jj < nbc; jj++, ptr += ld * bc) { \)==""\n"
R"==(_Pragma("unroll") for (int ii = 0; ii < nbr; ii++)(t) \)==""\n"
R"==(->x[ii + nbr * jj] \)==""\n"
R"==(= block_load(ptr + ii * br, br / SUBGROUP_SIZE); \)==""\n"
R"==(} \)==""\n"
R"==(} \)==""\n"
R"==(__attribute__((overloadable)) void tile_store_block(tile_type t, \)==""\n"
R"==(global element_type *ptr, int ld, int offset_r, int offset_c) { \)==""\n"
R"==(ptr += ld * offset_c + offset_r; \)==""\n"
R"==(_Pragma("unroll") for (int jj = 0; jj < nbc; jj++, ptr += ld * bc) { \)==""\n"
R"==(_Pragma("unroll") for (int ii = 0; ii < nbr; ii++) \)==""\n"
R"==(block_store(ptr + ii * br, (t).x[ii + nbr * jj]); \)==""\n"
R"==(} \)==""\n"
R"==(} \)==""\n"
R"==(__attribute__((overloadable)) void tile_load_block(tile_type *t, \)==""\n"
R"==(const global element_type *ptr, int n, int ld, int offset_r, \)==""\n"
R"==(int offset_c) { \)==""\n"
R"==(ptr += ld * offset_c + offset_r; \)==""\n"
R"==(n -= offset_c; \)==""\n"
R"==(_Pragma("unroll") for (int jj = 0; jj < nbc; jj++, ptr += ld * bc) { \)==""\n"
R"==(if (jj < n) { \)==""\n"
R"==(_Pragma("unroll") for (int ii = 0; ii < nbr; ii++)(t) \)==""\n"
R"==(->x[ii + nbr * jj] \)==""\n"
R"==(= block_load(ptr + ii * br, br / SUBGROUP_SIZE); \)==""\n"
R"==(} \)==""\n"
R"==(} \)==""\n"
R"==(} \)==""\n"
R"==(__attribute__((overloadable)) void tile_store_block(tile_type t, \)==""\n"
R"==(global element_type *ptr, int n, int ld, int offset_r, \)==""\n"
R"==(int offset_c) { \)==""\n"
R"==(ptr += ld * offset_c + offset_r; \)==""\n"
R"==(n -= offset_c; \)==""\n"
R"==(_Pragma("unroll") for (int jj = 0; jj < nbc; jj++, ptr += ld * bc) { \)==""\n"
R"==(if (jj < n) { \)==""\n"
R"==(_Pragma("unroll") for (int ii = 0; ii < nbr; ii++) \)==""\n"
R"==(block_store(ptr + ii * br, (t).x[ii + nbr * jj]); \)==""\n"
R"==(} \)==""\n"
R"==(} \)==""\n"
R"==(})==""\n"
R"==(#define DECLARE_2D_TILE_BLOCK2D_OPS( \)==""\n"
R"==(tile_type, element_type, sg, br, bc, nbr, nbc) \)==""\n"
R"==(__attribute__((overloadable)) void tile_load_block2d(tile_type *t, \)==""\n"
R"==(const global element_type *ptr, int m, int n, int ld, \)==""\n"
R"==(int offset_r, int offset_c) { \)==""\n"
R"==(const int e = sizeof(element_type); \)==""\n"
R"==(_Pragma("unroll") for (int jj = 0; jj < nbc; jj++) { \)==""\n"
R"==(_Pragma("unroll") for (int ii = 0; ii < nbr; ii++)(t) \)==""\n"
R"==(->x[ii + nbr * jj] \)==""\n"
R"==(= block2d_load(ptr, m * e, n, ld * e, offset_r + ii * br, \)==""\n"
R"==(offset_c + jj * bc, br, bc, sg); \)==""\n"
R"==(} \)==""\n"
R"==(} \)==""\n"
R"==(__attribute__((overloadable)) void tile_load_block2d(tile_type *t, \)==""\n"
R"==(const global element_type *ptr, int m, int n, int offset_r, \)==""\n"
R"==(int offset_c) { \)==""\n"
R"==(tile_load_block2d(t, ptr, m, n, m, offset_r, offset_c); \)==""\n"
R"==(} \)==""\n"
R"==(__attribute__((overloadable)) void tile_store_block2d(tile_type t, \)==""\n"
R"==(global element_type *ptr, int m, int n, int ld, int offset_r, \)==""\n"
R"==(int offset_c) { \)==""\n"
R"==(const int e = sizeof(element_type); \)==""\n"
R"==(_Pragma("unroll") for (int jj = 0; jj < nbc; jj++) { \)==""\n"
R"==(_Pragma("unroll") for (int ii = 0; ii < nbr; ii++) block2d_store( \)==""\n"
R"==((t).x[ii + nbr * jj], ptr, m *e, n, ld *e, \)==""\n"
R"==(offset_r + ii * br, offset_c + jj * bc, br, bc, sg); \)==""\n"
R"==(} \)==""\n"
R"==(} \)==""\n"
R"==(__attribute__((overloadable)) void tile_store_block2d(tile_type t, \)==""\n"
R"==(const global element_type *ptr, int m, int n, int offset_r, \)==""\n"
R"==(int offset_c) { \)==""\n"
R"==(tile_store_block2d(t, ptr, m, n, m, offset_r, offset_c); \)==""\n"
R"==(})==""\n"
R"==(#define DECLARE_2D_TILE_LOAD_PACKED_HALF(tile_type, sg, br, bc, nbr, nbc) \)==""\n"
R"==(__attribute__((overloadable)) void tile_load_packed_half(tile_type *t, \)==""\n"
R"==(const global half *ptr, int m, int n, int ld, int offset_r, \)==""\n"
R"==(int offset_c) { \)==""\n"
R"==(ptr += ld * offset_c + offset_r; \)==""\n"
R"==(_Pragma("unroll") for (int j = 0; j < bc * nbc; j++, ptr += ld) { \)==""\n"
R"==(if (offset_c + j < n) { \)==""\n"
R"==(_Pragma("unroll") for (int i0 = 0; i0 < br * nbr; i0 += sg) { \)==""\n"
R"==(int i = 2 * (i0 + get_sub_group_local_id()); \)==""\n"
R"==(half2 loaded = 0; \)==""\n"
R"==(if (offset_r + i < m) loaded.s0 = ptr[i]; \)==""\n"
R"==(if (offset_r + i + 1 < m) loaded.s1 = ptr[i + 1]; \)==""\n"
R"==(tile_access(*t, i0, j, sg, br, bc, nbr) = as_uint(loaded); \)==""\n"
R"==(} \)==""\n"
R"==(} \)==""\n"
R"==(} \)==""\n"
R"==(} \)==""\n"
R"==(__attribute__((overloadable)) void tile_load_packed_half(tile_type *t, \)==""\n"
R"==(const global half *ptr, int m, int n, int offset_r, \)==""\n"
R"==(int offset_c) { \)==""\n"
R"==(tile_load_packed_half(t, ptr, m, n, m, offset_r, offset_c); \)==""\n"
R"==(})==""\n"
R"==(#define cooperative_prefetch_2d(ptr, r, c, ld, sg_id, n_sg, sg_size, caching) \)==""\n"
R"==(cooperative_prefetch_2d_internal((const global char *)ptr, \)==""\n"
R"==((r) * sizeof(*(ptr)), c, (ld) * sizeof(*(ptr)), sg_id, n_sg, \)==""\n"
R"==(sg_size, caching))==""\n"
R"==(#define cooperative_prefetch_2d_rem( \)==""\n"
R"==(ptr, r, c, rmax, cmax, ld, sg_id, n_sg, sg_size, caching) \)==""\n"
R"==(cooperative_prefetch_2d_internal((const global char *)ptr, \)==""\n"
R"==((r) * sizeof(*(ptr)), c, (rmax) * sizeof(*(ptr)), cmax, \)==""\n"
R"==((ld) * sizeof(*(ptr)), sg_id, n_sg, sg_size, caching))==""\n"
R"==(/* IGC prefetch intrinsics */)==""\n"
R"==(enum LSC_LDCC {)==""\n"
R"==(LSC_LDCC_DEFAULT = 0,)==""\n"
R"==(LSC_LDCC_L1UC_L3UC = 1,)==""\n"
R"==(LSC_LDCC_L1UC_L3C = 2,)==""\n"
R"==(LSC_LDCC_L1C_L3UC = 3,)==""\n"
R"==(LSC_LDCC_L1C_L3C = 4,)==""\n"
R"==(LSC_LDCC_L1S_L3UC = 5,)==""\n"
R"==(LSC_LDCC_L1S_L3C = 6,)==""\n"
R"==(LSC_LDCC_L1IAR_L3C = 7,)==""\n"
R"==(};)==""\n"
R"==(extern void __builtin_IB_lsc_prefetch_global_uchar()==""\n"
R"==(const __global uchar *base, int immElemOff, enum LSC_LDCC cacheOpt);)==""\n"
R"==(extern void __builtin_IB_lsc_prefetch_global_uint()==""\n"
R"==(const __global uint *base, int immElemOff, enum LSC_LDCC cacheOpt);)==""\n"
R"==(__attribute__((overloadable)) void cooperative_prefetch_2d_internal()==""\n"
R"==(const global char *ptr, uint rbytes, uint c, uint ld_bytes, uint sg_id,)==""\n"
R"==(uint n_sg, uint sg_size, enum LSC_LDCC caching) {)==""\n"
R"==(const uint cl_per_col = (rbytes + 63) >> 6;)==""\n"
R"==(const uint cl = cl_per_col * c;)==""\n"
R"==(const uint cl_per_sg = (cl + n_sg - 1) / n_sg;)==""\n"
R"==(const uint cl_iters = (cl_per_sg + sg_size - 1) / sg_size;)==""\n"
R"==(#pragma unroll)==""\n"
R"==(for (uint ii_cl = 0; ii_cl < cl_iters; ii_cl++) {)==""\n"
R"==(uint i_cl = ii_cl + (sg_id * cl_per_sg) + get_sub_group_local_id();)==""\n"
R"==(uint r_cl = i_cl % cl_per_col;)==""\n"
R"==(uint c_cl = i_cl / cl_per_col;)==""\n"
R"==(if (i_cl < cl) {)==""\n"
R"==(__builtin_IB_lsc_prefetch_global_uint()==""\n"
R"==((const global uint *)(ptr + r_cl * 64 + c_cl * ld_bytes), 0,)==""\n"
R"==(caching);)==""\n"
R"==(})==""\n"
R"==(})==""\n"
R"==(})==""\n"
R"==(__attribute__((overloadable)) void cooperative_prefetch_2d_internal()==""\n"
R"==(const global char *ptr, uint rbytes, uint c, uint rbytes_max,)==""\n"
R"==(uint c_max, uint ld_bytes, uint sg_id, uint n_sg, uint sg_size,)==""\n"
R"==(enum LSC_LDCC caching) {)==""\n"
R"==(const uint cl_per_col = (rbytes_max + 63) >> 6;)==""\n"
R"==(const uint cl = cl_per_col * c_max;)==""\n"
R"==(const uint cl_per_sg = (cl + n_sg - 1) / n_sg;)==""\n"
R"==(const uint cl_iters = (cl_per_sg + sg_size - 1) / sg_size;)==""\n"
R"==(const uint max_off = rbytes - 1 + (c - 1) * ld_bytes;)==""\n"
R"==(#pragma unroll)==""\n"
R"==(for (uint ii_cl = 0; ii_cl < cl_iters; ii_cl++) {)==""\n"
R"==(uint i_cl = ii_cl + (sg_id * cl_per_sg) + get_sub_group_local_id();)==""\n"
R"==(uint r_cl = i_cl % cl_per_col;)==""\n"
R"==(uint c_cl = i_cl / cl_per_col;)==""\n"
R"==(uint pf_off = min(r_cl * 64 + c_cl * ld_bytes, max_off);)==""\n"
R"==(if (i_cl < cl) {)==""\n"
R"==(__builtin_IB_lsc_prefetch_global_uchar()==""\n"
R"==((const global uchar *)(ptr + pf_off), 0, caching);)==""\n"
R"==(})==""\n"
R"==(})==""\n"
R"==(})==""\n"
R"==(#endif)==""\n"
R"==()==";
}
}
}
}
}