namespace dnnl {
namespace impl {
namespace gpu {
namespace intel {
namespace ocl {
const char *types_interop_header = R"==(/*******************************************************************************)==""\n"
R"==(* Copyright 2020-2024 Intel Corporation)==""\n"
R"==(*)==""\n"
R"==(* Licensed under the Apache License, Version 2.0 (the "License");)==""\n"
R"==(* you may not use this file except in compliance with the License.)==""\n"
R"==(* You may obtain a copy of the License at)==""\n"
R"==(*)==""\n"
R"==(* http:)==""\n"
R"==(*)==""\n"
R"==(* Unless required by applicable law or agreed to in writing, software)==""\n"
R"==(* distributed under the License is distributed on an "AS IS" BASIS,)==""\n"
R"==(* WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.)==""\n"
R"==(* See the License for the specific language governing permissions and)==""\n"
R"==(* limitations under the License.)==""\n"
R"==(*******************************************************************************/)==""\n"
R"==(#ifndef GPU_INTEL_OCL_TYPES_INTEROP_H)==""\n"
R"==(#define GPU_INTEL_OCL_TYPES_INTEROP_H)==""\n"
R"==(#ifdef __OPENCL_VERSION__)==""\n"
R"==(typedef uchar uint8_t;)==""\n"
R"==(typedef long int64_t;)==""\n"
R"==(#endif)==""\n"
R"==(typedef struct {)==""\n"
R"==(int64_t array[2];)==""\n"
R"==(} int64x2_t;)==""\n"
R"==(typedef struct {)==""\n"
R"==(int64_t array[3];)==""\n"
R"==(} int64x3_t;)==""\n"
R"==(typedef struct {)==""\n"
R"==(int64_t array[4];)==""\n"
R"==(} int64x4_t;)==""\n"
R"==(typedef struct {)==""\n"
R"==(int64_t array[5];)==""\n"
R"==(} int64x5_t;)==""\n"
R"==(typedef struct {)==""\n"
R"==(int64_t array[6];)==""\n"
R"==(} int64x6_t;)==""\n"
R"==(#define MAX_INDEXING_TERMS 10)==""\n"
R"==(typedef struct {)==""\n"
R"==(int64_t sizes[MAX_INDEXING_TERMS];)==""\n"
R"==(int64_t strides[MAX_INDEXING_TERMS];)==""\n"
R"==(int64_t blocks[MAX_INDEXING_TERMS];)==""\n"
R"==(} dispatch_gws_rt_params_t;)==""\n"
R"==(#define ZERO_PAD_MASK_DATA_TYPE uint8_t)==""\n"
R"==(#define ZERO_PAD_MASK_DT_BITS (8 * sizeof(ZERO_PAD_MASK_DATA_TYPE)))==""\n"
R"==(#define ZERO_PAD_MAX_STEP_SIZE 1536)==""\n"
R"==(#define ZERO_PAD_MASK_SIZE (ZERO_PAD_MAX_STEP_SIZE / ZERO_PAD_MASK_DT_BITS))==""\n"
R"==(#define ZERO_PAD_BIT_MODE 0)==""\n"
R"==(#define ZERO_PAD_LOOKUP_MODE 1)==""\n"
R"==(typedef struct {)==""\n"
R"==(ZERO_PAD_MASK_DATA_TYPE mask[ZERO_PAD_MASK_SIZE];)==""\n"
R"==(} zero_pad_mask_t;)==""\n"
R"==(#endif)==""\n"
R"==()==";
}
}
}
}
}